' original monk.3ds file created by Dan White
'
Imports System
Imports System.IO

Public Class CBlueMonk

  Public Class TEST_XYZ_UV
    Public x As Single
    Public y As Single
    Public z As Single
    Public u As Single
    Public v As Single

    Public Sub New(ByVal x As Single, ByVal y As Single, ByVal z As Single, _
                   ByVal u As Single, ByVal v As Single)
      Me.x = x
      Me.y = y
      Me.z = z
      Me.u = u
      Me.v = v
    End Sub
  End Class

  Public Class TEST_NORMAL
    Public x As Single
    Public y As Single
    Public z As Single

    Public Sub New(ByVal x As Single, ByVal y As Single, ByVal z As Single)
      Me.x = x
      Me.y = y
      Me.z = z
    End Sub
  End Class

  Public Class TEST_TRIANGLE3
    Public xyz_uvIndex(2) As Int32
    Public normalIndex(2) As Int32

    Public Sub New(ByVal p0 As Int32, ByVal p1 As Int32, ByVal p2 As Int32, _
                   ByVal n0 As Int32, ByVal n1 As Int32, ByVal n2 As Int32)
      Me.xyz_uvIndex(0) = p0
      Me.xyz_uvIndex(1) = p1
      Me.xyz_uvIndex(2) = p2
      Me.normalIndex(0) = n0
      Me.normalIndex(1) = n1
      Me.normalIndex(2) = n2
    End Sub
  End Class

  Public Class TEST_RGB
    Public red As Single
    Public green As Single
    Public blue As Single

    Public Sub New(ByVal red As Single, ByVal green As Single, ByVal blue As Single)
      Me.red = red
      Me.green = green
      Me.blue = blue
    End Sub
  End Class

  Public Class TEST_3D_DATA4
    Public name As String
    Public matrix() As Single
    Public xyz_uvCount As Int32
    Public normalCount As Int32
    Public triangleCount As Int32
    Public xyz_uv() As TEST_XYZ_UV
    Public normal() As TEST_NORMAL
    Public triangle() As TEST_TRIANGLE3
    Public uvFlag As Int32
    Public dxfColor As Int32
    Public ambientRGB As TEST_RGB
    Public diffuseRGB As TEST_RGB
    Public specularRGB As TEST_RGB
    Public emissiveRGB As TEST_RGB
    Public texturePathName As String

    Public Sub New(ByVal name As String, ByRef matrix() As Single, ByVal xyz_uvCount As Int32, ByVal normalCount As Int32, _
                   ByVal triangleCount As Int32, ByRef xyz_uv() As TEST_XYZ_UV, ByRef normal() As TEST_NORMAL, _
                   ByRef triangle() As TEST_TRIANGLE3, ByVal uvFlag As Int32, ByVal dxfColor As Int32, _
                   ByVal rgb0 As TEST_RGB, ByVal rgb1 As TEST_RGB, ByVal rgb2 As TEST_RGB, _
                   ByVal rgb3 As TEST_RGB, ByVal texturePathName As String)
      Me.name = name
      Me.matrix = matrix
      Me.xyz_uvCount = xyz_uvCount
      Me.normalCount = normalCount
      Me.triangleCount = triangleCount
      Me.xyz_uv = xyz_uv
      Me.normal = normal
      Me.triangle = triangle
      Me.uvFlag = uvFlag
      Me.dxfColor = dxfColor
      ambientRGB = rgb0
      diffuseRGB = rgb1
      specularRGB = rgb2
      emissiveRGB = rgb3
      Me.texturePathName = texturePathName
    End Sub
  End Class

  Public layerCount As Int32 = 11
  Public matrix_body() As Single = Nothing
  Public xyz_uv_body() As TEST_XYZ_UV = Nothing
  Public normal_body() As TEST_NORMAL = Nothing
  Public triangle3_body() As TEST_TRIANGLE3 = Nothing
  Public matrix_head() As Single = Nothing
  Public xyz_uv_head() As TEST_XYZ_UV = Nothing
  Public normal_head() As TEST_NORMAL = Nothing
  Public triangle3_head() As TEST_TRIANGLE3 = Nothing
  Public matrix_hood() As Single = Nothing
  Public xyz_uv_hood() As TEST_XYZ_UV = Nothing
  Public normal_hood() As TEST_NORMAL = Nothing
  Public triangle3_hood() As TEST_TRIANGLE3 = Nothing
  Public matrix_Rhand() As Single = Nothing
  Public xyz_uv_Rhand() As TEST_XYZ_UV = Nothing
  Public normal_Rhand() As TEST_NORMAL = Nothing
  Public triangle3_Rhand() As TEST_TRIANGLE3 = Nothing
  Public matrix_Lhand() As Single = Nothing
  Public xyz_uv_Lhand() As TEST_XYZ_UV = Nothing
  Public normal_Lhand() As TEST_NORMAL = Nothing
  Public triangle3_Lhand() As TEST_TRIANGLE3 = Nothing
  Public matrix_Llower_arm() As Single = Nothing
  Public xyz_uv_Llower_arm() As TEST_XYZ_UV = Nothing
  Public normal_Llower_arm() As TEST_NORMAL = Nothing
  Public triangle3_Llower_arm() As TEST_TRIANGLE3 = Nothing
  Public matrix_Rlower_arm() As Single = Nothing
  Public xyz_uv_Rlower_arm() As TEST_XYZ_UV = Nothing
  Public normal_Rlower_arm() As TEST_NORMAL = Nothing
  Public triangle3_Rlower_arm() As TEST_TRIANGLE3 = Nothing
  Public matrix_rope_belt() As Single = Nothing
  Public xyz_uv_rope_belt() As TEST_XYZ_UV = Nothing
  Public normal_rope_belt() As TEST_NORMAL = Nothing
  Public triangle3_rope_belt() As TEST_TRIANGLE3 = Nothing
  Public matrix_Lupper_arm() As Single = Nothing
  Public xyz_uv_Lupper_arm() As TEST_XYZ_UV = Nothing
  Public normal_Lupper_arm() As TEST_NORMAL = Nothing
  Public triangle3_Lupper_arm() As TEST_TRIANGLE3 = Nothing
  Public matrix_Rupper_arm() As Single = Nothing
  Public xyz_uv_Rupper_arm() As TEST_XYZ_UV = Nothing
  Public normal_Rupper_arm() As TEST_NORMAL = Nothing
  Public triangle3_Rupper_arm() As TEST_TRIANGLE3 = Nothing
  Public matrix_shawl() As Single = Nothing
  Public xyz_uv_shawl() As TEST_XYZ_UV = Nothing
  Public normal_shawl() As TEST_NORMAL = Nothing
  Public triangle3_shawl() As TEST_TRIANGLE3 = Nothing
  Public data4() As TEST_3D_DATA4 = Nothing

  Public Sub New()

    matrix_body = New Single() { _
      0.553066, 0.0, 0.0, 3.635905, _
      0.0, 0.0, -0.624723, -18.7416687, _
      0.0, 0.999999, 0.0, 95.20727, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_body = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-75.605902, -95.207336, -29.999975, 0.671333, 2.0), _
      New TEST_XYZ_UV(-75.605902, -95.207336, -29.999975, 3.328667, 2.0), _
      New TEST_XYZ_UV(-75.240832, -95.207329, -51.053157, 0.671333, 1.73579), _
      New TEST_XYZ_UV(-75.240832, -95.207329, -51.053157, 3.328667, 1.73579), _
      New TEST_XYZ_UV(-75.240825, -95.207321, -8.946799, 0.671333, 2.26421), _
      New TEST_XYZ_UV(-75.240825, -95.207321, -8.946799, 3.328667, 2.26421), _
      New TEST_XYZ_UV(-74.664924, -60.96703, -29.99999, 1.242839, 2.0), _
      New TEST_XYZ_UV(-72.807563, -83.303283, -29.999985, 0.870023, 2.0), _
      New TEST_XYZ_UV(-72.370125, -59.977928, -50.538268, 1.259348, 1.742252), _
      New TEST_XYZ_UV(-72.370125, -59.977951, -9.461707, 1.259347, 2.257748), _
      New TEST_XYZ_UV(-72.117393, -82.534034, -49.96442, 0.882863, 1.749453), _
      New TEST_XYZ_UV(-72.117393, -82.534035, -10.035553, 0.882863, 2.250546), _
      New TEST_XYZ_UV(-70.341586, -95.207344, -66.348022, 0.671332, 1.543845), _
      New TEST_XYZ_UV(-70.341586, -95.207344, -66.348022, 1.19974, 0.671332), _
      New TEST_XYZ_UV(-70.341586, -95.207344, -66.348022, 2.80026, 0.671332), _
      New TEST_XYZ_UV(-70.341586, -95.207344, -66.348022, 3.328668, 1.543845), _
      New TEST_XYZ_UV(-70.341579, -95.207321, 6.348058, 0.671333, 2.456155), _
      New TEST_XYZ_UV(-70.341579, -95.207321, 6.348058, 1.19974, 0.671333), _
      New TEST_XYZ_UV(-70.341579, -95.207321, 6.348058, 2.80026, 0.671333), _
      New TEST_XYZ_UV(-70.341579, -95.207321, 6.348058, 3.328667, 2.456155), _
      New TEST_XYZ_UV(-68.943816, -31.580324, -29.999994, 1.733333, 2.0), _
      New TEST_XYZ_UV(-67.292872, -81.606598, -64.060967, 0.898343, 1.572547), _
      New TEST_XYZ_UV(-67.292872, -81.606598, -64.060967, 1.238, 0.898343), _
      New TEST_XYZ_UV(-67.292872, -81.606582, 4.060995, 0.898343, 2.427453), _
      New TEST_XYZ_UV(-67.292872, -81.606582, 4.060995, 2.761999, 0.898343), _
      New TEST_XYZ_UV(-65.922347, -32.990885, -9.392978, 1.709789, 2.258611), _
      New TEST_XYZ_UV(-65.922341, -32.990882, -50.607002, 1.709789, 1.741389), _
      New TEST_XYZ_UV(-65.885936, -59.077874, -63.695392, 1.255657, 1.27437), _
      New TEST_XYZ_UV(-65.885936, -59.077874, -63.695392, 1.27437, 1.577134), _
      New TEST_XYZ_UV(-65.885922, -59.077864, 3.695423, 1.274371, 2.422865), _
      New TEST_XYZ_UV(-65.885922, -59.077864, 3.695423, 2.744343, 1.274371), _
      New TEST_XYZ_UV(-58.893098, -34.111619, -62.851387, 1.343415, 1.691083), _
      New TEST_XYZ_UV(-58.893098, -34.111619, -62.851387, 1.691083, 1.587726), _
      New TEST_XYZ_UV(-58.893098, -34.111616, 2.851403, 1.691083, 2.412273), _
      New TEST_XYZ_UV(-58.893098, -34.111616, 2.851403, 2.656585, 1.691083), _
      New TEST_XYZ_UV(-52.080723, -60.967038, -29.999979, 2.757162, 2.0), _
      New TEST_XYZ_UV(-51.91301, -60.967038, -8.520095, 1.431012, 1.242839), _
      New TEST_XYZ_UV(-51.91301, -60.967038, -8.520095, 2.757162, 2.269565), _
      New TEST_XYZ_UV(-51.913003, -60.967038, -51.479866, 2.568988, 1.242838), _
      New TEST_XYZ_UV(-51.913003, -60.967038, -51.479866, 2.757162, 1.730435), _
      New TEST_XYZ_UV(-51.533063, -95.207329, -71.693053, 1.435781, 0.671333), _
      New TEST_XYZ_UV(-51.533063, -95.207329, -71.693053, 2.564219, 0.671333), _
      New TEST_XYZ_UV(-51.533059, -95.207306, 11.693068, 1.435781, 0.671333), _
      New TEST_XYZ_UV(-51.533059, -95.207306, 11.693068, 2.564219, 0.671333), _
      New TEST_XYZ_UV(-50.309358, -81.846795, -69.186348, 1.451138, 0.894334), _
      New TEST_XYZ_UV(-50.309358, -81.846786, 9.186379, 2.548862, 0.894334), _
      New TEST_XYZ_UV(-49.925793, -4.348133, -29.999992, 1.455951, 2.0), _
      New TEST_XYZ_UV(-49.925793, -4.348133, -29.999992, 2.187866, 2.0), _
      New TEST_XYZ_UV(-49.765909, -4.949289, -43.603806, 1.457958, 1.829277), _
      New TEST_XYZ_UV(-49.765909, -4.949289, -43.603806, 2.177832, 1.829277), _
      New TEST_XYZ_UV(-49.765909, -4.949287, -16.396183, 1.457958, 2.170723), _
      New TEST_XYZ_UV(-49.765909, -4.949287, -16.396183, 2.177832, 2.170723), _
      New TEST_XYZ_UV(-49.53293, -59.182411, 8.807288, 2.539119, 1.272626), _
      New TEST_XYZ_UV(-49.532926, -59.182411, -68.807266, 1.460881, 1.272626), _
      New TEST_XYZ_UV(-49.231312, 48.000008, -43.157909, 3.061611, 1.834873), _
      New TEST_XYZ_UV(-49.231312, 64.000016, -43.157909, 3.328667, 1.834873), _
      New TEST_XYZ_UV(-49.231312, 48.000006, -30.000013, 3.061611, 2.0), _
      New TEST_XYZ_UV(-49.231312, 64.000013, -30.000013, 3.328667, 2.0), _
      New TEST_XYZ_UV(-49.231312, 48.000003, -16.842115, 3.061611, 2.165127), _
      New TEST_XYZ_UV(-49.231312, 64.000011, -16.84212, 3.328667, 2.165127), _
      New TEST_XYZ_UV(-46.63872, 30.563308, -42.305084, 2.770574, 1.845575), _
      New TEST_XYZ_UV(-46.63872, 30.563314, -30.00001, 2.770574, 2.0), _
      New TEST_XYZ_UV(-46.63872, 30.563311, -17.694942, 2.770574, 2.154424), _
      New TEST_XYZ_UV(-45.327426, -5.811043, -53.071007, 1.513659, 1.710467), _
      New TEST_XYZ_UV(-45.327426, -5.811043, -53.071007, 1.513659, 2.163449), _
      New TEST_XYZ_UV(-45.327426, -5.811043, -53.071007, 2.163449, 1.710467), _
      New TEST_XYZ_UV(-45.32742, -5.811037, -6.928982, 1.513659, 2.289533), _
      New TEST_XYZ_UV(-45.32742, -5.811037, -6.928982, 2.163449, 2.289533), _
      New TEST_XYZ_UV(-45.32742, -5.811037, -6.928982, 2.486341, 2.163449), _
      New TEST_XYZ_UV(-45.231312, 48.00001, -53.026332, 1.514865, 3.061611), _
      New TEST_XYZ_UV(-45.231312, 48.00001, -53.026332, 3.061611, 1.711028), _
      New TEST_XYZ_UV(-45.231312, 64.000002, -53.026332, 1.514865, 3.328667), _
      New TEST_XYZ_UV(-45.231312, 64.000002, -53.026332, 3.328667, 1.711028), _
      New TEST_XYZ_UV(-45.231312, 48.000017, -6.973693, 2.485135, 3.061611), _
      New TEST_XYZ_UV(-45.231312, 48.000017, -6.973693, 3.061611, 2.288972), _
      New TEST_XYZ_UV(-45.231312, 64.000009, -6.973693, 2.485135, 3.328667), _
      New TEST_XYZ_UV(-45.231312, 64.000009, -6.973693, 3.328667, 2.288972), _
      New TEST_XYZ_UV(-44.955511, -34.209602, -67.223573, 1.518326, 1.689448), _
      New TEST_XYZ_UV(-44.955511, -34.209605, 7.223591, 2.481674, 1.689448), _
      New TEST_XYZ_UV(-42.63872, 30.563318, -51.320672, 1.547401, 2.770574), _
      New TEST_XYZ_UV(-42.63872, 30.563318, -51.320672, 2.770574, 1.732433), _
      New TEST_XYZ_UV(-42.638717, 30.56331, -8.679347, 2.452599, 2.770574), _
      New TEST_XYZ_UV(-42.638717, 30.56331, -8.679347, 2.770574, 2.267566), _
      New TEST_XYZ_UV(-37.972095, 4.000299, -39.755226, 1.605966, 1.877575), _
      New TEST_XYZ_UV(-37.972095, 4.000299, -39.755226, 2.32721, 1.877575), _
      New TEST_XYZ_UV(-37.972095, 4.000296, -20.24477, 1.605966, 2.122425), _
      New TEST_XYZ_UV(-37.972095, 4.000296, -20.24477, 2.32721, 2.122425), _
      New TEST_XYZ_UV(-37.969325, 4.181557, -29.999996, 1.606, 2.0), _
      New TEST_XYZ_UV(-37.969325, 4.181557, -29.999996, 2.330235, 2.0), _
      New TEST_XYZ_UV(-37.429173, 11.034848, -39.589951, 2.444624, 1.879649), _
      New TEST_XYZ_UV(-37.429173, 11.034847, -29.999998, 2.444624, 2.0), _
      New TEST_XYZ_UV(-37.429173, 11.034845, -20.410057, 2.444624, 2.12035), _
      New TEST_XYZ_UV(-34.960041, 11.03485, -46.975304, 1.643766, 2.444624), _
      New TEST_XYZ_UV(-34.960041, 11.03485, -46.975304, 2.444624, 1.786966), _
      New TEST_XYZ_UV(-34.960041, 11.034844, -13.024696, 2.356234, 2.444624), _
      New TEST_XYZ_UV(-34.960041, 11.034844, -13.024696, 2.444624, 2.213034), _
      New TEST_XYZ_UV(-34.917294, 3.635943, -46.668094, 1.644302, 1.790821), _
      New TEST_XYZ_UV(-34.917294, 3.635943, -46.668094, 1.644302, 2.321129), _
      New TEST_XYZ_UV(-34.917294, 3.635943, -46.668094, 2.321129, 1.790821), _
      New TEST_XYZ_UV(-34.917294, 3.635945, -13.331905, 1.644302, 2.209178), _
      New TEST_XYZ_UV(-34.917294, 3.635945, -13.331905, 2.321129, 2.209178), _
      New TEST_XYZ_UV(-34.917294, 3.635945, -13.331905, 2.355698, 2.321129), _
      New TEST_XYZ_UV(-33.843118, -6.213081, -56.361289, 1.657783, 1.669175), _
      New TEST_XYZ_UV(-33.843118, -6.213081, -56.361289, 1.657783, 2.156739), _
      New TEST_XYZ_UV(-33.843112, -6.213084, -3.638685, 1.657783, 2.330825), _
      New TEST_XYZ_UV(-33.843112, -6.213084, -3.638685, 2.342217, 2.156738), _
      New TEST_XYZ_UV(-33.231312, 48.00001, -56.315808, 1.665461, 3.061611), _
      New TEST_XYZ_UV(-33.231312, 64.000018, -56.31581, 1.665461, 3.328667), _
      New TEST_XYZ_UV(-33.231308, 48.000016, -3.68422, 2.334539, 3.061611), _
      New TEST_XYZ_UV(-33.231308, 64.000008, -3.684219, 2.334539, 3.328667), _
      New TEST_XYZ_UV(-31.675755, 30.563318, -54.610154, 1.684982, 2.770574), _
      New TEST_XYZ_UV(-31.675755, 30.563309, -5.38987, 2.315018, 2.770574), _
      New TEST_XYZ_UV(-28.776054, -81.875306, -69.217148, 1.721373, 0.893858), _
      New TEST_XYZ_UV(-28.776054, -81.875297, 9.217164, 2.278627, 0.893858), _
      New TEST_XYZ_UV(-27.808082, -95.207329, -71.710853, 1.733521, 0.671333), _
      New TEST_XYZ_UV(-27.808082, -95.207329, -71.710853, 2.266479, 0.671333), _
      New TEST_XYZ_UV(-27.808082, -95.207298, 11.710886, 1.733521, 0.671333), _
      New TEST_XYZ_UV(-27.808082, -95.207298, 11.710886, 2.266479, 0.671333), _
      New TEST_XYZ_UV(-27.465042, -60.96703, -8.506831, 1.737826, 1.242839), _
      New TEST_XYZ_UV(-27.465041, -60.967022, -51.493122, 2.262174, 1.242839), _
      New TEST_XYZ_UV(-27.191921, 3.257045, -49.286294, 1.741253, 1.757964), _
      New TEST_XYZ_UV(-27.191921, 3.257045, -49.286294, 1.741253, 2.314805), _
      New TEST_XYZ_UV(-27.191921, 3.257045, -10.713707, 1.741253, 2.242036), _
      New TEST_XYZ_UV(-27.191921, 3.257045, -10.713707, 2.258747, 2.314805), _
      New TEST_XYZ_UV(-27.159457, -59.158279, 8.738453, 2.258339, 1.273029), _
      New TEST_XYZ_UV(-27.159452, -59.158287, -68.738419, 1.741661, 1.273028), _
      New TEST_XYZ_UV(-26.697355, 11.034843, -49.179886, 1.74746, 2.444624), _
      New TEST_XYZ_UV(-26.697355, 11.034843, -10.820108, 2.25254, 2.444624), _
      New TEST_XYZ_UV(-24.755375, -34.354687, -66.748536, 1.771831, 1.687026), _
      New TEST_XYZ_UV(-24.755375, -34.354689, 6.748551, 2.228169, 1.687026), _
      New TEST_XYZ_UV(-18.57575, -6.820183, -55.954749, 1.849383, 2.146605), _
      New TEST_XYZ_UV(-18.575747, -6.820178, -4.045234, 2.150617, 2.146605), _
      New TEST_XYZ_UV(-17.23131, 48.00001, -56.315808, 1.866255, 3.061611), _
      New TEST_XYZ_UV(-17.23131, 64.000018, -56.31581, 1.866255, 3.328668), _
      New TEST_XYZ_UV(-17.23131, 48.000016, -3.68422, 2.133745, 3.061611), _
      New TEST_XYZ_UV(-17.23131, 64.000008, -3.684219, 2.133745, 3.328668), _
      New TEST_XYZ_UV(-16.712791, 30.563318, -54.610154, 1.872762, 2.770575), _
      New TEST_XYZ_UV(-16.712791, 30.563309, -5.38987, 2.127238, 2.770575), _
      New TEST_XYZ_UV(-14.887071, 2.554019, -49.074257, 1.895675, 2.303071), _
      New TEST_XYZ_UV(-14.887071, 2.554027, -10.925743, 2.104325, 2.303071), _
      New TEST_XYZ_UV(-14.15881, 11.034843, -49.179886, 1.904814, 2.444624), _
      New TEST_XYZ_UV(-14.15881, 11.034843, -10.820108, 2.095186, 2.444624), _
      New TEST_XYZ_UV(-6.574082, -95.207329, -71.102936, 2.0, 0.671333), _
      New TEST_XYZ_UV(-6.574082, -80.951523, -68.219055, 2.0, 0.909277), _
      New TEST_XYZ_UV(-6.574082, -58.418762, -66.628936, 2.0, 1.285372), _
      New TEST_XYZ_UV(-6.574082, -35.04659, -64.483077, 2.0, 1.675478), _
      New TEST_XYZ_UV(-6.574082, -7.683145, -55.376846, 2.0, 2.132202), _
      New TEST_XYZ_UV(-6.574082, -95.207321, 11.102963, 2.0, 0.671333), _
      New TEST_XYZ_UV(-6.574082, -80.951508, 8.219099, 2.0, 0.909277), _
      New TEST_XYZ_UV(-6.574082, -58.418761, 6.628952, 2.0, 1.285372), _
      New TEST_XYZ_UV(-6.574082, -35.046591, 4.483094, 2.0, 1.675478), _
      New TEST_XYZ_UV(-6.574082, -7.683131, -4.623129, 2.0, 2.132202), _
      New TEST_XYZ_UV(-6.574081, -60.96703, -51.05317, 2.0, 1.242839), _
      New TEST_XYZ_UV(-6.574081, 1.974627, -48.899509, 2.0, 2.2934), _
      New TEST_XYZ_UV(-6.574081, 1.974628, -11.100488, 2.0, 2.2934), _
      New TEST_XYZ_UV(-6.574081, 11.034835, -49.179886, 2.0, 2.444624), _
      New TEST_XYZ_UV(-6.574081, 11.034835, -10.820106, 2.0, 2.444624), _
      New TEST_XYZ_UV(-6.574081, 30.563309, -5.389868, 2.0, 2.770574), _
      New TEST_XYZ_UV(-6.574081, 30.563311, -54.610142, 2.0, 2.770574), _
      New TEST_XYZ_UV(-6.574081, 48.000001, -3.684217, 2.0, 3.061611), _
      New TEST_XYZ_UV(-6.574081, 48.00001, -56.315802, 2.0, 3.061611), _
      New TEST_XYZ_UV(-6.574081, 63.999993, -3.684216, 2.0, 3.328667), _
      New TEST_XYZ_UV(-6.574081, 64.000003, -56.315804, 2.0, 3.328667), _
      New TEST_XYZ_UV(-6.57408, -60.967038, -8.946796, 2.0, 1.242839), _
      New TEST_XYZ_UV(1.010649, 11.034827, -49.179878, 2.095185, 2.444624), _
      New TEST_XYZ_UV(1.010649, 11.034828, -10.820106, 1.904815, 2.444624), _
      New TEST_XYZ_UV(1.738909, 2.554011, -49.074245, 2.104325, 2.303071), _
      New TEST_XYZ_UV(1.738909, 2.554012, -10.92574, 1.895675, 2.303071), _
      New TEST_XYZ_UV(3.56463, 30.563303, -54.610142, 2.127237, 2.770574), _
      New TEST_XYZ_UV(3.56463, 30.563301, -5.389867, 1.872763, 2.770574), _
      New TEST_XYZ_UV(4.083148, 48.00001, -56.315796, 2.133744, 3.061611), _
      New TEST_XYZ_UV(4.083148, 64.000003, -56.315792, 2.133744, 3.328667), _
      New TEST_XYZ_UV(4.083148, 48.000001, -3.684214, 1.866256, 3.061611), _
      New TEST_XYZ_UV(4.083148, 64.000008, -3.684213, 1.866256, 3.328667), _
      New TEST_XYZ_UV(5.427586, -6.820191, -55.95474, 2.150616, 2.146605), _
      New TEST_XYZ_UV(5.427588, -6.820185, -4.045234, 1.849384, 2.146605), _
      New TEST_XYZ_UV(11.607212, -34.354695, -66.748536, 2.228168, 1.687026), _
      New TEST_XYZ_UV(11.607215, -34.354701, 6.748545, 1.771831, 1.687026), _
      New TEST_XYZ_UV(13.549193, 11.034827, -49.179878, 2.25254, 2.444624), _
      New TEST_XYZ_UV(13.549193, 11.034828, -10.820106, 1.74746, 2.444624), _
      New TEST_XYZ_UV(14.011291, -59.158295, -68.738419, 2.258339, 1.273028), _
      New TEST_XYZ_UV(14.011295, -59.158294, 8.738447, 1.741661, 1.273028), _
      New TEST_XYZ_UV(14.043759, 3.25703, -49.286286, 2.258746, 1.757964), _
      New TEST_XYZ_UV(14.043759, 3.25703, -49.286286, 2.258746, 2.314805), _
      New TEST_XYZ_UV(14.043759, 3.257038, -10.713707, 1.741254, 2.314805), _
      New TEST_XYZ_UV(14.043759, 3.257038, -10.713707, 2.258746, 2.242036), _
      New TEST_XYZ_UV(14.316879, -60.96703, -51.493134, 1.737826, 1.242839), _
      New TEST_XYZ_UV(14.316884, -60.967038, -8.506842, 2.262174, 1.242839), _
      New TEST_XYZ_UV(14.65992, -95.207336, -71.710853, 1.733521, 0.671333), _
      New TEST_XYZ_UV(14.65992, -95.207336, -71.710853, 2.266479, 0.671333), _
      New TEST_XYZ_UV(14.659922, -95.207314, 11.710877, 1.733521, 0.671333), _
      New TEST_XYZ_UV(14.659922, -95.207314, 11.710877, 2.266479, 0.671333), _
      New TEST_XYZ_UV(15.62789, -81.875313, -69.217148, 2.278627, 0.893858), _
      New TEST_XYZ_UV(15.627895, -81.875305, 9.217154, 1.721373, 0.893858), _
      New TEST_XYZ_UV(18.527591, 30.563301, -5.389865, 1.684983, 2.770574), _
      New TEST_XYZ_UV(18.527593, 30.563303, -54.610142, 2.315017, 2.770574), _
      New TEST_XYZ_UV(20.083146, 48.000001, -3.684214, 1.665462, 3.061611), _
      New TEST_XYZ_UV(20.083146, 64.000008, -3.68421, 1.665462, 3.328668), _
      New TEST_XYZ_UV(20.083151, 48.00001, -56.315796, 2.334538, 3.061611), _
      New TEST_XYZ_UV(20.083151, 64.000003, -56.315792, 2.334538, 3.328668), _
      New TEST_XYZ_UV(20.694954, -6.213089, -56.361289, 2.342216, 1.669175), _
      New TEST_XYZ_UV(20.694954, -6.213089, -56.361289, 2.342216, 2.156739), _
      New TEST_XYZ_UV(20.694955, -6.213091, -3.638685, 1.657784, 2.156738), _
      New TEST_XYZ_UV(20.694955, -6.213091, -3.638685, 2.342216, 2.330825), _
      New TEST_XYZ_UV(21.76913, 3.635936, -46.668091, 1.678871, 1.790821), _
      New TEST_XYZ_UV(21.76913, 3.635936, -46.668091, 2.355697, 1.790821), _
      New TEST_XYZ_UV(21.76913, 3.635936, -46.668091, 2.355697, 2.321129), _
      New TEST_XYZ_UV(21.76913, 3.635937, -13.331904, 1.644303, 2.321129), _
      New TEST_XYZ_UV(21.76913, 3.635937, -13.331904, 1.678871, 2.209178), _
      New TEST_XYZ_UV(21.76913, 3.635937, -13.331904, 2.355697, 2.209178), _
      New TEST_XYZ_UV(21.81188, 11.034835, -46.975296, 1.555376, 1.786966), _
      New TEST_XYZ_UV(21.81188, 11.034835, -46.975296, 2.356234, 2.444624), _
      New TEST_XYZ_UV(21.81188, 11.034828, -13.024693, 1.555376, 2.213034), _
      New TEST_XYZ_UV(21.81188, 11.034828, -13.024693, 1.643767, 2.444624), _
      New TEST_XYZ_UV(24.281012, 11.034833, -39.589939, 1.555376, 1.879649), _
      New TEST_XYZ_UV(24.281012, 11.034831, -29.999994, 1.555376, 2.0), _
      New TEST_XYZ_UV(24.281012, 11.03483, -20.410052, 1.555376, 2.12035), _
      New TEST_XYZ_UV(24.821161, 4.181549, -29.999994, 1.669764, 2.0), _
      New TEST_XYZ_UV(24.821161, 4.181549, -29.999994, 2.393999, 2.0), _
      New TEST_XYZ_UV(24.823931, 4.000292, -39.755226, 1.67279, 1.877575), _
      New TEST_XYZ_UV(24.823931, 4.000292, -39.755226, 2.394034, 1.877575), _
      New TEST_XYZ_UV(24.823934, 4.000288, -20.244768, 1.67279, 2.122425), _
      New TEST_XYZ_UV(24.823934, 4.000288, -20.244768, 2.394034, 2.122425), _
      New TEST_XYZ_UV(29.490557, 30.563302, -8.679343, 1.229426, 2.267567), _
      New TEST_XYZ_UV(29.490557, 30.563302, -8.679343, 1.547402, 2.770574), _
      New TEST_XYZ_UV(29.49056, 30.56331, -51.320667, 1.229426, 1.732433), _
      New TEST_XYZ_UV(29.49056, 30.56331, -51.320667, 2.452598, 2.770575), _
      New TEST_XYZ_UV(31.80734, -34.20961, -67.223573, 2.481673, 1.689448), _
      New TEST_XYZ_UV(31.807344, -34.209612, 7.223585, 1.518327, 1.689448), _
      New TEST_XYZ_UV(32.083148, 48.00001, -53.026317, 0.938389, 1.711028), _
      New TEST_XYZ_UV(32.083148, 48.00001, -53.026317, 2.485134, 3.061611), _
      New TEST_XYZ_UV(32.083148, 64.000002, -53.026322, 0.671333, 1.711028), _
      New TEST_XYZ_UV(32.083148, 64.000002, -53.026322, 2.485134, 3.328667), _
      New TEST_XYZ_UV(32.083148, 48.000001, -6.973686, 0.938389, 2.288972), _
      New TEST_XYZ_UV(32.083148, 48.000001, -6.973686, 1.514866, 3.061611), _
      New TEST_XYZ_UV(32.083148, 63.999994, -6.973686, 0.671333, 2.288972), _
      New TEST_XYZ_UV(32.083148, 63.999994, -6.973686, 1.514866, 3.328667), _
      New TEST_XYZ_UV(32.179259, -5.811052, -6.928982, 1.513659, 2.163449), _
      New TEST_XYZ_UV(32.179259, -5.811052, -6.928982, 1.836551, 2.289533), _
      New TEST_XYZ_UV(32.179259, -5.811052, -6.928982, 2.486341, 2.289533), _
      New TEST_XYZ_UV(32.179263, -5.811051, -53.071002, 1.836551, 1.710467), _
      New TEST_XYZ_UV(32.179263, -5.811051, -53.071002, 2.486341, 1.710467), _
      New TEST_XYZ_UV(32.179263, -5.811051, -53.071002, 2.486341, 2.163449), _
      New TEST_XYZ_UV(33.490567, 30.563301, -42.305081, 1.229426, 1.845575), _
      New TEST_XYZ_UV(33.490567, 30.563306, -30.000004, 1.229426, 2.0), _
      New TEST_XYZ_UV(33.490567, 30.563304, -17.694935, 1.229426, 2.154424), _
      New TEST_XYZ_UV(36.083148, 48.000008, -43.157898, 0.938389, 1.834873), _
      New TEST_XYZ_UV(36.083148, 64.0, -43.157898, 0.671333, 1.834873), _
      New TEST_XYZ_UV(36.083148, 48.000006, -30.000004, 0.938389, 2.0), _
      New TEST_XYZ_UV(36.083148, 63.999998, -30.000004, 0.671333, 2.0), _
      New TEST_XYZ_UV(36.083148, 48.000003, -16.842107, 0.938389, 2.165127), _
      New TEST_XYZ_UV(36.083148, 63.999996, -16.842107, 0.671333, 2.165127), _
      New TEST_XYZ_UV(36.384756, -59.182411, -68.807266, 2.539118, 1.272626), _
      New TEST_XYZ_UV(36.384762, -59.182418, 8.807285, 1.460882, 1.272626), _
      New TEST_XYZ_UV(36.617741, -4.949294, -16.396183, 1.822167, 2.170723), _
      New TEST_XYZ_UV(36.617741, -4.949294, -16.396183, 2.542042, 2.170723), _
      New TEST_XYZ_UV(36.617745, -4.949297, -43.603801, 1.822167, 1.829277), _
      New TEST_XYZ_UV(36.617745, -4.949297, -43.603801, 2.542042, 1.829277), _
      New TEST_XYZ_UV(36.777625, -4.348141, -29.999989, 1.812133, 2.0), _
      New TEST_XYZ_UV(36.777625, -4.348141, -29.999989, 2.544048, 2.0), _
      New TEST_XYZ_UV(37.161191, -81.846802, -69.186348, 2.548862, 0.894334), _
      New TEST_XYZ_UV(37.161191, -81.846801, 9.18637, 1.451138, 0.894334), _
      New TEST_XYZ_UV(38.384899, -95.207321, 11.693056, 1.435781, 0.671333), _
      New TEST_XYZ_UV(38.384899, -95.207321, 11.693056, 2.564219, 0.671333), _
      New TEST_XYZ_UV(38.384902, -95.207329, -71.693053, 1.435781, 0.671333), _
      New TEST_XYZ_UV(38.384902, -95.207329, -71.693053, 2.564219, 0.671333), _
      New TEST_XYZ_UV(38.764843, -60.967038, -51.479867, 1.242839, 1.730435), _
      New TEST_XYZ_UV(38.764843, -60.967038, -51.479867, 1.431013, 1.242839), _
      New TEST_XYZ_UV(38.764846, -60.967038, -8.520107, 1.242839, 2.269565), _
      New TEST_XYZ_UV(38.764846, -60.967038, -8.520107, 2.568988, 1.242839), _
      New TEST_XYZ_UV(38.932562, -60.967045, -29.999985, 1.242839, 2.0), _
      New TEST_XYZ_UV(45.744931, -34.111626, -62.851378, 2.308917, 1.587727), _
      New TEST_XYZ_UV(45.744931, -34.111626, -62.851378, 2.656585, 1.691083), _
      New TEST_XYZ_UV(45.744935, -34.111623, 2.851396, 1.343415, 1.691083), _
      New TEST_XYZ_UV(45.744935, -34.111623, 2.851396, 2.308917, 2.412273), _
      New TEST_XYZ_UV(52.737759, -59.077882, -63.695392, 2.725629, 1.577134), _
      New TEST_XYZ_UV(52.737759, -59.077882, -63.695392, 2.744343, 1.274371), _
      New TEST_XYZ_UV(52.737766, -59.077872, 3.695417, 1.255657, 1.274371), _
      New TEST_XYZ_UV(52.737766, -59.077872, 3.695417, 2.725629, 2.422865), _
      New TEST_XYZ_UV(52.774177, -32.990897, -9.392983, 2.290211, 2.258611), _
      New TEST_XYZ_UV(52.774184, -32.990885, -50.607003, 2.29021, 1.741389), _
      New TEST_XYZ_UV(54.144709, -81.606606, -64.060967, 2.761999, 0.898343), _
      New TEST_XYZ_UV(54.144709, -81.606606, -64.060967, 3.101657, 1.572547), _
      New TEST_XYZ_UV(54.144716, -81.60659, 4.060985, 1.238001, 0.898343), _
      New TEST_XYZ_UV(54.144716, -81.60659, 4.060985, 3.101656, 2.427453), _
      New TEST_XYZ_UV(55.795652, -31.580336, -29.999996, 2.266667, 2.0), _
      New TEST_XYZ_UV(57.193422, -95.207352, -66.348031, 0.671333, 1.543845), _
      New TEST_XYZ_UV(57.193422, -95.207352, -66.348031, 1.19974, 0.671333), _
      New TEST_XYZ_UV(57.193422, -95.207352, -66.348031, 2.80026, 0.671333), _
      New TEST_XYZ_UV(57.193422, -95.207352, -66.348031, 3.328667, 1.543845), _
      New TEST_XYZ_UV(57.193429, -95.207336, 6.348049, 0.671333, 2.456155), _
      New TEST_XYZ_UV(57.193429, -95.207336, 6.348049, 1.19974, 0.671333), _
      New TEST_XYZ_UV(57.193429, -95.207336, 6.348049, 2.80026, 0.671333), _
      New TEST_XYZ_UV(57.193429, -95.207336, 6.348049, 3.328667, 2.456155), _
      New TEST_XYZ_UV(58.969229, -82.534042, -49.964427, 3.117136, 1.749453), _
      New TEST_XYZ_UV(58.969236, -82.534043, -10.035558, 3.117136, 2.250546), _
      New TEST_XYZ_UV(59.221955, -59.977936, -50.538269, 2.740652, 1.742252), _
      New TEST_XYZ_UV(59.221955, -59.977959, -9.461715, 2.740653, 2.257748), _
      New TEST_XYZ_UV(59.659406, -83.303291, -29.999992, 3.129976, 2.0), _
      New TEST_XYZ_UV(61.516767, -60.967038, -29.999996, 2.757161, 2.0), _
      New TEST_XYZ_UV(62.092668, -95.207336, -51.053165, 0.671333, 1.73579), _
      New TEST_XYZ_UV(62.092668, -95.207336, -51.053165, 3.328667, 1.73579), _
      New TEST_XYZ_UV(62.092668, -95.207329, -8.946811, 0.671333, 2.26421), _
      New TEST_XYZ_UV(62.092668, -95.207329, -8.946811, 3.328667, 2.26421), _
      New TEST_XYZ_UV(62.457745, -95.207344, -29.999981, 0.671333, 2.0), _
      New TEST_XYZ_UV(62.457745, -95.207344, -29.999981, 3.328667, 2.0) _
    }


    normal_body = New TEST_NORMAL() { _
      New TEST_NORMAL(-1.0, 0.0, 0.0), _
      New TEST_NORMAL(-0.997754, -0.065314, -0.014876), _
      New TEST_NORMAL(-0.997278, 0.073735, 0.0), _
      New TEST_NORMAL(-0.996046, -0.088269, -0.01006), _
      New TEST_NORMAL(-0.983634, 0.18018, 0.000183), _
      New TEST_NORMAL(-0.98152, 0.0, -0.19136), _
      New TEST_NORMAL(-0.98152, 0.0, 0.19136), _
      New TEST_NORMAL(-0.978445, 0.076269, -0.191907), _
      New TEST_NORMAL(-0.97772, 0.079356, 0.194336), _
      New TEST_NORMAL(-0.977345, -0.110912, 0.180267), _
      New TEST_NORMAL(-0.97489, -0.131628, -0.179622), _
      New TEST_NORMAL(-0.969674, 0.183836, -0.161048), _
      New TEST_NORMAL(-0.964915, 0.203243, 0.166226), _
      New TEST_NORMAL(-0.958082, -0.109276, 0.264835), _
      New TEST_NORMAL(-0.957589, -0.100605, -0.270002), _
      New TEST_NORMAL(-0.957053, 0.289913, 0.0), _
      New TEST_NORMAL(-0.937249, 0.2891, 0.194898), _
      New TEST_NORMAL(-0.934347, 0.297901, -0.195576), _
      New TEST_NORMAL(-0.921778, -0.387711, 0.002219), _
      New TEST_NORMAL(-0.874217, -0.485522, 0.003758), _
      New TEST_NORMAL(-0.872223, -0.364324, -0.326336), _
      New TEST_NORMAL(-0.863288, -0.390607, 0.319624), _
      New TEST_NORMAL(-0.843687, -0.504657, -0.183065), _
      New TEST_NORMAL(-0.83838, -0.508662, 0.195915), _
      New TEST_NORMAL(-0.825002, 0.565129, 0.001181), _
      New TEST_NORMAL(-0.719527, -0.69433, 0.013685), _
      New TEST_NORMAL(-0.715313, -0.668407, 0.203862), _
      New TEST_NORMAL(-0.702591, -0.67963, -0.210874), _
      New TEST_NORMAL(-0.687063, -0.162618, -0.708166), _
      New TEST_NORMAL(-0.679425, -0.147238, 0.71882), _
      New TEST_NORMAL(-0.669463, -0.119248, -0.733211), _
      New TEST_NORMAL(-0.666357, 0.083301, 0.740965), _
      New TEST_NORMAL(-0.664762, 0.07995, -0.742764), _
      New TEST_NORMAL(-0.664351, 0.0, -0.74742), _
      New TEST_NORMAL(-0.664351, 0.0, 0.747421), _
      New TEST_NORMAL(-0.655365, -0.120632, 0.745617), _
      New TEST_NORMAL(-0.642884, 0.220449, -0.733554), _
      New TEST_NORMAL(-0.642437, 0.240719, 0.72755), _
      New TEST_NORMAL(-0.641728, 0.269942, 0.717856), _
      New TEST_NORMAL(-0.640253, 0.279855, -0.715372), _
      New TEST_NORMAL(-0.575278, -0.325814, -0.750267), _
      New TEST_NORMAL(-0.5674, -0.337263, 0.751206), _
      New TEST_NORMAL(-0.553605, -0.477479, 0.682301), _
      New TEST_NORMAL(-0.543406, -0.468085, -0.696855), _
      New TEST_NORMAL(-0.519483, 0.642265, 0.563589), _
      New TEST_NORMAL(-0.518273, 0.642757, -0.564142), _
      New TEST_NORMAL(-0.479487, -0.619926, 0.621116), _
      New TEST_NORMAL(-0.472255, -0.621163, -0.625405), _
      New TEST_NORMAL(-0.467925, 0.876101, -0.116156), _
      New TEST_NORMAL(-0.466242, 0.876944, 0.116568), _
      New TEST_NORMAL(-0.429511, 0.789853, -0.437782), _
      New TEST_NORMAL(-0.427861, 0.78985, 0.4394), _
      New TEST_NORMAL(-0.413809, 0.910357, -0.00362), _
      New TEST_NORMAL(-0.152322, -0.059633, 0.98653), _
      New TEST_NORMAL(-0.152322, -0.059633, -0.98653), _
      New TEST_NORMAL(-0.14527, 0.201213, -0.968716), _
      New TEST_NORMAL(-0.14527, 0.201214, 0.968715), _
      New TEST_NORMAL(-0.140968, -0.112071, 0.98365), _
      New TEST_NORMAL(-0.140967, -0.112071, -0.983651), _
      New TEST_NORMAL(-0.138434, 0.056902, 0.988736), _
      New TEST_NORMAL(-0.138433, 0.056902, -0.988736), _
      New TEST_NORMAL(-0.136872, -0.247303, 0.959222), _
      New TEST_NORMAL(-0.136871, -0.247303, -0.959222), _
      New TEST_NORMAL(-0.133377, 0.0, 0.991065), _
      New TEST_NORMAL(-0.133377, 0.0, -0.991065), _
      New TEST_NORMAL(-0.125744, 0.14629, -0.981217), _
      New TEST_NORMAL(-0.125744, 0.14629, 0.981217), _
      New TEST_NORMAL(-0.107103, -0.350007, -0.930604), _
      New TEST_NORMAL(-0.107103, -0.350007, 0.930604), _
      New TEST_NORMAL(-0.09211, 0.904454, -0.416507), _
      New TEST_NORMAL(-0.092024, 0.904466, 0.416501), _
      New TEST_NORMAL(-0.091254, -0.511759, -0.854269), _
      New TEST_NORMAL(-0.091254, -0.511759, 0.854269), _
      New TEST_NORMAL(-0.068783, -0.208694, 0.975559), _
      New TEST_NORMAL(-0.068783, -0.208694, -0.975559), _
      New TEST_NORMAL(-0.055063, -0.466564, 0.882772), _
      New TEST_NORMAL(-0.055063, -0.466565, -0.882771), _
      New TEST_NORMAL(-0.053332, -0.047876, -0.997428), _
      New TEST_NORMAL(-0.053332, -0.047876, 0.997428), _
      New TEST_NORMAL(-0.034667, -0.293009, -0.955481), _
      New TEST_NORMAL(-0.034667, -0.293009, 0.955481), _
      New TEST_NORMAL(-0.024679, -0.109967, 0.993629), _
      New TEST_NORMAL(-0.024679, -0.109968, -0.993629), _
      New TEST_NORMAL(-0.018127, 0.932679, -0.360251), _
      New TEST_NORMAL(-0.015119, 0.932509, 0.360829), _
      New TEST_NORMAL(-0.009953, 0.507304, -0.86171), _
      New TEST_NORMAL(-0.008884, 0.50833, 0.861116), _
      New TEST_NORMAL(-0.002499, 0.139357, 0.990239), _
      New TEST_NORMAL(-0.002499, 0.139357, -0.990239), _
      New TEST_NORMAL(0.0, -0.448453, -0.893806), _
      New TEST_NORMAL(0.0, -0.448452, 0.893807), _
      New TEST_NORMAL(0.0, -0.293383, -0.955995), _
      New TEST_NORMAL(0.0, -0.293382, 0.955995), _
      New TEST_NORMAL(0.0, -0.197453, -0.980312), _
      New TEST_NORMAL(0.0, -0.197453, 0.980312), _
      New TEST_NORMAL(0.0, -0.130586, -0.991437), _
      New TEST_NORMAL(0.0, -0.130585, 0.991437), _
      New TEST_NORMAL(0.0, -0.067319, -0.997732), _
      New TEST_NORMAL(0.0, -0.067319, 0.997732), _
      New TEST_NORMAL(0.0, 0.0, -1.0), _
      New TEST_NORMAL(0.0, 0.0, 1.0), _
      New TEST_NORMAL(0.0, 0.048735, -0.998812), _
      New TEST_NORMAL(0.0, 0.048735, -0.998812), _
      New TEST_NORMAL(0.0, 0.048735, -0.998812), _
      New TEST_NORMAL(0.0, 0.048735, 0.998812), _
      New TEST_NORMAL(0.0, 0.048735, 0.998812), _
      New TEST_NORMAL(0.0, 0.048736, 0.998812), _
      New TEST_NORMAL(0.0, 0.145876, -0.989303), _
      New TEST_NORMAL(0.0, 0.145876, 0.989303), _
      New TEST_NORMAL(0.0, 0.18332, -0.983053), _
      New TEST_NORMAL(0.0, 0.18332, -0.983053), _
      New TEST_NORMAL(0.0, 0.18332, -0.983053), _
      New TEST_NORMAL(0.0, 0.183321, 0.983053), _
      New TEST_NORMAL(0.0, 0.183321, 0.983053), _
      New TEST_NORMAL(0.0, 0.183321, 0.983053), _
      New TEST_NORMAL(0.0, 0.505304, -0.862941), _
      New TEST_NORMAL(0.0, 0.507371, 0.861728), _
      New TEST_NORMAL(0.0, 0.939754, 0.34185), _
      New TEST_NORMAL(0.0, 0.940152, -0.340755), _
      New TEST_NORMAL(0.002499, 0.139356, -0.990239), _
      New TEST_NORMAL(0.0025, 0.139357, 0.990239), _
      New TEST_NORMAL(0.008885, 0.50833, 0.861116), _
      New TEST_NORMAL(0.009953, 0.507304, -0.86171), _
      New TEST_NORMAL(0.015119, 0.932509, 0.360829), _
      New TEST_NORMAL(0.018127, 0.93268, -0.36025), _
      New TEST_NORMAL(0.024679, -0.109968, -0.993629), _
      New TEST_NORMAL(0.024679, -0.109967, 0.993629), _
      New TEST_NORMAL(0.034667, -0.293009, 0.955481), _
      New TEST_NORMAL(0.034667, -0.293009, -0.955481), _
      New TEST_NORMAL(0.053332, -0.047876, 0.997428), _
      New TEST_NORMAL(0.053332, -0.047876, -0.997428), _
      New TEST_NORMAL(0.055063, -0.466565, -0.882771), _
      New TEST_NORMAL(0.055063, -0.466564, 0.882772), _
      New TEST_NORMAL(0.068782, -0.208694, -0.975559), _
      New TEST_NORMAL(0.068783, -0.208694, 0.975559), _
      New TEST_NORMAL(0.091254, -0.511758, 0.854269), _
      New TEST_NORMAL(0.091254, -0.511759, -0.854269), _
      New TEST_NORMAL(0.092024, 0.904466, 0.416501), _
      New TEST_NORMAL(0.09211, 0.904454, -0.416507), _
      New TEST_NORMAL(0.107103, -0.350006, 0.930604), _
      New TEST_NORMAL(0.107103, -0.350007, -0.930604), _
      New TEST_NORMAL(0.125744, 0.14629, 0.981217), _
      New TEST_NORMAL(0.125744, 0.14629, -0.981217), _
      New TEST_NORMAL(0.133377, 0.0, -0.991065), _
      New TEST_NORMAL(0.133377, 0.0, 0.991065), _
      New TEST_NORMAL(0.136871, -0.247303, -0.959222), _
      New TEST_NORMAL(0.136871, -0.247303, 0.959222), _
      New TEST_NORMAL(0.138433, 0.056902, -0.988736), _
      New TEST_NORMAL(0.138434, 0.056902, 0.988736), _
      New TEST_NORMAL(0.140967, -0.112071, -0.983651), _
      New TEST_NORMAL(0.140968, -0.112071, 0.98365), _
      New TEST_NORMAL(0.14527, 0.201213, -0.968716), _
      New TEST_NORMAL(0.14527, 0.201214, 0.968715), _
      New TEST_NORMAL(0.152322, -0.059633, 0.98653), _
      New TEST_NORMAL(0.152322, -0.059633, -0.98653), _
      New TEST_NORMAL(0.413809, 0.910357, -0.00362), _
      New TEST_NORMAL(0.427861, 0.78985, 0.4394), _
      New TEST_NORMAL(0.42951, 0.789853, -0.437782), _
      New TEST_NORMAL(0.466243, 0.876943, 0.116568), _
      New TEST_NORMAL(0.467925, 0.876101, -0.116156), _
      New TEST_NORMAL(0.472255, -0.621163, -0.625405), _
      New TEST_NORMAL(0.479486, -0.619926, 0.621116), _
      New TEST_NORMAL(0.518273, 0.642757, -0.564142), _
      New TEST_NORMAL(0.519483, 0.642265, 0.563589), _
      New TEST_NORMAL(0.543406, -0.468085, -0.696854), _
      New TEST_NORMAL(0.553606, -0.477479, 0.682301), _
      New TEST_NORMAL(0.5674, -0.337263, 0.751206), _
      New TEST_NORMAL(0.575277, -0.325814, -0.750268), _
      New TEST_NORMAL(0.640253, 0.279855, -0.715372), _
      New TEST_NORMAL(0.641728, 0.269943, 0.717855), _
      New TEST_NORMAL(0.642437, 0.24072, 0.72755), _
      New TEST_NORMAL(0.642884, 0.220449, -0.733554), _
      New TEST_NORMAL(0.655366, -0.120632, 0.745616), _
      New TEST_NORMAL(0.664351, 0.0, -0.74742), _
      New TEST_NORMAL(0.664351, 0.0, 0.74742), _
      New TEST_NORMAL(0.664762, 0.07995, -0.742764), _
      New TEST_NORMAL(0.666357, 0.083301, 0.740965), _
      New TEST_NORMAL(0.669463, -0.119248, -0.733211), _
      New TEST_NORMAL(0.679425, -0.147237, 0.718821), _
      New TEST_NORMAL(0.687063, -0.162618, -0.708166), _
      New TEST_NORMAL(0.702591, -0.679631, -0.210874), _
      New TEST_NORMAL(0.715313, -0.668407, 0.203862), _
      New TEST_NORMAL(0.719527, -0.69433, 0.013685), _
      New TEST_NORMAL(0.825002, 0.565129, 0.001181), _
      New TEST_NORMAL(0.83838, -0.508662, 0.195915), _
      New TEST_NORMAL(0.843687, -0.504657, -0.183065), _
      New TEST_NORMAL(0.863288, -0.390608, 0.319624), _
      New TEST_NORMAL(0.872223, -0.364324, -0.326336), _
      New TEST_NORMAL(0.874216, -0.485522, 0.003758), _
      New TEST_NORMAL(0.921778, -0.387711, 0.002219), _
      New TEST_NORMAL(0.934347, 0.297901, -0.195575), _
      New TEST_NORMAL(0.937249, 0.2891, 0.194898), _
      New TEST_NORMAL(0.957053, 0.289913, 0.0), _
      New TEST_NORMAL(0.957589, -0.100605, -0.270003), _
      New TEST_NORMAL(0.958082, -0.109276, 0.264835), _
      New TEST_NORMAL(0.964915, 0.203243, 0.166226), _
      New TEST_NORMAL(0.969674, 0.183836, -0.161048), _
      New TEST_NORMAL(0.97489, -0.131628, -0.179622), _
      New TEST_NORMAL(0.977345, -0.110912, 0.180267), _
      New TEST_NORMAL(0.97772, 0.079356, 0.194336), _
      New TEST_NORMAL(0.978445, 0.076269, -0.191907), _
      New TEST_NORMAL(0.98152, 0.0, -0.19136), _
      New TEST_NORMAL(0.98152, 0.0, 0.19136), _
      New TEST_NORMAL(0.983634, 0.180179, 0.000183), _
      New TEST_NORMAL(0.996046, -0.088268, -0.010061), _
      New TEST_NORMAL(0.997278, 0.073735, 0.0), _
      New TEST_NORMAL(0.997754, -0.065314, -0.014876), _
      New TEST_NORMAL(1.0, 0.0, 0.0) _
    }

    triangle3_body = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(261, 291, 283, 58, 50, 28), _
      New TEST_TRIANGLE3(291, 261, 262, 50, 58, 69), _
      New TEST_TRIANGLE3(193, 262, 261, 125, 69, 58), _
      New TEST_TRIANGLE3(262, 193, 190, 69, 125, 124), _
      New TEST_TRIANGLE3(148, 190, 193, 95, 124, 125), _
      New TEST_TRIANGLE3(190, 148, 147, 124, 95, 118), _
      New TEST_TRIANGLE3(253, 283, 277, 54, 28, 30), _
      New TEST_TRIANGLE3(283, 253, 261, 28, 54, 58), _
      New TEST_TRIANGLE3(181, 261, 253, 130, 58, 54), _
      New TEST_TRIANGLE3(261, 181, 193, 58, 130, 125), _
      New TEST_TRIANGLE3(149, 193, 181, 97, 125, 130), _
      New TEST_TRIANGLE3(193, 149, 148, 125, 97, 95), _
      New TEST_TRIANGLE3(228, 277, 273, 62, 30, 40), _
      New TEST_TRIANGLE3(277, 228, 253, 30, 62, 54), _
      New TEST_TRIANGLE3(177, 253, 228, 133, 54, 62), _
      New TEST_TRIANGLE3(253, 177, 181, 54, 133, 130), _
      New TEST_TRIANGLE3(150, 181, 177, 93, 130, 133), _
      New TEST_TRIANGLE3(181, 150, 149, 130, 93, 97), _
      New TEST_TRIANGLE3(202, 273, 237, 71, 40, 47), _
      New TEST_TRIANGLE3(273, 202, 228, 40, 71, 62), _
      New TEST_TRIANGLE3(175, 228, 202, 131, 62, 71), _
      New TEST_TRIANGLE3(228, 175, 177, 62, 131, 133), _
      New TEST_TRIANGLE3(151, 177, 175, 89, 133, 131), _
      New TEST_TRIANGLE3(177, 151, 150, 133, 89, 93), _
      New TEST_TRIANGLE3(185, 239, 209, 67, 47, 43), _
      New TEST_TRIANGLE3(239, 185, 203, 47, 67, 71), _
      New TEST_TRIANGLE3(167, 202, 184, 128, 71, 67), _
      New TEST_TRIANGLE3(202, 167, 175, 71, 128, 131), _
      New TEST_TRIANGLE3(154, 175, 167, 91, 131, 128), _
      New TEST_TRIANGLE3(175, 154, 151, 131, 91, 89), _
      New TEST_TRIANGLE3(179, 207, 213, 65, 43, 36), _
      New TEST_TRIANGLE3(207, 179, 184, 43, 65, 67), _
      New TEST_TRIANGLE3(165, 184, 179, 119, 67, 65), _
      New TEST_TRIANGLE3(184, 165, 167, 67, 119, 128), _
      New TEST_TRIANGLE3(156, 167, 165, 107, 128, 119), _
      New TEST_TRIANGLE3(167, 156, 154, 128, 107, 91), _
      New TEST_TRIANGLE3(194, 213, 224, 55, 36, 39), _
      New TEST_TRIANGLE3(213, 194, 179, 36, 55, 65), _
      New TEST_TRIANGLE3(169, 179, 194, 111, 65, 55), _
      New TEST_TRIANGLE3(179, 169, 165, 65, 111, 119), _
      New TEST_TRIANGLE3(157, 165, 169, 110, 119, 111), _
      New TEST_TRIANGLE3(165, 157, 156, 119, 110, 107), _
      New TEST_TRIANGLE3(196, 224, 234, 60, 39, 32), _
      New TEST_TRIANGLE3(224, 196, 194, 39, 60, 55), _
      New TEST_TRIANGLE3(172, 194, 196, 103, 55, 60), _
      New TEST_TRIANGLE3(194, 172, 169, 55, 103, 111), _
      New TEST_TRIANGLE3(159, 169, 172, 102, 111, 103), _
      New TEST_TRIANGLE3(169, 159, 157, 111, 102, 110), _
      New TEST_TRIANGLE3(197, 234, 236, 64, 32, 33), _
      New TEST_TRIANGLE3(234, 197, 196, 32, 64, 60), _
      New TEST_TRIANGLE3(173, 196, 197, 99, 60, 64), _
      New TEST_TRIANGLE3(196, 173, 172, 60, 99, 103), _
      New TEST_TRIANGLE3(161, 172, 173, 99, 103, 99), _
      New TEST_TRIANGLE3(172, 161, 159, 103, 99, 102), _
      New TEST_TRIANGLE3(260, 288, 265, 57, 51, 70), _
      New TEST_TRIANGLE3(288, 260, 281, 51, 57, 29), _
      New TEST_TRIANGLE3(192, 265, 189, 126, 70, 123), _
      New TEST_TRIANGLE3(265, 192, 260, 70, 126, 57), _
      New TEST_TRIANGLE3(143, 189, 142, 96, 123, 117), _
      New TEST_TRIANGLE3(189, 143, 192, 123, 96, 126), _
      New TEST_TRIANGLE3(252, 281, 260, 53, 29, 57), _
      New TEST_TRIANGLE3(281, 252, 276, 29, 53, 35), _
      New TEST_TRIANGLE3(180, 260, 192, 129, 57, 126), _
      New TEST_TRIANGLE3(260, 180, 252, 57, 129, 53), _
      New TEST_TRIANGLE3(144, 192, 143, 98, 126, 96), _
      New TEST_TRIANGLE3(192, 144, 180, 126, 98, 129), _
      New TEST_TRIANGLE3(227, 276, 252, 61, 35, 53), _
      New TEST_TRIANGLE3(276, 227, 272, 35, 61, 41), _
      New TEST_TRIANGLE3(176, 252, 180, 134, 53, 129), _
      New TEST_TRIANGLE3(252, 176, 227, 53, 134, 61), _
      New TEST_TRIANGLE3(145, 180, 144, 94, 129, 98), _
      New TEST_TRIANGLE3(180, 145, 176, 129, 94, 134), _
      New TEST_TRIANGLE3(201, 272, 227, 72, 41, 61), _
      New TEST_TRIANGLE3(272, 201, 242, 41, 72, 46), _
      New TEST_TRIANGLE3(174, 227, 176, 132, 61, 134), _
      New TEST_TRIANGLE3(227, 174, 201, 61, 132, 72), _
      New TEST_TRIANGLE3(146, 176, 145, 90, 134, 94), _
      New TEST_TRIANGLE3(176, 146, 174, 134, 90, 132), _
      New TEST_TRIANGLE3(182, 241, 200, 68, 46, 72), _
      New TEST_TRIANGLE3(241, 182, 205, 46, 68, 42), _
      New TEST_TRIANGLE3(166, 201, 174, 127, 72, 132), _
      New TEST_TRIANGLE3(201, 166, 183, 72, 127, 68), _
      New TEST_TRIANGLE3(153, 174, 146, 92, 132, 90), _
      New TEST_TRIANGLE3(174, 153, 166, 132, 92, 127), _
      New TEST_TRIANGLE3(178, 206, 183, 66, 42, 68), _
      New TEST_TRIANGLE3(206, 178, 211, 42, 66, 37), _
      New TEST_TRIANGLE3(164, 183, 166, 120, 68, 127), _
      New TEST_TRIANGLE3(183, 164, 178, 68, 120, 66), _
      New TEST_TRIANGLE3(155, 166, 153, 108, 127, 92), _
      New TEST_TRIANGLE3(166, 155, 164, 127, 108, 120), _
      New TEST_TRIANGLE3(195, 211, 178, 56, 37, 66), _
      New TEST_TRIANGLE3(211, 195, 226, 37, 56, 38), _
      New TEST_TRIANGLE3(168, 178, 164, 112, 66, 120), _
      New TEST_TRIANGLE3(178, 168, 195, 66, 112, 56), _
      New TEST_TRIANGLE3(158, 164, 155, 114, 120, 108), _
      New TEST_TRIANGLE3(164, 158, 168, 120, 114, 112), _
      New TEST_TRIANGLE3(198, 226, 195, 59, 38, 56), _
      New TEST_TRIANGLE3(226, 198, 230, 38, 59, 31), _
      New TEST_TRIANGLE3(170, 195, 168, 104, 56, 112), _
      New TEST_TRIANGLE3(195, 170, 198, 56, 104, 59), _
      New TEST_TRIANGLE3(160, 168, 158, 106, 112, 114), _
      New TEST_TRIANGLE3(168, 160, 170, 112, 106, 104), _
      New TEST_TRIANGLE3(199, 230, 198, 63, 31, 59), _
      New TEST_TRIANGLE3(230, 199, 232, 31, 63, 34), _
      New TEST_TRIANGLE3(171, 198, 170, 100, 59, 104), _
      New TEST_TRIANGLE3(198, 171, 199, 59, 100, 63), _
      New TEST_TRIANGLE3(162, 170, 160, 100, 104, 106), _
      New TEST_TRIANGLE3(170, 162, 171, 104, 100, 100), _
      New TEST_TRIANGLE3(269, 292, 263, 163, 50, 69), _
      New TEST_TRIANGLE3(290, 268, 302, 50, 163, 48), _
      New TEST_TRIANGLE3(187, 263, 191, 86, 69, 124), _
      New TEST_TRIANGLE3(263, 187, 269, 69, 86, 163), _
      New TEST_TRIANGLE3(163, 191, 147, 116, 124, 118), _
      New TEST_TRIANGLE3(191, 163, 187, 124, 116, 86), _
      New TEST_TRIANGLE3(270, 302, 268, 183, 48, 163), _
      New TEST_TRIANGLE3(302, 270, 304, 48, 183, 52), _
      New TEST_TRIANGLE3(266, 304, 270, 162, 52, 183), _
      New TEST_TRIANGLE3(304, 266, 300, 52, 162, 49), _
      New TEST_TRIANGLE3(286, 300, 266, 51, 49, 162), _
      New TEST_TRIANGLE3(267, 264, 287, 162, 70, 51), _
      New TEST_TRIANGLE3(188, 267, 186, 123, 162, 85), _
      New TEST_TRIANGLE3(267, 188, 264, 162, 123, 70), _
      New TEST_TRIANGLE3(142, 186, 152, 117, 85, 115), _
      New TEST_TRIANGLE3(186, 142, 188, 85, 117, 123), _
      New TEST_TRIANGLE3(250, 235, 233, 7, 33, 32), _
      New TEST_TRIANGLE3(235, 250, 251, 33, 7, 5), _
      New TEST_TRIANGLE3(245, 233, 223, 17, 32, 39), _
      New TEST_TRIANGLE3(233, 245, 250, 32, 17, 7), _
      New TEST_TRIANGLE3(216, 223, 212, 11, 39, 36), _
      New TEST_TRIANGLE3(223, 216, 245, 39, 11, 17), _
      New TEST_TRIANGLE3(221, 212, 208, 22, 36, 43), _
      New TEST_TRIANGLE3(212, 221, 216, 36, 22, 11), _
      New TEST_TRIANGLE3(255, 209, 239, 27, 43, 47), _
      New TEST_TRIANGLE3(209, 255, 222, 43, 27, 22), _
      New TEST_TRIANGLE3(279, 238, 274, 20, 47, 40), _
      New TEST_TRIANGLE3(238, 279, 254, 47, 20, 27), _
      New TEST_TRIANGLE3(297, 274, 278, 14, 40, 30), _
      New TEST_TRIANGLE3(274, 297, 279, 40, 14, 20), _
      New TEST_TRIANGLE3(295, 278, 284, 10, 30, 28), _
      New TEST_TRIANGLE3(278, 295, 297, 30, 10, 14), _
      New TEST_TRIANGLE3(303, 284, 293, 48, 28, 50), _
      New TEST_TRIANGLE3(284, 303, 295, 28, 48, 10), _
      New TEST_TRIANGLE3(248, 251, 250, 2, 5, 7), _
      New TEST_TRIANGLE3(251, 248, 249, 5, 2, 0), _
      New TEST_TRIANGLE3(244, 250, 245, 15, 7, 17), _
      New TEST_TRIANGLE3(250, 244, 248, 7, 15, 2), _
      New TEST_TRIANGLE3(215, 245, 216, 4, 17, 11), _
      New TEST_TRIANGLE3(245, 215, 244, 17, 4, 15), _
      New TEST_TRIANGLE3(217, 216, 221, 19, 11, 22), _
      New TEST_TRIANGLE3(216, 217, 215, 11, 19, 4), _
      New TEST_TRIANGLE3(259, 222, 255, 25, 22, 27), _
      New TEST_TRIANGLE3(222, 259, 218, 22, 25, 19), _
      New TEST_TRIANGLE3(285, 254, 279, 18, 27, 20), _
      New TEST_TRIANGLE3(254, 285, 258, 27, 18, 25), _
      New TEST_TRIANGLE3(299, 279, 297, 1, 20, 14), _
      New TEST_TRIANGLE3(279, 299, 285, 20, 1, 18), _
      New TEST_TRIANGLE3(298, 297, 295, 3, 14, 10), _
      New TEST_TRIANGLE3(297, 298, 299, 14, 3, 1), _
      New TEST_TRIANGLE3(305, 295, 303, 52, 10, 48), _
      New TEST_TRIANGLE3(295, 305, 298, 10, 52, 3), _
      New TEST_TRIANGLE3(246, 249, 248, 8, 0, 2), _
      New TEST_TRIANGLE3(249, 246, 247, 0, 8, 6), _
      New TEST_TRIANGLE3(243, 248, 244, 16, 2, 15), _
      New TEST_TRIANGLE3(248, 243, 246, 2, 16, 8), _
      New TEST_TRIANGLE3(214, 244, 215, 12, 15, 4), _
      New TEST_TRIANGLE3(244, 214, 243, 15, 12, 16), _
      New TEST_TRIANGLE3(219, 215, 217, 23, 4, 19), _
      New TEST_TRIANGLE3(215, 219, 214, 4, 23, 12), _
      New TEST_TRIANGLE3(257, 218, 259, 26, 19, 25), _
      New TEST_TRIANGLE3(218, 257, 220, 19, 26, 23), _
      New TEST_TRIANGLE3(280, 258, 285, 21, 25, 18), _
      New TEST_TRIANGLE3(258, 280, 256, 25, 21, 26), _
      New TEST_TRIANGLE3(296, 285, 299, 13, 18, 1), _
      New TEST_TRIANGLE3(285, 296, 280, 18, 13, 21), _
      New TEST_TRIANGLE3(294, 299, 298, 9, 1, 3), _
      New TEST_TRIANGLE3(299, 294, 296, 1, 9, 13), _
      New TEST_TRIANGLE3(301, 298, 305, 49, 3, 52), _
      New TEST_TRIANGLE3(298, 301, 294, 3, 49, 9), _
      New TEST_TRIANGLE3(229, 247, 246, 31, 6, 8), _
      New TEST_TRIANGLE3(247, 229, 231, 6, 31, 34), _
      New TEST_TRIANGLE3(225, 246, 243, 38, 8, 16), _
      New TEST_TRIANGLE3(246, 225, 229, 8, 38, 31), _
      New TEST_TRIANGLE3(210, 243, 214, 37, 16, 12), _
      New TEST_TRIANGLE3(243, 210, 225, 16, 37, 38), _
      New TEST_TRIANGLE3(204, 214, 219, 42, 12, 23), _
      New TEST_TRIANGLE3(214, 204, 210, 12, 42, 37), _
      New TEST_TRIANGLE3(241, 220, 257, 46, 23, 26), _
      New TEST_TRIANGLE3(220, 241, 205, 23, 46, 42), _
      New TEST_TRIANGLE3(271, 256, 280, 41, 26, 21), _
      New TEST_TRIANGLE3(256, 271, 240, 26, 41, 46), _
      New TEST_TRIANGLE3(275, 280, 296, 35, 21, 13), _
      New TEST_TRIANGLE3(280, 275, 271, 21, 35, 41), _
      New TEST_TRIANGLE3(282, 296, 294, 29, 13, 9), _
      New TEST_TRIANGLE3(296, 282, 275, 13, 29, 35), _
      New TEST_TRIANGLE3(289, 294, 301, 51, 9, 49), _
      New TEST_TRIANGLE3(294, 289, 282, 9, 51, 29), _
      New TEST_TRIANGLE3(18, 45, 24, 157, 149, 179), _
      New TEST_TRIANGLE3(45, 18, 43, 149, 157, 138), _
      New TEST_TRIANGLE3(43, 113, 45, 138, 82, 149), _
      New TEST_TRIANGLE3(113, 43, 117, 82, 138, 83), _
      New TEST_TRIANGLE3(117, 148, 113, 83, 95, 82), _
      New TEST_TRIANGLE3(148, 117, 147, 95, 83, 118), _
      New TEST_TRIANGLE3(24, 52, 30, 179, 154, 177), _
      New TEST_TRIANGLE3(52, 24, 45, 154, 179, 149), _
      New TEST_TRIANGLE3(45, 124, 52, 149, 77, 154), _
      New TEST_TRIANGLE3(124, 45, 113, 77, 149, 82), _
      New TEST_TRIANGLE3(113, 149, 124, 82, 97, 77), _
      New TEST_TRIANGLE3(149, 113, 148, 97, 82, 95), _
      New TEST_TRIANGLE3(30, 78, 34, 177, 145, 167), _
      New TEST_TRIANGLE3(78, 30, 52, 145, 177, 154), _
      New TEST_TRIANGLE3(52, 129, 78, 154, 74, 145), _
      New TEST_TRIANGLE3(129, 52, 124, 74, 154, 77), _
      New TEST_TRIANGLE3(124, 150, 129, 77, 93, 74), _
      New TEST_TRIANGLE3(150, 124, 149, 93, 77, 97), _
      New TEST_TRIANGLE3(34, 105, 68, 167, 136, 160), _
      New TEST_TRIANGLE3(105, 34, 78, 136, 167, 145), _
      New TEST_TRIANGLE3(78, 131, 105, 145, 76, 136), _
      New TEST_TRIANGLE3(131, 78, 129, 76, 145, 74), _
      New TEST_TRIANGLE3(129, 151, 131, 74, 89, 76), _
      New TEST_TRIANGLE3(151, 129, 150, 89, 74, 93), _
      New TEST_TRIANGLE3(66, 122, 99, 160, 140, 164), _
      New TEST_TRIANGLE3(122, 66, 104, 140, 160, 136), _
      New TEST_TRIANGLE3(105, 139, 123, 136, 79, 140), _
      New TEST_TRIANGLE3(139, 105, 131, 79, 136, 76), _
      New TEST_TRIANGLE3(131, 154, 139, 76, 91, 79), _
      New TEST_TRIANGLE3(154, 131, 151, 91, 76, 89), _
      New TEST_TRIANGLE3(101, 127, 94, 164, 142, 171), _
      New TEST_TRIANGLE3(127, 101, 123, 142, 164, 140), _
      New TEST_TRIANGLE3(123, 141, 127, 140, 88, 142), _
      New TEST_TRIANGLE3(141, 123, 139, 88, 140, 79), _
      New TEST_TRIANGLE3(139, 156, 141, 79, 107, 88), _
      New TEST_TRIANGLE3(156, 139, 154, 107, 79, 91), _
      New TEST_TRIANGLE3(94, 111, 81, 171, 151, 168), _
      New TEST_TRIANGLE3(111, 94, 127, 151, 171, 142), _
      New TEST_TRIANGLE3(127, 137, 111, 142, 109, 151), _
      New TEST_TRIANGLE3(137, 127, 141, 109, 142, 88), _
      New TEST_TRIANGLE3(141, 157, 137, 88, 110, 109), _
      New TEST_TRIANGLE3(157, 141, 156, 110, 88, 107), _
      New TEST_TRIANGLE3(81, 108, 73, 168, 147, 175), _
      New TEST_TRIANGLE3(108, 81, 111, 147, 168, 151), _
      New TEST_TRIANGLE3(111, 134, 108, 151, 101, 147), _
      New TEST_TRIANGLE3(134, 111, 137, 101, 151, 109), _
      New TEST_TRIANGLE3(137, 159, 134, 109, 102, 101), _
      New TEST_TRIANGLE3(159, 137, 157, 102, 109, 110), _
      New TEST_TRIANGLE3(73, 109, 75, 175, 143, 173), _
      New TEST_TRIANGLE3(109, 73, 108, 143, 175, 147), _
      New TEST_TRIANGLE3(108, 135, 109, 147, 99, 143), _
      New TEST_TRIANGLE3(135, 108, 134, 99, 147, 101), _
      New TEST_TRIANGLE3(134, 161, 135, 101, 99, 99), _
      New TEST_TRIANGLE3(161, 134, 159, 99, 101, 102), _
      New TEST_TRIANGLE3(13, 44, 40, 156, 150, 137), _
      New TEST_TRIANGLE3(44, 13, 22, 150, 156, 178), _
      New TEST_TRIANGLE3(40, 112, 114, 137, 81, 84), _
      New TEST_TRIANGLE3(112, 40, 44, 81, 137, 150), _
      New TEST_TRIANGLE3(114, 143, 142, 84, 96, 117), _
      New TEST_TRIANGLE3(143, 114, 112, 96, 84, 81), _
      New TEST_TRIANGLE3(22, 53, 44, 178, 153, 150), _
      New TEST_TRIANGLE3(53, 22, 27, 153, 178, 172), _
      New TEST_TRIANGLE3(44, 125, 112, 150, 78, 81), _
      New TEST_TRIANGLE3(125, 44, 53, 78, 150, 153), _
      New TEST_TRIANGLE3(112, 144, 143, 81, 98, 96), _
      New TEST_TRIANGLE3(144, 112, 125, 98, 81, 78), _
      New TEST_TRIANGLE3(27, 77, 53, 172, 146, 153), _
      New TEST_TRIANGLE3(77, 27, 31, 146, 172, 166), _
      New TEST_TRIANGLE3(53, 128, 125, 153, 73, 78), _
      New TEST_TRIANGLE3(128, 53, 77, 73, 153, 146), _
      New TEST_TRIANGLE3(125, 145, 144, 78, 94, 98), _
      New TEST_TRIANGLE3(145, 125, 128, 94, 78, 73), _
      New TEST_TRIANGLE3(31, 103, 77, 166, 135, 146), _
      New TEST_TRIANGLE3(103, 31, 64, 135, 166, 161), _
      New TEST_TRIANGLE3(77, 130, 128, 146, 75, 73), _
      New TEST_TRIANGLE3(130, 77, 103, 75, 146, 135), _
      New TEST_TRIANGLE3(128, 146, 145, 73, 90, 94), _
      New TEST_TRIANGLE3(146, 128, 130, 90, 73, 75), _
      New TEST_TRIANGLE3(63, 120, 102, 161, 139, 135), _
      New TEST_TRIANGLE3(120, 63, 96, 139, 161, 165), _
      New TEST_TRIANGLE3(103, 138, 130, 135, 80, 75), _
      New TEST_TRIANGLE3(138, 103, 121, 80, 135, 139), _
      New TEST_TRIANGLE3(130, 153, 146, 75, 92, 90), _
      New TEST_TRIANGLE3(153, 130, 138, 92, 75, 80), _
      New TEST_TRIANGLE3(97, 126, 121, 165, 141, 139), _
      New TEST_TRIANGLE3(126, 97, 92, 141, 165, 170), _
      New TEST_TRIANGLE3(121, 140, 138, 139, 87, 80), _
      New TEST_TRIANGLE3(140, 121, 126, 87, 139, 141), _
      New TEST_TRIANGLE3(138, 155, 153, 80, 108, 92), _
      New TEST_TRIANGLE3(155, 138, 140, 108, 80, 87), _
      New TEST_TRIANGLE3(92, 110, 126, 170, 152, 141), _
      New TEST_TRIANGLE3(110, 92, 79, 152, 170, 169), _
      New TEST_TRIANGLE3(126, 136, 140, 141, 113, 87), _
      New TEST_TRIANGLE3(136, 126, 110, 113, 141, 152), _
      New TEST_TRIANGLE3(140, 158, 155, 87, 114, 108), _
      New TEST_TRIANGLE3(158, 140, 136, 114, 87, 113), _
      New TEST_TRIANGLE3(79, 106, 110, 169, 148, 152), _
      New TEST_TRIANGLE3(106, 79, 69, 148, 169, 176), _
      New TEST_TRIANGLE3(110, 132, 136, 152, 105, 113), _
      New TEST_TRIANGLE3(132, 110, 106, 105, 152, 148), _
      New TEST_TRIANGLE3(136, 160, 158, 113, 106, 114), _
      New TEST_TRIANGLE3(160, 136, 132, 106, 113, 105), _
      New TEST_TRIANGLE3(69, 107, 106, 176, 144, 148), _
      New TEST_TRIANGLE3(107, 69, 71, 144, 176, 174), _
      New TEST_TRIANGLE3(106, 133, 132, 148, 100, 105), _
      New TEST_TRIANGLE3(133, 106, 107, 100, 148, 144), _
      New TEST_TRIANGLE3(132, 162, 160, 105, 100, 106), _
      New TEST_TRIANGLE3(162, 132, 133, 100, 105, 100), _
      New TEST_TRIANGLE3(17, 36, 42, 157, 44, 138), _
      New TEST_TRIANGLE3(37, 19, 5, 44, 157, 159), _
      New TEST_TRIANGLE3(42, 118, 116, 138, 121, 83), _
      New TEST_TRIANGLE3(118, 42, 36, 121, 138, 44), _
      New TEST_TRIANGLE3(116, 163, 147, 83, 116, 118), _
      New TEST_TRIANGLE3(163, 116, 118, 116, 83, 121), _
      New TEST_TRIANGLE3(5, 35, 37, 159, 24, 44), _
      New TEST_TRIANGLE3(35, 5, 1, 24, 159, 155), _
      New TEST_TRIANGLE3(1, 39, 35, 155, 45, 24), _
      New TEST_TRIANGLE3(39, 1, 3, 45, 155, 158), _
      New TEST_TRIANGLE3(14, 41, 38, 156, 137, 45), _
      New TEST_TRIANGLE3(39, 3, 15, 45, 158, 156), _
      New TEST_TRIANGLE3(38, 115, 119, 45, 84, 122), _
      New TEST_TRIANGLE3(115, 38, 41, 84, 45, 137), _
      New TEST_TRIANGLE3(119, 142, 152, 122, 117, 115), _
      New TEST_TRIANGLE3(142, 119, 115, 117, 122, 84), _
      New TEST_TRIANGLE3(76, 58, 74, 173, 200, 175), _
      New TEST_TRIANGLE3(58, 76, 59, 200, 173, 201), _
      New TEST_TRIANGLE3(74, 62, 82, 175, 190, 168), _
      New TEST_TRIANGLE3(62, 74, 58, 190, 175, 200), _
      New TEST_TRIANGLE3(82, 91, 95, 168, 196, 171), _
      New TEST_TRIANGLE3(91, 82, 62, 196, 168, 190), _
      New TEST_TRIANGLE3(95, 86, 100, 171, 185, 164), _
      New TEST_TRIANGLE3(86, 95, 91, 185, 171, 196), _
      New TEST_TRIANGLE3(99, 50, 66, 164, 180, 160), _
      New TEST_TRIANGLE3(50, 99, 85, 180, 164, 185), _
      New TEST_TRIANGLE3(67, 25, 33, 160, 187, 167), _
      New TEST_TRIANGLE3(25, 67, 51, 187, 160, 180), _
      New TEST_TRIANGLE3(33, 9, 29, 167, 193, 177), _
      New TEST_TRIANGLE3(9, 33, 25, 193, 167, 187), _
      New TEST_TRIANGLE3(29, 11, 23, 177, 197, 179), _
      New TEST_TRIANGLE3(11, 29, 9, 197, 177, 193), _
      New TEST_TRIANGLE3(23, 4, 16, 179, 159, 157), _
      New TEST_TRIANGLE3(4, 23, 11, 159, 179, 197), _
      New TEST_TRIANGLE3(59, 56, 58, 201, 205, 200), _
      New TEST_TRIANGLE3(56, 59, 57, 205, 201, 207), _
      New TEST_TRIANGLE3(58, 61, 62, 200, 192, 190), _
      New TEST_TRIANGLE3(61, 58, 56, 192, 200, 205), _
      New TEST_TRIANGLE3(62, 90, 91, 190, 203, 196), _
      New TEST_TRIANGLE3(90, 62, 61, 203, 190, 192), _
      New TEST_TRIANGLE3(91, 88, 86, 196, 188, 185), _
      New TEST_TRIANGLE3(88, 91, 90, 188, 196, 203), _
      New TEST_TRIANGLE3(85, 46, 50, 185, 182, 180), _
      New TEST_TRIANGLE3(46, 85, 87, 182, 185, 188), _
      New TEST_TRIANGLE3(51, 20, 25, 180, 189, 187), _
      New TEST_TRIANGLE3(20, 51, 47, 189, 180, 182), _
      New TEST_TRIANGLE3(25, 6, 9, 187, 206, 193), _
      New TEST_TRIANGLE3(6, 25, 20, 206, 187, 189), _
      New TEST_TRIANGLE3(9, 7, 11, 193, 204, 197), _
      New TEST_TRIANGLE3(7, 9, 6, 204, 193, 206), _
      New TEST_TRIANGLE3(11, 0, 4, 197, 155, 159), _
      New TEST_TRIANGLE3(0, 11, 7, 155, 197, 204), _
      New TEST_TRIANGLE3(57, 54, 56, 207, 199, 205), _
      New TEST_TRIANGLE3(54, 57, 55, 199, 207, 202), _
      New TEST_TRIANGLE3(56, 60, 61, 205, 191, 192), _
      New TEST_TRIANGLE3(60, 56, 54, 191, 205, 199), _
      New TEST_TRIANGLE3(61, 89, 90, 192, 195, 203), _
      New TEST_TRIANGLE3(89, 61, 60, 195, 192, 191), _
      New TEST_TRIANGLE3(90, 84, 88, 203, 184, 188), _
      New TEST_TRIANGLE3(84, 90, 89, 184, 203, 195), _
      New TEST_TRIANGLE3(87, 48, 46, 188, 181, 182), _
      New TEST_TRIANGLE3(48, 87, 83, 181, 188, 184), _
      New TEST_TRIANGLE3(47, 26, 20, 182, 186, 189), _
      New TEST_TRIANGLE3(26, 47, 49, 186, 182, 181), _
      New TEST_TRIANGLE3(20, 8, 6, 189, 194, 206), _
      New TEST_TRIANGLE3(8, 20, 26, 194, 189, 186), _
      New TEST_TRIANGLE3(6, 10, 7, 206, 198, 204), _
      New TEST_TRIANGLE3(10, 6, 8, 198, 206, 194), _
      New TEST_TRIANGLE3(7, 2, 0, 204, 158, 155), _
      New TEST_TRIANGLE3(2, 7, 10, 158, 204, 198), _
      New TEST_TRIANGLE3(55, 70, 54, 202, 176, 199), _
      New TEST_TRIANGLE3(70, 55, 72, 176, 202, 174), _
      New TEST_TRIANGLE3(54, 80, 60, 199, 169, 191), _
      New TEST_TRIANGLE3(80, 54, 70, 169, 199, 176), _
      New TEST_TRIANGLE3(60, 93, 89, 191, 170, 195), _
      New TEST_TRIANGLE3(93, 60, 80, 170, 191, 169), _
      New TEST_TRIANGLE3(89, 98, 84, 195, 165, 184), _
      New TEST_TRIANGLE3(98, 89, 93, 165, 195, 170), _
      New TEST_TRIANGLE3(83, 63, 48, 184, 161, 181), _
      New TEST_TRIANGLE3(63, 83, 96, 161, 184, 165), _
      New TEST_TRIANGLE3(49, 32, 26, 181, 166, 186), _
      New TEST_TRIANGLE3(32, 49, 65, 166, 181, 161), _
      New TEST_TRIANGLE3(26, 28, 8, 186, 172, 194), _
      New TEST_TRIANGLE3(28, 26, 32, 172, 186, 166), _
      New TEST_TRIANGLE3(8, 21, 10, 194, 178, 198), _
      New TEST_TRIANGLE3(21, 8, 28, 178, 194, 172), _
      New TEST_TRIANGLE3(10, 12, 2, 198, 156, 158), _
      New TEST_TRIANGLE3(12, 10, 21, 156, 198, 178) _
    }

    matrix_head = New Single() { _
      0.0, 0.0, -0.309686, 0.774218, _
      -0.160459, 0.0, 0.0, -12.32059, _
      0.0, 0.160459, 0.0, 188.5021, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_head = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-7.500001, -12.499862, 0.0, 0.0, 0.0), _
      New TEST_XYZ_UV(12.499997, -12.499863, 0.0, 0.0, 0.0), _
      New TEST_XYZ_UV(2.500001, 7.500088, 0.0, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.499997, 17.500112, 0.0, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.500001, -12.499863, 4.999999, 0.0, 0.0), _
      New TEST_XYZ_UV(12.499997, -12.499864, 5.0, 0.0, 0.0), _
      New TEST_XYZ_UV(2.5, 7.500087, 5.0, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.499998, 17.500111, 5.0, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.894781, -55.922876, 22.975359, 0.0, 0.0), _
      New TEST_XYZ_UV(-18.027585, -69.850768, 9.565706, 0.0, 0.0), _
      New TEST_XYZ_UV(-18.027578, -69.850765, -4.565702, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.894779, -55.922867, -17.369555, 0.0, 0.0), _
      New TEST_XYZ_UV(-14.780948, -21.114937, 26.052181, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.499998, -25.968928, 12.111234, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.500002, -25.968923, -7.111231, 0.0, 0.0), _
      New TEST_XYZ_UV(-14.780949, -21.114926, -21.052182, 0.0, 0.0), _
      New TEST_XYZ_UV(-14.780949, 22.176179, 26.052184, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.500003, 27.030176, 12.111234, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.500007, 27.03018, -7.111233, 0.0, 0.0), _
      New TEST_XYZ_UV(-14.78095, 22.176095, -21.052184, 0.0, 0.0), _
      New TEST_XYZ_UV(-25.28051, 55.313886, 22.369553, 0.0, 0.0), _
      New TEST_XYZ_UV(-23.450382, 64.812289, 9.565702, 0.0, 0.0), _
      New TEST_XYZ_UV(-23.450392, 64.812292, -4.565704, 0.0, 0.0), _
      New TEST_XYZ_UV(-25.280517, 55.3138, -17.369556, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.118045, -72.521205, 9.888556, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.118046, -72.521202, -4.888552, 0.0, 0.0), _
      New TEST_XYZ_UV(-39.561415, -22.953953, -23.053152, 0.0, 0.0), _
      New TEST_XYZ_UV(-39.561422, 24.015125, -23.053156, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.894786, 56.984037, -17.975362, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.118053, 67.482732, -4.888556, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.118055, 67.482728, 9.888554, 0.0, 0.0), _
      New TEST_XYZ_UV(-41.894788, 56.984123, 22.975359, 0.0, 0.0), _
      New TEST_XYZ_UV(-39.561416, 24.015209, 28.053152, 0.0, 0.0), _
      New TEST_XYZ_UV(-39.561412, -22.953964, 28.053152, 0.0, 0.0) _
    }


    normal_head = New TEST_NORMAL() { _
      New TEST_NORMAL(0.0, -0.707107, -0.707107), _
      New TEST_NORMAL(0.0, -0.707107, 0.707107), _
      New TEST_NORMAL(0.079808, 0.076359, -0.993881), _
      New TEST_NORMAL(0.08641, 0.084246, 0.992691), _
      New TEST_NORMAL(0.08641, -0.084246, 0.992691), _
      New TEST_NORMAL(0.087036, -0.093665, -0.991792), _
      New TEST_NORMAL(0.090705, 0.507326, 0.856967), _
      New TEST_NORMAL(0.091549, 0.519655, -0.849457), _
      New TEST_NORMAL(0.109176, -0.890645, -0.441398), _
      New TEST_NORMAL(0.109595, -0.895476, 0.431406), _
      New TEST_NORMAL(0.139874, 0.935846, 0.323462), _
      New TEST_NORMAL(0.146983, 0.932584, -0.32967), _
      New TEST_NORMAL(0.194004, -0.381798, -0.903655), _
      New TEST_NORMAL(0.20547, -0.383723, 0.900299), _
      New TEST_NORMAL(0.4226, 0.466285, 0.777166), _
      New TEST_NORMAL(0.423459, 0.477941, -0.769581), _
      New TEST_NORMAL(0.544513, -0.110112, -0.831493), _
      New TEST_NORMAL(0.54627, -0.107353, 0.830702), _
      New TEST_NORMAL(0.553651, 0.111219, 0.825289), _
      New TEST_NORMAL(0.555505, 0.108754, -0.824371), _
      New TEST_NORMAL(0.564801, 0.777968, -0.275255), _
      New TEST_NORMAL(0.567742, 0.77738, 0.27083), _
      New TEST_NORMAL(0.589362, -0.692668, -0.415768), _
      New TEST_NORMAL(0.591842, -0.693554, 0.410739), _
      New TEST_NORMAL(0.6002, 0.4326, -0.672768), _
      New TEST_NORMAL(0.600201, 0.4326, 0.672768), _
      New TEST_NORMAL(0.632456, 0.632455, -0.447213), _
      New TEST_NORMAL(0.632457, 0.632455, 0.447213), _
      New TEST_NORMAL(0.706586, -0.436694, 0.556808), _
      New TEST_NORMAL(0.706586, -0.436693, -0.556808), _
      New TEST_NORMAL(0.947651, 0.198891, -0.249798), _
      New TEST_NORMAL(0.947652, 0.198891, 0.249798), _
      New TEST_NORMAL(0.958035, -0.129432, 0.255766), _
      New TEST_NORMAL(0.958035, -0.129431, -0.255766) _
    }

    triangle3_head = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(5, 1, 0, 28, 29, 0), _
      New TEST_TRIANGLE3(4, 5, 0, 1, 28, 0), _
      New TEST_TRIANGLE3(6, 2, 1, 25, 24, 29), _
      New TEST_TRIANGLE3(5, 6, 1, 28, 25, 29), _
      New TEST_TRIANGLE3(7, 3, 2, 27, 26, 24), _
      New TEST_TRIANGLE3(6, 7, 2, 25, 27, 24), _
      New TEST_TRIANGLE3(3, 0, 2, 26, 0, 24), _
      New TEST_TRIANGLE3(2, 0, 1, 24, 0, 29), _
      New TEST_TRIANGLE3(4, 7, 6, 1, 27, 25), _
      New TEST_TRIANGLE3(4, 6, 5, 1, 25, 28), _
      New TEST_TRIANGLE3(12, 9, 8, 17, 23, 13), _
      New TEST_TRIANGLE3(9, 12, 13, 23, 17, 32), _
      New TEST_TRIANGLE3(14, 10, 9, 33, 22, 23), _
      New TEST_TRIANGLE3(9, 13, 14, 23, 32, 33), _
      New TEST_TRIANGLE3(15, 11, 10, 16, 12, 22), _
      New TEST_TRIANGLE3(10, 14, 15, 22, 33, 16), _
      New TEST_TRIANGLE3(17, 13, 12, 31, 32, 17), _
      New TEST_TRIANGLE3(12, 16, 17, 17, 18, 31), _
      New TEST_TRIANGLE3(18, 14, 13, 30, 33, 32), _
      New TEST_TRIANGLE3(13, 17, 18, 32, 31, 30), _
      New TEST_TRIANGLE3(19, 15, 14, 19, 16, 33), _
      New TEST_TRIANGLE3(14, 18, 19, 33, 30, 19), _
      New TEST_TRIANGLE3(21, 17, 20, 21, 31, 14), _
      New TEST_TRIANGLE3(16, 20, 17, 18, 14, 31), _
      New TEST_TRIANGLE3(22, 18, 17, 20, 30, 31), _
      New TEST_TRIANGLE3(17, 21, 22, 31, 21, 20), _
      New TEST_TRIANGLE3(23, 18, 22, 15, 30, 20), _
      New TEST_TRIANGLE3(18, 23, 19, 30, 15, 19), _
      New TEST_TRIANGLE3(9, 24, 8, 23, 9, 13), _
      New TEST_TRIANGLE3(10, 25, 24, 22, 8, 9), _
      New TEST_TRIANGLE3(24, 9, 10, 9, 23, 22), _
      New TEST_TRIANGLE3(25, 10, 11, 8, 22, 12), _
      New TEST_TRIANGLE3(15, 26, 11, 16, 5, 12), _
      New TEST_TRIANGLE3(19, 27, 26, 19, 2, 5), _
      New TEST_TRIANGLE3(26, 15, 19, 5, 16, 19), _
      New TEST_TRIANGLE3(23, 28, 27, 15, 7, 2), _
      New TEST_TRIANGLE3(27, 19, 23, 2, 19, 15), _
      New TEST_TRIANGLE3(22, 29, 28, 20, 11, 7), _
      New TEST_TRIANGLE3(28, 23, 22, 7, 15, 20), _
      New TEST_TRIANGLE3(21, 30, 29, 21, 10, 11), _
      New TEST_TRIANGLE3(29, 22, 21, 11, 20, 21), _
      New TEST_TRIANGLE3(20, 31, 30, 14, 6, 10), _
      New TEST_TRIANGLE3(30, 21, 20, 10, 21, 14), _
      New TEST_TRIANGLE3(16, 32, 31, 18, 3, 6), _
      New TEST_TRIANGLE3(31, 20, 16, 6, 14, 18), _
      New TEST_TRIANGLE3(12, 33, 32, 17, 4, 3), _
      New TEST_TRIANGLE3(32, 16, 12, 3, 18, 17), _
      New TEST_TRIANGLE3(33, 12, 8, 4, 17, 13) _
    }

    matrix_hood = New Single() { _
      1.0, 0.0, 0.0, 0.0, _
      0.0, 0.0, -1.0, 7.071537, _
      0.0, 1.0, 0.0, 188.5873, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_hood = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-12.686251, -13.593765, 4.345373, 0.556926, 0.352082), _
      New TEST_XYZ_UV(-12.686251, -13.593765, 10.0, 0.556926, 0.449285), _
      New TEST_XYZ_UV(-12.686251, -13.593765, 14.999999, 0.556926, 0.535235), _
      New TEST_XYZ_UV(-12.2475, -7.500015, 4.745705, 0.452175, 0.358963), _
      New TEST_XYZ_UV(-12.2475, -7.500015, 10.0, 0.452175, 0.449285), _
      New TEST_XYZ_UV(-12.2475, -7.500015, 15.000002, 0.452175, 0.535235), _
      New TEST_XYZ_UV(-12.075, -13.125015, -0.834731, 0.507569, 0.051131), _
      New TEST_XYZ_UV(-12.075, -13.125015, -0.834731, 0.548869, 0.263036), _
      New TEST_XYZ_UV(-12.075, -13.125015, 17.356451, 0.051131, 0.575742), _
      New TEST_XYZ_UV(-12.075, -13.125015, 17.356451, 0.092431, 0.051131), _
      New TEST_XYZ_UV(-12.075, -13.125015, 17.356451, 0.548869, 0.575742), _
      New TEST_XYZ_UV(-11.1225, -7.500015, 18.017338, 0.147825, 0.587103), _
      New TEST_XYZ_UV(-11.1225, -7.500015, 18.017338, 0.452175, 0.587103), _
      New TEST_XYZ_UV(-10.97341, -7.045685, -1.394344, 0.444365, 0.253416), _
      New TEST_XYZ_UV(-10.97341, -7.045685, -1.394344, 0.488633, 0.155635), _
      New TEST_XYZ_UV(-10.875, -0.000015, 4.745706, 0.32325, 0.358963), _
      New TEST_XYZ_UV(-10.874999, -0.000015, 10.000001, 0.32325, 0.449285), _
      New TEST_XYZ_UV(-10.874999, -0.000015, 15.000001, 0.32325, 0.535235), _
      New TEST_XYZ_UV(-10.509837, 0.314316, -1.003538, 0.317847, 0.260134), _
      New TEST_XYZ_UV(-10.15, 6.888611, 4.745706, 0.204834, 0.358963), _
      New TEST_XYZ_UV(-10.15, 6.888626, 10.000001, 0.204834, 0.449285), _
      New TEST_XYZ_UV(-10.15, 6.888626, 15.000001, 0.204834, 0.535235), _
      New TEST_XYZ_UV(-9.862501, -0.000015, 18.01734, 0.27675, 0.587103), _
      New TEST_XYZ_UV(-9.862501, -0.000015, 18.01734, 0.32325, 0.587103), _
      New TEST_XYZ_UV(-9.811886, 6.949356, -1.003537, 0.20379, 0.260134), _
      New TEST_XYZ_UV(-9.2125, 6.888626, 18.017338, 0.204834, 0.587103), _
      New TEST_XYZ_UV(-9.2125, 6.888626, 18.017338, 0.395166, 0.587103), _
      New TEST_XYZ_UV(-9.0625, 11.555817, 4.745706, 0.124605, 0.358963), _
      New TEST_XYZ_UV(-9.0625, 11.555817, 4.745706, 0.455784, 0.358963), _
      New TEST_XYZ_UV(-9.0625, 11.555817, 10.000001, 0.124605, 0.449285), _
      New TEST_XYZ_UV(-9.0625, 11.555817, 10.000001, 0.455784, 0.449285), _
      New TEST_XYZ_UV(-9.0625, 11.555817, 15.000001, 0.124605, 0.535235), _
      New TEST_XYZ_UV(-9.0625, 11.555817, 15.000001, 0.455784, 0.535235), _
      New TEST_XYZ_UV(-8.75, 11.494644, 18.750002, 0.125657, 0.599697), _
      New TEST_XYZ_UV(-8.75, 11.494644, 18.750002, 0.149588, 0.474343), _
      New TEST_XYZ_UV(-8.75, 11.494644, 18.750002, 0.450412, 0.599697), _
      New TEST_XYZ_UV(-8.75, 11.494644, 18.750002, 0.474343, 0.599697), _
      New TEST_XYZ_UV(-8.724386, 11.473206, -1.003537, 0.126025, 0.260134), _
      New TEST_XYZ_UV(-8.724386, 11.473206, -1.003537, 0.449972, 0.260134), _
      New TEST_XYZ_UV(-8.483761, 1.049942, -5.983692, 0.305201, 0.174525), _
      New TEST_XYZ_UV(-8.251538, -3.646225, -5.983693, 0.158156, 0.174525), _
      New TEST_XYZ_UV(-8.251538, -3.646225, -5.983693, 0.385928, 0.174525), _
      New TEST_XYZ_UV(-8.251538, -3.646225, -5.983693, 0.441844, 0.214072), _
      New TEST_XYZ_UV(-7.921363, 6.397614, -5.983692, 0.213275, 0.174525), _
      New TEST_XYZ_UV(-7.029969, 10.054321, -5.983692, 0.150416, 0.174525), _
      New TEST_XYZ_UV(-7.029969, 10.054321, -5.983692, 0.420845, 0.174525), _
      New TEST_XYZ_UV(-7.029969, 10.054321, -5.983692, 0.420845, 0.449584), _
      New TEST_XYZ_UV(-7.02375, -13.593765, -1.498884, 0.420738, 0.043074), _
      New TEST_XYZ_UV(-7.02375, -13.593765, 12.963342, 0.179262, 0.043074), _
      New TEST_XYZ_UV(-6.12375, -7.500015, 12.855682, 0.147825, 0.498374), _
      New TEST_XYZ_UV(-6.12375, -7.500015, 12.855682, 0.194733, 0.147825), _
      New TEST_XYZ_UV(-6.033381, -8.338348, -2.595666, 0.403714, 0.133414), _
      New TEST_XYZ_UV(-5.437499, -0.000015, 12.855683, 0.206529, 0.27675), _
      New TEST_XYZ_UV(-5.437499, -0.000015, 12.855683, 0.27675, 0.498374), _
      New TEST_XYZ_UV(-5.075, 7.499985, 13.900843, 0.212761, 0.405675), _
      New TEST_XYZ_UV(-5.075, 7.499985, 13.900843, 0.405675, 0.51634), _
      New TEST_XYZ_UV(-5.0, 13.372009, 18.01734, 0.21405, 0.506615), _
      New TEST_XYZ_UV(-5.0, 13.372009, 18.01734, 0.38595, 0.587103), _
      New TEST_XYZ_UV(-5.0, 14.778259, 4.745706, 0.38595, 0.358963), _
      New TEST_XYZ_UV(-5.0, 14.778259, 10.000001, 0.38595, 0.449285), _
      New TEST_XYZ_UV(-5.0, 14.778259, 15.000001, 0.38595, 0.535235), _
      New TEST_XYZ_UV(-4.898514, -0.446915, -11.064886, 0.330932, 0.087179), _
      New TEST_XYZ_UV(-4.830943, 14.585403, -1.003537, 0.383044, 0.260134), _
      New TEST_XYZ_UV(-4.830885, -3.226074, -11.064886, 0.216957, 0.087179), _
      New TEST_XYZ_UV(-4.830885, -3.226074, -11.064886, 0.378706, 0.087179), _
      New TEST_XYZ_UV(-4.679047, -4.798874, -5.983694, 0.219567, 0.174525), _
      New TEST_XYZ_UV(-4.679047, -4.798874, -5.983694, 0.380433, 0.194258), _
      New TEST_XYZ_UV(-4.570052, 2.671585, -11.064886, 0.277325, 0.087179), _
      New TEST_XYZ_UV(-4.105784, 4.764496, -11.064886, 0.241348, 0.087179), _
      New TEST_XYZ_UV(-4.105784, 4.764496, -11.064886, 0.370578, 0.358652), _
      New TEST_XYZ_UV(-3.899206, 12.565796, -5.983692, 0.367027, 0.174525), _
      New TEST_XYZ_UV(-3.899206, 12.565796, -5.983692, 0.367027, 0.492756), _
      New TEST_XYZ_UV(-2.703609, -3.826416, -11.064886, 0.253525, 0.087179), _
      New TEST_XYZ_UV(-2.436291, -4.473648, -14.868771, 0.25812, 0.02179), _
      New TEST_XYZ_UV(-2.436291, -4.473648, -14.868771, 0.34188, 0.199848), _
      New TEST_XYZ_UV(-2.436291, -4.473648, -14.868771, 0.400152, 0.02179), _
      New TEST_XYZ_UV(-2.253007, 6.217438, -11.064886, 0.338729, 0.383628), _
      New TEST_XYZ_UV(-2.122366, -3.328247, -15.181271, 0.336483, 0.219538), _
      New TEST_XYZ_UV(-2.122366, -3.328247, -15.181271, 0.380462, 0.016418), _
      New TEST_XYZ_UV(-2.070366, -0.444626, -14.868771, 0.330893, 0.02179), _
      New TEST_XYZ_UV(-2.070366, -0.444626, -14.868771, 0.33559, 0.269107), _
      New TEST_XYZ_UV(-1.978083, -1.848022, -15.181271, 0.334003, 0.244983), _
      New TEST_XYZ_UV(-1.978083, -1.848022, -15.181271, 0.355017, 0.016418), _
      New TEST_XYZ_UV(-1.244627, -4.680908, -15.181271, 0.278605, 0.016418), _
      New TEST_XYZ_UV(-1.052236, -0.432831, -15.181271, 0.318088, 0.26931), _
      New TEST_XYZ_UV(-0.872684, -4.099014, -16.118771, 0.284999, 0.000303), _
      New TEST_XYZ_UV(-0.872684, -4.099014, -16.118771, 0.315001, 0.206288), _
      New TEST_XYZ_UV(-0.814505, -2.895325, -16.118771, 0.314001, 0.22698), _
      New TEST_XYZ_UV(-0.000001, -2.832779, -16.118771, 0.3, 0.228055), _
      New TEST_XYZ_UV(-0.000001, -4.099014, -16.118771, 0.3, 0.206288), _
      New TEST_XYZ_UV(-0.000001, -4.099014, -16.118771, 0.3, 0.000303), _
      New TEST_XYZ_UV(-0.000001, -0.147522, -15.181271, 0.3, 0.274214), _
      New TEST_XYZ_UV(-0.000001, -4.680908, -15.181271, 0.3, 0.016418), _
      New TEST_XYZ_UV(-0.000001, 6.915802, -11.064886, 0.3, 0.395633), _
      New TEST_XYZ_UV(0.0, -3.826416, -11.064886, 0.3, 0.087179), _
      New TEST_XYZ_UV(0.0, 13.729355, -5.983692, 0.3, 0.174525), _
      New TEST_XYZ_UV(0.0, 13.729355, -5.983692, 0.3, 0.512758), _
      New TEST_XYZ_UV(0.0, 16.03566, -1.003538, 0.3, 0.260134), _
      New TEST_XYZ_UV(0.0, -4.798874, -5.983694, 0.3, 0.194258), _
      New TEST_XYZ_UV(0.0, -4.798874, -5.983694, 0.3, 0.174525), _
      New TEST_XYZ_UV(0.0, 16.298782, 4.745706, 0.3, 0.358963), _
      New TEST_XYZ_UV(0.0, -8.338348, -2.595666, 0.3, 0.133414), _
      New TEST_XYZ_UV(0.0, -13.593765, 11.91818, 0.3, 0.043074), _
      New TEST_XYZ_UV(0.0, -7.500015, 11.810521, 0.3, 0.147825), _
      New TEST_XYZ_UV(0.0, -0.000015, 11.810521, 0.3, 0.27675), _
      New TEST_XYZ_UV(0.0, 7.889633, 12.855682, 0.3, 0.412373), _
      New TEST_XYZ_UV(0.0, 14.502899, 18.017342, 0.3, 0.587103), _
      New TEST_XYZ_UV(0.0, 14.502899, 18.017342, 0.3, 0.526055), _
      New TEST_XYZ_UV(0.0, 16.298782, 10.000001, 0.3, 0.449285), _
      New TEST_XYZ_UV(0.0, 16.298782, 15.000001, 0.3, 0.535235), _
      New TEST_XYZ_UV(0.0, -13.593765, -1.498884, 0.3, 0.043074), _
      New TEST_XYZ_UV(0.814503, -2.895325, -16.118771, 0.285999, 0.22698), _
      New TEST_XYZ_UV(0.872682, -4.099014, -16.118771, 0.284999, 0.206288), _
      New TEST_XYZ_UV(0.872682, -4.099014, -16.118771, 0.315001, 0.000303), _
      New TEST_XYZ_UV(1.052234, -0.432831, -15.181271, 0.281912, 0.26931), _
      New TEST_XYZ_UV(1.244626, -4.680908, -15.181271, 0.321395, 0.016418), _
      New TEST_XYZ_UV(1.978081, -1.848022, -15.181271, 0.244983, 0.016418), _
      New TEST_XYZ_UV(1.978081, -1.848022, -15.181271, 0.265997, 0.244983), _
      New TEST_XYZ_UV(2.070365, -0.444626, -14.868771, 0.26441, 0.269107), _
      New TEST_XYZ_UV(2.070365, -0.444626, -14.868771, 0.269107, 0.02179), _
      New TEST_XYZ_UV(2.122364, -3.328247, -15.181271, 0.219538, 0.016418), _
      New TEST_XYZ_UV(2.122364, -3.328247, -15.181271, 0.263517, 0.219538), _
      New TEST_XYZ_UV(2.253006, 6.217438, -11.064886, 0.261271, 0.383628), _
      New TEST_XYZ_UV(2.436289, -4.473648, -14.868771, 0.199848, 0.02179), _
      New TEST_XYZ_UV(2.436289, -4.473648, -14.868771, 0.25812, 0.199848), _
      New TEST_XYZ_UV(2.436289, -4.473648, -14.868771, 0.34188, 0.02179), _
      New TEST_XYZ_UV(2.703608, -3.826416, -11.064886, 0.346475, 0.087179), _
      New TEST_XYZ_UV(3.899206, 12.565796, -5.983692, 0.232973, 0.174525), _
      New TEST_XYZ_UV(3.899206, 12.565796, -5.983692, 0.232973, 0.492756), _
      New TEST_XYZ_UV(4.105783, 4.764496, -11.064886, 0.229422, 0.358652), _
      New TEST_XYZ_UV(4.105783, 4.764496, -11.064886, 0.358652, 0.087179), _
      New TEST_XYZ_UV(4.570049, 2.671585, -11.064886, 0.322675, 0.087179), _
      New TEST_XYZ_UV(4.679047, -4.798874, -5.983694, 0.219567, 0.194258), _
      New TEST_XYZ_UV(4.679047, -4.798874, -5.983694, 0.380433, 0.174525), _
      New TEST_XYZ_UV(4.830884, -3.226074, -11.064886, 0.221294, 0.087179), _
      New TEST_XYZ_UV(4.830884, -3.226074, -11.064886, 0.383043, 0.087179), _
      New TEST_XYZ_UV(4.830943, 14.585403, -1.003537, 0.216956, 0.260134), _
      New TEST_XYZ_UV(4.898512, -0.446915, -11.064886, 0.269068, 0.087179), _
      New TEST_XYZ_UV(5.0, 13.372009, 18.01734, 0.21405, 0.587103), _
      New TEST_XYZ_UV(5.0, 13.372009, 18.01734, 0.38595, 0.506615), _
      New TEST_XYZ_UV(5.0, 14.778259, 4.745706, 0.21405, 0.358963), _
      New TEST_XYZ_UV(5.0, 14.778259, 10.000001, 0.21405, 0.449285), _
      New TEST_XYZ_UV(5.0, 14.778259, 15.000001, 0.21405, 0.535235), _
      New TEST_XYZ_UV(5.075, 7.499985, 13.900843, 0.194325, 0.51634), _
      New TEST_XYZ_UV(5.075, 7.499985, 13.900843, 0.387239, 0.405675), _
      New TEST_XYZ_UV(5.4375, -0.000015, 12.855683, 0.32325, 0.498374), _
      New TEST_XYZ_UV(5.4375, -0.000015, 12.855683, 0.393471, 0.27675), _
      New TEST_XYZ_UV(6.033381, -8.338348, -2.595666, 0.196286, 0.133414), _
      New TEST_XYZ_UV(6.12375, -7.500015, 12.855681, 0.405267, 0.147825), _
      New TEST_XYZ_UV(6.12375, -7.500015, 12.855681, 0.452175, 0.498374), _
      New TEST_XYZ_UV(7.02375, -13.593765, -1.498884, 0.179262, 0.043074), _
      New TEST_XYZ_UV(7.02375, -13.593765, 12.963342, 0.420738, 0.043074), _
      New TEST_XYZ_UV(7.02375, -13.593765, 12.963342, 0.556926, 0.500224), _
      New TEST_XYZ_UV(7.029968, 10.054321, -5.983692, 0.179155, 0.174525), _
      New TEST_XYZ_UV(7.029968, 10.054321, -5.983692, 0.179155, 0.449584), _
      New TEST_XYZ_UV(7.029968, 10.054321, -5.983692, 0.449584, 0.174525), _
      New TEST_XYZ_UV(7.921362, 6.397614, -5.983692, 0.386725, 0.174525), _
      New TEST_XYZ_UV(8.251537, -3.646225, -5.983694, 0.214072, 0.174525), _
      New TEST_XYZ_UV(8.251537, -3.646225, -5.983694, 0.441844, 0.174525), _
      New TEST_XYZ_UV(8.483759, 1.049942, -5.983692, 0.294799, 0.174525), _
      New TEST_XYZ_UV(8.724385, 11.473206, -1.003537, 0.150028, 0.260134), _
      New TEST_XYZ_UV(8.724385, 11.473206, -1.003537, 0.473975, 0.260134), _
      New TEST_XYZ_UV(8.75, 11.494644, 18.750002, 0.125657, 0.599697), _
      New TEST_XYZ_UV(8.75, 11.494644, 18.750002, 0.149587, 0.599697), _
      New TEST_XYZ_UV(8.75, 11.494644, 18.750002, 0.450413, 0.474343), _
      New TEST_XYZ_UV(8.75, 11.494644, 18.750002, 0.474343, 0.599697), _
      New TEST_XYZ_UV(9.0625, 11.555817, 4.745706, 0.144215, 0.358963), _
      New TEST_XYZ_UV(9.0625, 11.555817, 4.745706, 0.475395, 0.358963), _
      New TEST_XYZ_UV(9.0625, 11.555817, 10.000001, 0.144215, 0.449285), _
      New TEST_XYZ_UV(9.0625, 11.555817, 10.000001, 0.475395, 0.449285), _
      New TEST_XYZ_UV(9.0625, 11.555817, 15.000001, 0.144215, 0.535235), _
      New TEST_XYZ_UV(9.0625, 11.555817, 15.000001, 0.475395, 0.535235), _
      New TEST_XYZ_UV(9.212499, 6.888626, 18.017338, 0.204834, 0.587103), _
      New TEST_XYZ_UV(9.212499, 6.888626, 18.017338, 0.395166, 0.587103), _
      New TEST_XYZ_UV(9.811884, 6.949356, -1.003538, 0.39621, 0.260134), _
      New TEST_XYZ_UV(9.8625, -0.000015, 18.01734, 0.27675, 0.587103), _
      New TEST_XYZ_UV(9.8625, -0.000015, 18.01734, 0.32325, 0.587103), _
      New TEST_XYZ_UV(10.149999, 6.888611, 4.745706, 0.395166, 0.358963), _
      New TEST_XYZ_UV(10.149999, 6.888626, 10.000001, 0.395166, 0.449285), _
      New TEST_XYZ_UV(10.149999, 6.888626, 15.000001, 0.395166, 0.535235), _
      New TEST_XYZ_UV(10.509836, 0.314316, -1.003538, 0.282153, 0.260134), _
      New TEST_XYZ_UV(10.874999, -0.000015, 4.745706, 0.27675, 0.358963), _
      New TEST_XYZ_UV(10.874999, -0.000015, 10.000001, 0.27675, 0.449285), _
      New TEST_XYZ_UV(10.874999, -0.000015, 15.000001, 0.27675, 0.535235), _
      New TEST_XYZ_UV(10.973409, -7.045685, -1.394344, 0.111367, 0.155635), _
      New TEST_XYZ_UV(10.973409, -7.045685, -1.394344, 0.155635, 0.253416), _
      New TEST_XYZ_UV(10.973409, -7.045685, -1.394344, 0.488633, 0.253416), _
      New TEST_XYZ_UV(11.122499, -7.500015, 18.017338, 0.147825, 0.587103), _
      New TEST_XYZ_UV(11.122499, -7.500015, 18.017338, 0.452175, 0.587103), _
      New TEST_XYZ_UV(11.122499, -7.500015, 18.017338, 0.491196, 0.147825), _
      New TEST_XYZ_UV(12.074999, -13.125015, -0.834731, 0.051131, 0.263036), _
      New TEST_XYZ_UV(12.074999, -13.125015, -0.834731, 0.092431, 0.051131), _
      New TEST_XYZ_UV(12.074999, -13.125015, 17.356451, 0.051131, 0.575742), _
      New TEST_XYZ_UV(12.074999, -13.125015, 17.356451, 0.507569, 0.051131), _
      New TEST_XYZ_UV(12.247499, -7.500015, 4.745705, 0.147825, 0.358963), _
      New TEST_XYZ_UV(12.247499, -7.500015, 10.0, 0.147825, 0.449285), _
      New TEST_XYZ_UV(12.247499, -7.500015, 15.000001, 0.147825, 0.535235), _
      New TEST_XYZ_UV(12.68625, -13.593765, 4.345373, 0.043074, 0.352082), _
      New TEST_XYZ_UV(12.68625, -13.593765, 10.0, 0.043074, 0.449285), _
      New TEST_XYZ_UV(12.68625, -13.593765, 14.999999, 0.043074, 0.535235) _
    }


    normal_hood = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.997418, 0.071814, 0.0), _
      New TEST_NORMAL(-0.99217, 0.099126, -0.075979), _
      New TEST_NORMAL(-0.992018, 0.1261, 0.0), _
      New TEST_NORMAL(-0.991242, 0.07137, 0.111109), _
      New TEST_NORMAL(-0.990154, 0.113233, -0.0823), _
      New TEST_NORMAL(-0.989803, 0.142442, 0.0), _
      New TEST_NORMAL(-0.989321, 0.143138, -0.027472), _
      New TEST_NORMAL(-0.986106, 0.166119, 0.0), _
      New TEST_NORMAL(-0.985638, 0.166392, -0.028836), _
      New TEST_NORMAL(-0.976963, 0.138373, 0.162466), _
      New TEST_NORMAL(-0.976888, 0.132995, 0.167339), _
      New TEST_NORMAL(-0.975576, 0.161472, 0.148926), _
      New TEST_NORMAL(-0.968769, 0.103995, -0.225105), _
      New TEST_NORMAL(-0.96274, 0.167167, -0.212571), _
      New TEST_NORMAL(-0.870242, 0.04944, -0.490137), _
      New TEST_NORMAL(-0.856206, 0.154381, -0.493029), _
      New TEST_NORMAL(-0.856181, 0.513064, 0.06099), _
      New TEST_NORMAL(-0.845762, 0.532821, -0.02807), _
      New TEST_NORMAL(-0.844821, 0.535048, 0.0), _
      New TEST_NORMAL(-0.819344, 0.527323, -0.224957), _
      New TEST_NORMAL(-0.816445, -0.085984, -0.570985), _
      New TEST_NORMAL(-0.815022, 0.034313, -0.578413), _
      New TEST_NORMAL(-0.780617, 0.051305, -0.622901), _
      New TEST_NORMAL(-0.780065, 0.12691, -0.612693), _
      New TEST_NORMAL(-0.711286, 0.031843, -0.702181), _
      New TEST_NORMAL(-0.704107, -0.550571, -0.448446), _
      New TEST_NORMAL(-0.691138, 0.455293, -0.561281), _
      New TEST_NORMAL(-0.671736, -0.395852, -0.626157), _
      New TEST_NORMAL(-0.63242, 0.147736, -0.760407), _
      New TEST_NORMAL(-0.628796, -0.660765, -0.409885), _
      New TEST_NORMAL(-0.576042, 0.342721, -0.742104), _
      New TEST_NORMAL(-0.53349, 0.265277, -0.803129), _
      New TEST_NORMAL(-0.482535, -0.082864, 0.871948), _
      New TEST_NORMAL(-0.464428, 0.885336, -0.022039), _
      New TEST_NORMAL(-0.464354, 0.88565, 0.0), _
      New TEST_NORMAL(-0.463799, -0.051559, 0.884439), _
      New TEST_NORMAL(-0.45386, -0.079075, 0.887557), _
      New TEST_NORMAL(-0.453432, 0.223944, 0.862699), _
      New TEST_NORMAL(-0.450454, 0.863959, -0.22509), _
      New TEST_NORMAL(-0.43225, -0.307622, 0.847661), _
      New TEST_NORMAL(-0.423443, 0.890056, 0.168807), _
      New TEST_NORMAL(-0.413397, -0.040958, 0.909629), _
      New TEST_NORMAL(-0.367933, 0.710931, -0.599335), _
      New TEST_NORMAL(-0.281031, 0.139918, -0.949444), _
      New TEST_NORMAL(-0.273634, 0.51715, -0.810975), _
      New TEST_NORMAL(-0.269521, 0.012217, 0.962917), _
      New TEST_NORMAL(-0.252299, -0.41697, -0.873202), _
      New TEST_NORMAL(-0.217765, 0.385801, -0.896513), _
      New TEST_NORMAL(-0.195186, -0.006956, 0.980742), _
      New TEST_NORMAL(-0.179451, 0.008871, 0.983727), _
      New TEST_NORMAL(-0.138826, -0.839831, -0.524796), _
      New TEST_NORMAL(-0.138237, -0.422873, -0.895583), _
      New TEST_NORMAL(-0.131818, -0.990835, -0.029489), _
      New TEST_NORMAL(-0.124768, -0.964776, -0.231605), _
      New TEST_NORMAL(-0.079427, -0.189283, -0.978705), _
      New TEST_NORMAL(-0.06522, 0.304149, 0.950389), _
      New TEST_NORMAL(-0.005408, 0.012234, 0.999911), _
      New TEST_NORMAL(-0.005026, 0.003664, 0.999981), _
      New TEST_NORMAL(-0.004428, -0.070131, 0.997528), _
      New TEST_NORMAL(-0.000583, 0.973407, -0.22908), _
      New TEST_NORMAL(-0.000402, 0.999751, -0.022331), _
      New TEST_NORMAL(-0.000024, 0.793019, -0.609197), _
      New TEST_NORMAL(0.0, -0.99997, 0.007789), _
      New TEST_NORMAL(0.0, -0.984655, -0.17451), _
      New TEST_NORMAL(0.0, -0.878455, -0.477825), _
      New TEST_NORMAL(0.0, -0.486127, -0.873888), _
      New TEST_NORMAL(0.0, -0.465891, -0.884842), _
      New TEST_NORMAL(0.0, -0.204294, -0.97891), _
      New TEST_NORMAL(0.0, 1.0, 0.0), _
      New TEST_NORMAL(0.000418, 0.558797, -0.829305), _
      New TEST_NORMAL(0.000787, 0.43568, -0.900101), _
      New TEST_NORMAL(0.004171, -0.381301, 0.924442), _
      New TEST_NORMAL(0.00439, 0.18005, -0.983648), _
      New TEST_NORMAL(0.008584, 0.969385, 0.245397), _
      New TEST_NORMAL(0.026244, 0.296645, 0.954627), _
      New TEST_NORMAL(0.108497, -0.14955, -0.982783), _
      New TEST_NORMAL(0.13176, -0.965249, -0.225685), _
      New TEST_NORMAL(0.140848, -0.989201, -0.040532), _
      New TEST_NORMAL(0.141792, 0.316454, 0.937951), _
      New TEST_NORMAL(0.158287, -0.841479, -0.516583), _
      New TEST_NORMAL(0.167396, -0.413389, -0.895035), _
      New TEST_NORMAL(0.173372, 0.041515, 0.983981), _
      New TEST_NORMAL(0.189096, 0.400056, -0.896771), _
      New TEST_NORMAL(0.219538, -0.012131, 0.975529), _
      New TEST_NORMAL(0.240379, -0.065814, 0.968445), _
      New TEST_NORMAL(0.254318, -0.414619, -0.873735), _
      New TEST_NORMAL(0.272225, 0.519819, -0.809742), _
      New TEST_NORMAL(0.283152, 0.13652, -0.949309), _
      New TEST_NORMAL(0.367853, 0.710887, -0.599436), _
      New TEST_NORMAL(0.392214, 0.328576, 0.859189), _
      New TEST_NORMAL(0.435979, 0.876552, 0.203909), _
      New TEST_NORMAL(0.436176, -0.311811, 0.844111), _
      New TEST_NORMAL(0.436639, -0.043358, 0.898591), _
      New TEST_NORMAL(0.451422, -0.054734, 0.89063), _
      New TEST_NORMAL(0.45151, 0.86341, -0.225084), _
      New TEST_NORMAL(0.460545, -0.026258, 0.887248), _
      New TEST_NORMAL(0.464354, 0.88565, 0.0), _
      New TEST_NORMAL(0.465159, 0.884952, -0.022072), _
      New TEST_NORMAL(0.485359, -0.097467, 0.868865), _
      New TEST_NORMAL(0.579104, 0.264474, -0.771163), _
      New TEST_NORMAL(0.582554, 0.341097, -0.737756), _
      New TEST_NORMAL(0.613332, -0.694742, -0.37571), _
      New TEST_NORMAL(0.677866, 0.103818, -0.727819), _
      New TEST_NORMAL(0.691097, 0.455294, -0.561331), _
      New TEST_NORMAL(0.698185, 0.038319, -0.714891), _
      New TEST_NORMAL(0.700244, -0.564017, -0.437657), _
      New TEST_NORMAL(0.700368, -0.405488, -0.587421), _
      New TEST_NORMAL(0.746927, 0.043382, -0.663489), _
      New TEST_NORMAL(0.775001, 0.128995, -0.618655), _
      New TEST_NORMAL(0.807982, -0.067048, -0.58538), _
      New TEST_NORMAL(0.813622, 0.039485, -0.580052), _
      New TEST_NORMAL(0.818388, 0.528706, -0.225191), _
      New TEST_NORMAL(0.828164, 0.556249, 0.068791), _
      New TEST_NORMAL(0.844821, 0.535048, 0.0), _
      New TEST_NORMAL(0.845156, 0.533804, -0.02766), _
      New TEST_NORMAL(0.855114, 0.154573, -0.49486), _
      New TEST_NORMAL(0.878057, 0.033149, -0.477406), _
      New TEST_NORMAL(0.962823, 0.166065, -0.21306), _
      New TEST_NORMAL(0.970711, 0.072722, -0.228982), _
      New TEST_NORMAL(0.977399, 0.121049, 0.173316), _
      New TEST_NORMAL(0.977425, 0.139335, 0.158828), _
      New TEST_NORMAL(0.98188, 0.141074, 0.12653), _
      New TEST_NORMAL(0.985784, 0.165656, -0.02807), _
      New TEST_NORMAL(0.986106, 0.166119, 0.0), _
      New TEST_NORMAL(0.987065, 0.136993, -0.083276), _
      New TEST_NORMAL(0.987825, 0.0918, 0.125593), _
      New TEST_NORMAL(0.989803, 0.142442, 0.0), _
      New TEST_NORMAL(0.99097, 0.126549, -0.044318), _
      New TEST_NORMAL(0.992018, 0.1261, 0.0), _
      New TEST_NORMAL(0.995608, 0.075335, -0.055579), _
      New TEST_NORMAL(0.997418, 0.071814, 0.0) _
    }

    triangle3_hood = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(51, 14, 6, 51, 20, 22), _
      New TEST_TRIANGLE3(6, 47, 51, 22, 54, 51), _
      New TEST_TRIANGLE3(101, 51, 47, 66, 51, 54), _
      New TEST_TRIANGLE3(47, 110, 101, 54, 67, 66), _
      New TEST_TRIANGLE3(147, 101, 110, 80, 66, 67), _
      New TEST_TRIANGLE3(110, 150, 147, 67, 75, 80), _
      New TEST_TRIANGLE3(184, 147, 150, 109, 80, 75), _
      New TEST_TRIANGLE3(150, 191, 184, 75, 107, 109), _
      New TEST_TRIANGLE3(86, 77, 74, 46, 24, 29), _
      New TEST_TRIANGLE3(73, 83, 85, 29, 53, 46), _
      New TEST_TRIANGLE3(90, 85, 83, 65, 46, 53), _
      New TEST_TRIANGLE3(83, 92, 90, 53, 63, 65), _
      New TEST_TRIANGLE3(113, 90, 92, 85, 65, 63), _
      New TEST_TRIANGLE3(92, 115, 113, 63, 76, 85), _
      New TEST_TRIANGLE3(121, 112, 124, 104, 85, 101), _
      New TEST_TRIANGLE3(115, 125, 113, 76, 101, 85), _
      New TEST_TRIANGLE3(87, 81, 77, 43, 28, 24), _
      New TEST_TRIANGLE3(77, 86, 87, 24, 46, 43), _
      New TEST_TRIANGLE3(88, 87, 86, 72, 43, 46), _
      New TEST_TRIANGLE3(86, 89, 88, 46, 65, 72), _
      New TEST_TRIANGLE3(111, 88, 89, 87, 72, 65), _
      New TEST_TRIANGLE3(89, 112, 111, 65, 85, 87), _
      New TEST_TRIANGLE3(117, 111, 112, 102, 87, 85), _
      New TEST_TRIANGLE3(112, 121, 117, 85, 104, 102), _
      New TEST_TRIANGLE3(84, 80, 81, 47, 31, 28), _
      New TEST_TRIANGLE3(81, 87, 84, 28, 43, 47), _
      New TEST_TRIANGLE3(91, 84, 87, 70, 47, 43), _
      New TEST_TRIANGLE3(87, 88, 91, 43, 72, 70), _
      New TEST_TRIANGLE3(114, 91, 88, 82, 70, 72), _
      New TEST_TRIANGLE3(88, 111, 114, 72, 87, 82), _
      New TEST_TRIANGLE3(118, 114, 111, 99, 82, 87), _
      New TEST_TRIANGLE3(111, 117, 118, 87, 102, 99), _
      New TEST_TRIANGLE3(50, 48, 9, 93, 92, 41), _
      New TEST_TRIANGLE3(8, 11, 49, 41, 48, 93), _
      New TEST_TRIANGLE3(103, 102, 48, 57, 56, 92), _
      New TEST_TRIANGLE3(48, 50, 103, 92, 93, 57), _
      New TEST_TRIANGLE3(148, 151, 102, 35, 36, 56), _
      New TEST_TRIANGLE3(102, 103, 148, 56, 57, 35), _
      New TEST_TRIANGLE3(189, 193, 151, 83, 95, 36), _
      New TEST_TRIANGLE3(152, 149, 188, 36, 35, 83), _
      New TEST_TRIANGLE3(53, 49, 11, 98, 93, 48), _
      New TEST_TRIANGLE3(11, 22, 53, 48, 49, 98), _
      New TEST_TRIANGLE3(104, 103, 50, 58, 57, 93), _
      New TEST_TRIANGLE3(50, 52, 104, 93, 98, 58), _
      New TEST_TRIANGLE3(146, 148, 103, 32, 35, 57), _
      New TEST_TRIANGLE3(103, 104, 146, 57, 58, 32), _
      New TEST_TRIANGLE3(176, 188, 149, 81, 83, 35), _
      New TEST_TRIANGLE3(149, 145, 176, 35, 32, 81), _
      New TEST_TRIANGLE3(55, 53, 22, 91, 98, 49), _
      New TEST_TRIANGLE3(22, 26, 55, 49, 45, 91), _
      New TEST_TRIANGLE3(105, 104, 52, 71, 58, 98), _
      New TEST_TRIANGLE3(52, 54, 105, 98, 91, 71), _
      New TEST_TRIANGLE3(144, 146, 104, 39, 32, 58), _
      New TEST_TRIANGLE3(104, 105, 144, 58, 71, 39), _
      New TEST_TRIANGLE3(172, 176, 145, 84, 81, 32), _
      New TEST_TRIANGLE3(145, 143, 172, 32, 39, 84), _
      New TEST_TRIANGLE3(56, 54, 34, 55, 91, 37), _
      New TEST_TRIANGLE3(26, 36, 55, 45, 37, 91), _
      New TEST_TRIANGLE3(107, 105, 54, 74, 71, 91), _
      New TEST_TRIANGLE3(54, 56, 107, 91, 55, 74), _
      New TEST_TRIANGLE3(139, 144, 105, 78, 39, 71), _
      New TEST_TRIANGLE3(105, 107, 139, 71, 74, 78), _
      New TEST_TRIANGLE3(162, 172, 143, 89, 84, 39), _
      New TEST_TRIANGLE3(144, 139, 164, 39, 78, 89), _
      New TEST_TRIANGLE3(194, 185, 190, 124, 109, 107), _
      New TEST_TRIANGLE3(190, 197, 194, 107, 129, 124), _
      New TEST_TRIANGLE3(181, 180, 185, 127, 118, 109), _
      New TEST_TRIANGLE3(185, 194, 181, 109, 124, 127), _
      New TEST_TRIANGLE3(177, 174, 180, 122, 117, 118), _
      New TEST_TRIANGLE3(180, 181, 177, 118, 127, 122), _
      New TEST_TRIANGLE3(167, 161, 174, 114, 111, 117), _
      New TEST_TRIANGLE3(174, 177, 167, 117, 122, 114), _
      New TEST_TRIANGLE3(195, 194, 197, 128, 124, 129), _
      New TEST_TRIANGLE3(197, 198, 195, 129, 130, 128), _
      New TEST_TRIANGLE3(182, 181, 194, 126, 127, 124), _
      New TEST_TRIANGLE3(194, 195, 182, 124, 128, 126), _
      New TEST_TRIANGLE3(178, 177, 181, 123, 122, 127), _
      New TEST_TRIANGLE3(181, 182, 178, 127, 126, 123), _
      New TEST_TRIANGLE3(169, 167, 177, 113, 114, 122), _
      New TEST_TRIANGLE3(177, 178, 169, 122, 123, 113), _
      New TEST_TRIANGLE3(196, 195, 198, 119, 128, 130), _
      New TEST_TRIANGLE3(198, 199, 196, 130, 125, 119), _
      New TEST_TRIANGLE3(183, 182, 195, 120, 126, 128), _
      New TEST_TRIANGLE3(195, 196, 183, 128, 119, 120), _
      New TEST_TRIANGLE3(179, 178, 182, 121, 123, 126), _
      New TEST_TRIANGLE3(182, 183, 179, 126, 120, 121), _
      New TEST_TRIANGLE3(171, 169, 178, 112, 113, 123), _
      New TEST_TRIANGLE3(178, 179, 171, 123, 121, 112), _
      New TEST_TRIANGLE3(187, 196, 199, 83, 119, 125), _
      New TEST_TRIANGLE3(199, 192, 187, 125, 95, 83), _
      New TEST_TRIANGLE3(175, 183, 196, 81, 120, 119), _
      New TEST_TRIANGLE3(196, 187, 175, 119, 83, 81), _
      New TEST_TRIANGLE3(173, 179, 183, 84, 121, 120), _
      New TEST_TRIANGLE3(183, 175, 173, 120, 81, 84), _
      New TEST_TRIANGLE3(165, 171, 179, 89, 112, 121), _
      New TEST_TRIANGLE3(179, 173, 165, 121, 84, 89), _
      New TEST_TRIANGLE3(140, 136, 160, 97, 94, 111), _
      New TEST_TRIANGLE3(160, 166, 140, 111, 114, 97), _
      New TEST_TRIANGLE3(100, 97, 136, 60, 59, 94), _
      New TEST_TRIANGLE3(136, 140, 100, 94, 97, 60), _
      New TEST_TRIANGLE3(58, 62, 97, 33, 38, 59), _
      New TEST_TRIANGLE3(97, 100, 58, 59, 60, 33), _
      New TEST_TRIANGLE3(28, 38, 62, 17, 19, 38), _
      New TEST_TRIANGLE3(62, 58, 28, 38, 33, 17), _
      New TEST_TRIANGLE3(141, 140, 166, 96, 97, 114), _
      New TEST_TRIANGLE3(166, 168, 141, 114, 113, 96), _
      New TEST_TRIANGLE3(108, 100, 140, 68, 60, 97), _
      New TEST_TRIANGLE3(140, 141, 108, 97, 96, 68), _
      New TEST_TRIANGLE3(59, 58, 100, 34, 33, 60), _
      New TEST_TRIANGLE3(100, 108, 59, 60, 68, 34), _
      New TEST_TRIANGLE3(30, 28, 58, 18, 17, 33), _
      New TEST_TRIANGLE3(58, 59, 30, 33, 34, 18), _
      New TEST_TRIANGLE3(142, 141, 168, 90, 96, 113), _
      New TEST_TRIANGLE3(168, 170, 142, 113, 112, 90), _
      New TEST_TRIANGLE3(109, 108, 141, 73, 68, 96), _
      New TEST_TRIANGLE3(141, 142, 109, 96, 90, 73), _
      New TEST_TRIANGLE3(60, 59, 108, 40, 34, 68), _
      New TEST_TRIANGLE3(108, 109, 60, 68, 73, 40), _
      New TEST_TRIANGLE3(32, 30, 59, 16, 18, 34), _
      New TEST_TRIANGLE3(59, 60, 32, 34, 40, 16), _
      New TEST_TRIANGLE3(138, 142, 170, 78, 90, 112), _
      New TEST_TRIANGLE3(170, 163, 138, 112, 89, 78), _
      New TEST_TRIANGLE3(106, 109, 142, 74, 73, 90), _
      New TEST_TRIANGLE3(142, 138, 106, 90, 78, 74), _
      New TEST_TRIANGLE3(57, 60, 109, 55, 40, 73), _
      New TEST_TRIANGLE3(109, 106, 57, 73, 74, 55), _
      New TEST_TRIANGLE3(35, 32, 60, 37, 16, 40), _
      New TEST_TRIANGLE3(60, 57, 35, 40, 55, 37), _
      New TEST_TRIANGLE3(19, 24, 37, 8, 13, 19), _
      New TEST_TRIANGLE3(37, 27, 19, 19, 17, 8), _
      New TEST_TRIANGLE3(15, 18, 24, 6, 12, 13), _
      New TEST_TRIANGLE3(24, 19, 15, 13, 8, 6), _
      New TEST_TRIANGLE3(3, 13, 18, 4, 20, 12), _
      New TEST_TRIANGLE3(18, 15, 3, 12, 6, 4), _
      New TEST_TRIANGLE3(0, 7, 13, 1, 22, 20), _
      New TEST_TRIANGLE3(13, 3, 0, 20, 4, 1), _
      New TEST_TRIANGLE3(20, 19, 27, 7, 8, 17), _
      New TEST_TRIANGLE3(27, 29, 20, 17, 18, 7), _
      New TEST_TRIANGLE3(16, 15, 19, 5, 6, 8), _
      New TEST_TRIANGLE3(19, 20, 16, 8, 7, 5), _
      New TEST_TRIANGLE3(4, 3, 15, 2, 4, 6), _
      New TEST_TRIANGLE3(15, 16, 4, 6, 5, 2), _
      New TEST_TRIANGLE3(1, 0, 3, 0, 1, 4), _
      New TEST_TRIANGLE3(3, 4, 1, 4, 2, 0), _
      New TEST_TRIANGLE3(21, 20, 29, 11, 7, 18), _
      New TEST_TRIANGLE3(29, 31, 21, 18, 16, 11), _
      New TEST_TRIANGLE3(17, 16, 20, 9, 5, 7), _
      New TEST_TRIANGLE3(20, 21, 17, 7, 11, 9), _
      New TEST_TRIANGLE3(5, 4, 16, 10, 2, 5), _
      New TEST_TRIANGLE3(16, 17, 5, 5, 9, 10), _
      New TEST_TRIANGLE3(2, 1, 4, 3, 0, 2), _
      New TEST_TRIANGLE3(4, 5, 2, 2, 10, 3), _
      New TEST_TRIANGLE3(25, 21, 31, 45, 11, 16), _
      New TEST_TRIANGLE3(31, 33, 25, 16, 37, 45), _
      New TEST_TRIANGLE3(23, 17, 21, 49, 9, 11), _
      New TEST_TRIANGLE3(21, 25, 23, 11, 45, 49), _
      New TEST_TRIANGLE3(12, 5, 17, 48, 10, 9), _
      New TEST_TRIANGLE3(17, 23, 12, 9, 49, 48), _
      New TEST_TRIANGLE3(10, 2, 5, 41, 3, 10), _
      New TEST_TRIANGLE3(5, 12, 10, 10, 48, 41), _
      New TEST_TRIANGLE3(42, 14, 51, 27, 20, 51), _
      New TEST_TRIANGLE3(51, 66, 42, 51, 50, 27), _
      New TEST_TRIANGLE3(66, 51, 101, 50, 51, 66), _
      New TEST_TRIANGLE3(101, 98, 66, 66, 64, 50), _
      New TEST_TRIANGLE3(98, 101, 147, 64, 66, 80), _
      New TEST_TRIANGLE3(147, 132, 98, 80, 79, 64), _
      New TEST_TRIANGLE3(132, 147, 184, 79, 80, 109), _
      New TEST_TRIANGLE3(186, 158, 133, 109, 106, 79), _
      New TEST_TRIANGLE3(39, 18, 13, 14, 12, 20), _
      New TEST_TRIANGLE3(13, 41, 39, 20, 27, 14), _
      New TEST_TRIANGLE3(157, 185, 180, 106, 109, 118), _
      New TEST_TRIANGLE3(180, 159, 157, 118, 116, 106), _
      New TEST_TRIANGLE3(43, 24, 18, 15, 13, 12), _
      New TEST_TRIANGLE3(18, 39, 43, 12, 14, 15), _
      New TEST_TRIANGLE3(159, 180, 174, 116, 118, 117), _
      New TEST_TRIANGLE3(174, 156, 159, 117, 115, 116), _
      New TEST_TRIANGLE3(44, 37, 24, 26, 19, 13), _
      New TEST_TRIANGLE3(24, 43, 44, 13, 15, 26), _
      New TEST_TRIANGLE3(70, 62, 38, 42, 38, 19), _
      New TEST_TRIANGLE3(38, 45, 70, 19, 26, 42), _
      New TEST_TRIANGLE3(95, 97, 62, 61, 59, 38), _
      New TEST_TRIANGLE3(62, 70, 95, 38, 42, 61), _
      New TEST_TRIANGLE3(127, 136, 97, 88, 94, 59), _
      New TEST_TRIANGLE3(97, 95, 127, 59, 61, 88), _
      New TEST_TRIANGLE3(153, 160, 136, 103, 111, 94), _
      New TEST_TRIANGLE3(136, 127, 153, 94, 88, 103), _
      New TEST_TRIANGLE3(156, 174, 161, 115, 117, 111), _
      New TEST_TRIANGLE3(161, 155, 156, 111, 103, 115), _
      New TEST_TRIANGLE3(61, 39, 41, 21, 14, 27), _
      New TEST_TRIANGLE3(41, 64, 61, 27, 25, 21), _
      New TEST_TRIANGLE3(63, 40, 65, 25, 27, 50), _
      New TEST_TRIANGLE3(65, 72, 63, 50, 52, 25), _
      New TEST_TRIANGLE3(72, 65, 99, 52, 50, 64), _
      New TEST_TRIANGLE3(99, 94, 72, 64, 62, 52), _
      New TEST_TRIANGLE3(94, 99, 133, 62, 64, 79), _
      New TEST_TRIANGLE3(133, 126, 94, 79, 77, 62), _
      New TEST_TRIANGLE3(134, 157, 159, 105, 106, 116), _
      New TEST_TRIANGLE3(159, 137, 134, 116, 110, 105), _
      New TEST_TRIANGLE3(126, 133, 158, 77, 79, 106), _
      New TEST_TRIANGLE3(158, 135, 126, 106, 105, 77), _
      New TEST_TRIANGLE3(67, 43, 39, 23, 15, 14), _
      New TEST_TRIANGLE3(39, 61, 67, 14, 21, 23), _
      New TEST_TRIANGLE3(137, 159, 156, 110, 116, 115), _
      New TEST_TRIANGLE3(156, 131, 137, 115, 108, 110), _
      New TEST_TRIANGLE3(68, 44, 43, 30, 26, 15), _
      New TEST_TRIANGLE3(43, 67, 68, 15, 23, 30), _
      New TEST_TRIANGLE3(76, 71, 46, 44, 42, 26), _
      New TEST_TRIANGLE3(46, 69, 76, 26, 30, 44), _
      New TEST_TRIANGLE3(93, 96, 71, 69, 61, 42), _
      New TEST_TRIANGLE3(71, 76, 93, 42, 44, 69), _
      New TEST_TRIANGLE3(122, 128, 96, 86, 88, 61), _
      New TEST_TRIANGLE3(96, 93, 122, 61, 69, 86), _
      New TEST_TRIANGLE3(129, 154, 128, 100, 103, 88), _
      New TEST_TRIANGLE3(128, 122, 129, 88, 86, 100), _
      New TEST_TRIANGLE3(131, 156, 155, 108, 115, 103), _
      New TEST_TRIANGLE3(155, 130, 131, 103, 100, 108), _
      New TEST_TRIANGLE3(78, 61, 64, 24, 21, 25), _
      New TEST_TRIANGLE3(64, 75, 78, 25, 29, 24), _
      New TEST_TRIANGLE3(73, 63, 72, 29, 25, 52), _
      New TEST_TRIANGLE3(72, 83, 73, 52, 53, 29), _
      New TEST_TRIANGLE3(83, 72, 94, 53, 52, 62), _
      New TEST_TRIANGLE3(94, 92, 83, 62, 63, 53), _
      New TEST_TRIANGLE3(92, 94, 126, 63, 62, 77), _
      New TEST_TRIANGLE3(126, 115, 92, 77, 76, 63), _
      New TEST_TRIANGLE3(123, 134, 137, 101, 105, 110), _
      New TEST_TRIANGLE3(137, 120, 123, 110, 104, 101), _
      New TEST_TRIANGLE3(115, 126, 135, 76, 77, 105), _
      New TEST_TRIANGLE3(135, 125, 115, 105, 101, 76), _
      New TEST_TRIANGLE3(82, 67, 61, 28, 23, 21), _
      New TEST_TRIANGLE3(61, 78, 82, 21, 24, 28), _
      New TEST_TRIANGLE3(120, 137, 131, 104, 110, 108), _
      New TEST_TRIANGLE3(131, 116, 120, 108, 102, 104), _
      New TEST_TRIANGLE3(79, 68, 67, 31, 30, 23), _
      New TEST_TRIANGLE3(67, 82, 79, 23, 28, 31), _
      New TEST_TRIANGLE3(84, 76, 69, 47, 44, 30), _
      New TEST_TRIANGLE3(69, 80, 84, 30, 31, 47), _
      New TEST_TRIANGLE3(91, 93, 76, 70, 69, 44), _
      New TEST_TRIANGLE3(76, 84, 91, 44, 47, 70), _
      New TEST_TRIANGLE3(114, 122, 93, 82, 86, 69), _
      New TEST_TRIANGLE3(93, 91, 114, 69, 70, 82), _
      New TEST_TRIANGLE3(118, 129, 122, 99, 100, 86), _
      New TEST_TRIANGLE3(122, 114, 118, 86, 82, 99), _
      New TEST_TRIANGLE3(116, 131, 130, 102, 108, 100), _
      New TEST_TRIANGLE3(130, 119, 116, 100, 99, 102) _
    }

    matrix_Rhand = New Single() { _
      -0.140259, 0.0, -0.927138, -42.27917, _
      0.0, -1.6093, 0.0, 0.041224, _
      -1.603176, 0.0, 0.081114, 71.39645, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_Rhand = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-5.058658, -1.865513, 5.286465, 0.0, 0.0), _
      New TEST_XYZ_UV(-3.230063, -3.437729, 4.728927, 0.0, 0.0), _
      New TEST_XYZ_UV(0.867144, -3.437729, 3.479694, 0.0, 0.0), _
      New TEST_XYZ_UV(5.2282, -2.519689, 2.898258, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.058658, -1.379661, 5.286465, 0.0, 0.0), _
      New TEST_XYZ_UV(-3.230063, -1.093981, 4.728935, 0.0, 0.0), _
      New TEST_XYZ_UV(0.867145, -1.093981, 3.479702, 0.0, 0.0), _
      New TEST_XYZ_UV(5.2282, -0.787967, 2.898258, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.058658, 1.53545, 5.286466, 0.0, 0.0), _
      New TEST_XYZ_UV(-3.230063, 1.249768, 4.728935, 0.0, 0.0), _
      New TEST_XYZ_UV(0.867145, 1.249768, 3.479703, 0.0, 0.0), _
      New TEST_XYZ_UV(5.2282, 0.943754, 2.898259, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.058658, 2.0213, 5.286466, 0.0, 0.0), _
      New TEST_XYZ_UV(-3.230063, 3.593516, 4.728927, 0.0, 0.0), _
      New TEST_XYZ_UV(0.867144, 3.593516, 3.479695, 0.0, 0.0), _
      New TEST_XYZ_UV(5.2282, 2.675476, 2.898259, 0.0, 0.0), _
      New TEST_XYZ_UV(-4.723916, -1.865513, 8.569148, 0.0, 0.0), _
      New TEST_XYZ_UV(-2.895322, -3.437729, 8.011609, 0.0, 0.0), _
      New TEST_XYZ_UV(1.201885, -3.437729, 6.762376, 0.0, 0.0), _
      New TEST_XYZ_UV(5.962151, -2.519689, 5.619896, 0.0, 0.0), _
      New TEST_XYZ_UV(-4.723916, -1.379661, 8.569148, 0.0, 0.0), _
      New TEST_XYZ_UV(-2.895322, -1.093981, 8.011605, 0.0, 0.0), _
      New TEST_XYZ_UV(1.201885, -1.09398, 6.762373, 0.0, 0.0), _
      New TEST_XYZ_UV(5.962149, -0.787967, 5.619897, 0.0, 0.0), _
      New TEST_XYZ_UV(-4.723916, 1.53545, 8.569148, 0.0, 0.0), _
      New TEST_XYZ_UV(-2.895322, 1.249768, 8.011606, 0.0, 0.0), _
      New TEST_XYZ_UV(1.201886, 1.249768, 6.762373, 0.0, 0.0), _
      New TEST_XYZ_UV(5.962149, 0.943754, 5.619897, 0.0, 0.0), _
      New TEST_XYZ_UV(-4.723916, 2.0213, 8.569148, 0.0, 0.0), _
      New TEST_XYZ_UV(-2.895321, 3.593516, 8.01161, 0.0, 0.0), _
      New TEST_XYZ_UV(1.201886, 3.593516, 6.762377, 0.0, 0.0), _
      New TEST_XYZ_UV(5.962149, 2.675476, 5.619897, 0.0, 0.0), _
      New TEST_XYZ_UV(2.800707, 5.397537, 3.31956, 0.0, 0.0), _
      New TEST_XYZ_UV(2.69269, 6.442284, 3.352495, 0.0, 0.0), _
      New TEST_XYZ_UV(3.050515, 5.397538, 5.769334, 0.0, 0.0), _
      New TEST_XYZ_UV(2.942497, 6.442284, 5.802265, 0.0, 0.0), _
      New TEST_XYZ_UV(7.047181, -1.60252, -1.311351, 0.0, 0.0), _
      New TEST_XYZ_UV(7.047179, -0.482245, -1.31135, 0.0, 0.0), _
      New TEST_XYZ_UV(7.047179, 0.638031, -1.31135, 0.0, 0.0), _
      New TEST_XYZ_UV(7.047179, 1.758306, -1.31135, 0.0, 0.0), _
      New TEST_XYZ_UV(8.141984, -1.60252, -0.208557, 0.0, 0.0), _
      New TEST_XYZ_UV(8.141989, -0.482245, -0.208558, 0.0, 0.0), _
      New TEST_XYZ_UV(8.141989, 0.638031, -0.208557, 0.0, 0.0), _
      New TEST_XYZ_UV(8.141989, 1.758306, -0.208557, 0.0, 0.0), _
      New TEST_XYZ_UV(-10.593719, -1.831116, 1.202205, 0.0, 0.0), _
      New TEST_XYZ_UV(-10.593724, 1.986904, 1.202206, 0.0, 0.0), _
      New TEST_XYZ_UV(-10.593724, -1.831117, 7.449618, 0.0, 0.0), _
      New TEST_XYZ_UV(-10.593723, 1.986904, 7.449619, 0.0, 0.0) _
    }


    normal_Rhand = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.821636, 0.326217, -0.467437), _
      New TEST_NORMAL(-0.821635, -0.326217, -0.467438), _
      New TEST_NORMAL(-0.603382, 0.0, -0.797452), _
      New TEST_NORMAL(-0.603382, 0.0, -0.797453), _
      New TEST_NORMAL(-0.564846, 0.339498, 0.752124), _
      New TEST_NORMAL(-0.564846, -0.339498, 0.752124), _
      New TEST_NORMAL(-0.551579, 0.598241, -0.581265), _
      New TEST_NORMAL(-0.407657, -0.716613, -0.565933), _
      New TEST_NORMAL(-0.291643, 0.000002, -0.956527), _
      New TEST_NORMAL(-0.291642, -0.000002, -0.956527), _
      New TEST_NORMAL(-0.267746, -0.464924, -0.843895), _
      New TEST_NORMAL(-0.263722, 0.464316, -0.845495), _
      New TEST_NORMAL(-0.21261, 0.000002, -0.977137), _
      New TEST_NORMAL(-0.212609, -0.000001, -0.977137), _
      New TEST_NORMAL(-0.206905, 0.648001, 0.732998), _
      New TEST_NORMAL(-0.185861, 0.0, -0.982576), _
      New TEST_NORMAL(-0.185861, 0.0, -0.982576), _
      New TEST_NORMAL(-0.1705, -0.254872, 0.951825), _
      New TEST_NORMAL(-0.169473, 0.254604, 0.952079), _
      New TEST_NORMAL(-0.14147, 0.502707, -0.852803), _
      New TEST_NORMAL(-0.141468, -0.502707, -0.852802), _
      New TEST_NORMAL(-0.129804, 0.838271, -0.529578), _
      New TEST_NORMAL(-0.12556, -0.835939, -0.534267), _
      New TEST_NORMAL(-0.104684, -0.734684, 0.670284), _
      New TEST_NORMAL(-0.080709, -0.71006, -0.6995), _
      New TEST_NORMAL(-0.063389, 0.765037, 0.640859), _
      New TEST_NORMAL(-0.060705, -0.766033, 0.639929), _
      New TEST_NORMAL(0.019337, 0.138547, -0.990167), _
      New TEST_NORMAL(0.239266, -0.726089, 0.644629), _
      New TEST_NORMAL(0.262629, 0.0, 0.964897), _
      New TEST_NORMAL(0.262629, 0.0, 0.964897), _
      New TEST_NORMAL(0.291645, 0.0, 0.956527), _
      New TEST_NORMAL(0.291645, 0.0, 0.956527), _
      New TEST_NORMAL(0.331389, 0.725774, -0.602855), _
      New TEST_NORMAL(0.466743, 0.138204, 0.873528), _
      New TEST_NORMAL(0.498948, 0.753738, 0.427703), _
      New TEST_NORMAL(0.534562, 0.515345, -0.669823), _
      New TEST_NORMAL(0.535589, -0.515537, -0.668854), _
      New TEST_NORMAL(0.587545, 0.577797, 0.566518), _
      New TEST_NORMAL(0.590874, -0.573806, 0.567111), _
      New TEST_NORMAL(0.662555, 0.0, 0.749013), _
      New TEST_NORMAL(0.662555, 0.0, 0.749013), _
      New TEST_NORMAL(0.669132, -0.267143, -0.693467), _
      New TEST_NORMAL(0.824475, -0.526549, -0.207333), _
      New TEST_NORMAL(0.824476, 0.526547, -0.207335), _
      New TEST_NORMAL(0.88582, -0.26684, 0.37963), _
      New TEST_NORMAL(0.977625, 0.0, -0.210353), _
      New TEST_NORMAL(0.977626, -0.000002, -0.210353) _
    }

    triangle3_Rhand = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(5, 4, 0, 8, 10, 1), _
      New TEST_TRIANGLE3(0, 1, 5, 1, 7, 8), _
      New TEST_TRIANGLE3(6, 5, 1, 12, 8, 7), _
      New TEST_TRIANGLE3(1, 2, 6, 7, 24, 12), _
      New TEST_TRIANGLE3(7, 6, 2, 3, 12, 24), _
      New TEST_TRIANGLE3(2, 3, 7, 24, 22, 3), _
      New TEST_TRIANGLE3(9, 8, 4, 9, 11, 10), _
      New TEST_TRIANGLE3(4, 5, 9, 10, 8, 9), _
      New TEST_TRIANGLE3(10, 9, 5, 13, 9, 8), _
      New TEST_TRIANGLE3(5, 6, 10, 8, 12, 13), _
      New TEST_TRIANGLE3(11, 10, 6, 2, 13, 12), _
      New TEST_TRIANGLE3(6, 7, 11, 12, 3, 2), _
      New TEST_TRIANGLE3(13, 12, 8, 6, 0, 11), _
      New TEST_TRIANGLE3(8, 9, 13, 11, 9, 6), _
      New TEST_TRIANGLE3(14, 13, 9, 27, 6, 9), _
      New TEST_TRIANGLE3(9, 10, 14, 9, 13, 27), _
      New TEST_TRIANGLE3(15, 14, 10, 21, 27, 13), _
      New TEST_TRIANGLE3(10, 11, 15, 13, 2, 21), _
      New TEST_TRIANGLE3(21, 17, 16, 31, 23, 5), _
      New TEST_TRIANGLE3(16, 20, 21, 5, 17, 31), _
      New TEST_TRIANGLE3(22, 18, 17, 29, 28, 23), _
      New TEST_TRIANGLE3(17, 21, 22, 23, 31, 29), _
      New TEST_TRIANGLE3(23, 19, 18, 41, 39, 28), _
      New TEST_TRIANGLE3(18, 22, 23, 28, 29, 41), _
      New TEST_TRIANGLE3(25, 21, 20, 32, 31, 17), _
      New TEST_TRIANGLE3(20, 24, 25, 17, 18, 32), _
      New TEST_TRIANGLE3(26, 22, 21, 30, 29, 31), _
      New TEST_TRIANGLE3(21, 25, 26, 31, 32, 30), _
      New TEST_TRIANGLE3(27, 23, 22, 40, 41, 29), _
      New TEST_TRIANGLE3(22, 26, 27, 29, 30, 40), _
      New TEST_TRIANGLE3(29, 25, 24, 14, 32, 18), _
      New TEST_TRIANGLE3(24, 28, 29, 18, 4, 14), _
      New TEST_TRIANGLE3(30, 26, 25, 34, 30, 32), _
      New TEST_TRIANGLE3(25, 29, 30, 32, 14, 34), _
      New TEST_TRIANGLE3(31, 27, 26, 38, 40, 30), _
      New TEST_TRIANGLE3(26, 30, 31, 30, 34, 38), _
      New TEST_TRIANGLE3(17, 1, 0, 23, 7, 1), _
      New TEST_TRIANGLE3(0, 16, 17, 1, 5, 23), _
      New TEST_TRIANGLE3(18, 2, 1, 28, 24, 7), _
      New TEST_TRIANGLE3(1, 17, 18, 7, 23, 28), _
      New TEST_TRIANGLE3(19, 3, 2, 39, 22, 24), _
      New TEST_TRIANGLE3(2, 18, 19, 24, 28, 39), _
      New TEST_TRIANGLE3(41, 37, 36, 47, 15, 20), _
      New TEST_TRIANGLE3(36, 40, 41, 20, 43, 47), _
      New TEST_TRIANGLE3(42, 38, 37, 46, 16, 15), _
      New TEST_TRIANGLE3(37, 41, 42, 15, 47, 46), _
      New TEST_TRIANGLE3(43, 39, 38, 44, 19, 16), _
      New TEST_TRIANGLE3(38, 42, 43, 16, 46, 44), _
      New TEST_TRIANGLE3(30, 14, 15, 34, 27, 21), _
      New TEST_TRIANGLE3(15, 31, 30, 21, 38, 34), _
      New TEST_TRIANGLE3(35, 33, 32, 35, 33, 42), _
      New TEST_TRIANGLE3(32, 34, 35, 42, 45, 35), _
      New TEST_TRIANGLE3(28, 12, 13, 4, 0, 6), _
      New TEST_TRIANGLE3(13, 29, 28, 6, 14, 4), _
      New TEST_TRIANGLE3(24, 8, 12, 18, 11, 0), _
      New TEST_TRIANGLE3(12, 28, 24, 0, 4, 18), _
      New TEST_TRIANGLE3(16, 0, 4, 5, 1, 10), _
      New TEST_TRIANGLE3(4, 20, 16, 10, 17, 5), _
      New TEST_TRIANGLE3(33, 13, 14, 33, 6, 27), _
      New TEST_TRIANGLE3(14, 32, 33, 27, 42, 33), _
      New TEST_TRIANGLE3(32, 14, 30, 42, 27, 34), _
      New TEST_TRIANGLE3(30, 34, 32, 34, 45, 42), _
      New TEST_TRIANGLE3(35, 29, 13, 35, 14, 6), _
      New TEST_TRIANGLE3(13, 33, 35, 6, 33, 35), _
      New TEST_TRIANGLE3(34, 30, 35, 45, 34, 35), _
      New TEST_TRIANGLE3(29, 35, 30, 14, 35, 34), _
      New TEST_TRIANGLE3(36, 3, 40, 20, 22, 43), _
      New TEST_TRIANGLE3(19, 40, 3, 39, 43, 22), _
      New TEST_TRIANGLE3(37, 7, 3, 15, 3, 22), _
      New TEST_TRIANGLE3(3, 36, 37, 22, 20, 15), _
      New TEST_TRIANGLE3(38, 11, 7, 16, 2, 3), _
      New TEST_TRIANGLE3(7, 37, 38, 3, 15, 16), _
      New TEST_TRIANGLE3(39, 15, 11, 19, 21, 2), _
      New TEST_TRIANGLE3(11, 38, 39, 2, 16, 19), _
      New TEST_TRIANGLE3(40, 19, 23, 43, 39, 41), _
      New TEST_TRIANGLE3(23, 41, 40, 41, 47, 43), _
      New TEST_TRIANGLE3(41, 23, 27, 47, 41, 40), _
      New TEST_TRIANGLE3(27, 42, 41, 40, 46, 47), _
      New TEST_TRIANGLE3(43, 31, 15, 44, 38, 21), _
      New TEST_TRIANGLE3(15, 39, 43, 21, 19, 44), _
      New TEST_TRIANGLE3(42, 27, 31, 46, 40, 38), _
      New TEST_TRIANGLE3(31, 43, 42, 38, 44, 46), _
      New TEST_TRIANGLE3(44, 4, 8, 37, 10, 11), _
      New TEST_TRIANGLE3(8, 45, 44, 11, 36, 37), _
      New TEST_TRIANGLE3(47, 24, 20, 25, 18, 17), _
      New TEST_TRIANGLE3(20, 46, 47, 17, 26, 25), _
      New TEST_TRIANGLE3(45, 8, 24, 36, 11, 18), _
      New TEST_TRIANGLE3(24, 47, 45, 18, 25, 36), _
      New TEST_TRIANGLE3(46, 20, 4, 26, 17, 10), _
      New TEST_TRIANGLE3(4, 44, 46, 10, 37, 26) _
    }

    matrix_Lhand = New Single() { _
      -0.140259, 0.0, 0.927137, 42.2792, _
      0.0, -1.609299, 0.0, 0.041222, _
      1.603176, 0.0, 0.081114, 71.396445, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_Lhand = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(5.058657, -1.865513, 5.286465, 0.0, 0.0), _
      New TEST_XYZ_UV(3.230062, -3.437729, 4.728931, 0.0, 0.0), _
      New TEST_XYZ_UV(-0.867144, -3.437729, 3.479694, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.228197, -2.519689, 2.898259, 0.0, 0.0), _
      New TEST_XYZ_UV(5.058657, -1.379661, 5.286465, 0.0, 0.0), _
      New TEST_XYZ_UV(3.230062, -1.093981, 4.728935, 0.0, 0.0), _
      New TEST_XYZ_UV(-0.867145, -1.093981, 3.479702, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.228197, -0.787967, 2.898259, 0.0, 0.0), _
      New TEST_XYZ_UV(5.058657, 1.53545, 5.286465, 0.0, 0.0), _
      New TEST_XYZ_UV(3.230063, 1.249768, 4.728935, 0.0, 0.0), _
      New TEST_XYZ_UV(-0.867144, 1.249768, 3.479702, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.228197, 0.943754, 2.898259, 0.0, 0.0), _
      New TEST_XYZ_UV(5.058657, 2.0213, 5.286465, 0.0, 0.0), _
      New TEST_XYZ_UV(3.230063, 3.593516, 4.72893, 0.0, 0.0), _
      New TEST_XYZ_UV(-0.867144, 3.593516, 3.479694, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.228197, 2.675476, 2.898258, 0.0, 0.0), _
      New TEST_XYZ_UV(4.723916, -1.865513, 8.569148, 0.0, 0.0), _
      New TEST_XYZ_UV(2.895321, -3.437729, 8.011609, 0.0, 0.0), _
      New TEST_XYZ_UV(-1.201891, -3.437729, 6.76238, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.962148, -2.519688, 5.619893, 0.0, 0.0), _
      New TEST_XYZ_UV(4.723916, -1.379661, 8.569148, 0.0, 0.0), _
      New TEST_XYZ_UV(2.895317, -1.093981, 8.011608, 0.0, 0.0), _
      New TEST_XYZ_UV(-1.20189, -1.09398, 6.762376, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.962148, -0.787967, 5.619893, 0.0, 0.0), _
      New TEST_XYZ_UV(4.723916, 1.53545, 8.569147, 0.0, 0.0), _
      New TEST_XYZ_UV(2.895317, 1.249768, 8.011608, 0.0, 0.0), _
      New TEST_XYZ_UV(-1.20189, 1.249768, 6.762376, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.962148, 0.943754, 5.619893, 0.0, 0.0), _
      New TEST_XYZ_UV(4.723916, 2.0213, 8.569147, 0.0, 0.0), _
      New TEST_XYZ_UV(2.895322, 3.593516, 8.011609, 0.0, 0.0), _
      New TEST_XYZ_UV(-1.20189, 3.593516, 6.762379, 0.0, 0.0), _
      New TEST_XYZ_UV(-5.962148, 2.675476, 5.619892, 0.0, 0.0), _
      New TEST_XYZ_UV(-2.800706, 5.397538, 3.319559, 0.0, 0.0), _
      New TEST_XYZ_UV(-2.692689, 6.442284, 3.352494, 0.0, 0.0), _
      New TEST_XYZ_UV(-3.050514, 5.397538, 5.769329, 0.0, 0.0), _
      New TEST_XYZ_UV(-2.942496, 6.442284, 5.802264, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.047179, -1.60252, -1.31135, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.047179, -0.482245, -1.31135, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.047179, 0.638031, -1.311346, 0.0, 0.0), _
      New TEST_XYZ_UV(-7.047179, 1.758306, -1.311346, 0.0, 0.0), _
      New TEST_XYZ_UV(-8.141981, -1.60252, -0.20856, 0.0, 0.0), _
      New TEST_XYZ_UV(-8.141986, -0.482244, -0.208557, 0.0, 0.0), _
      New TEST_XYZ_UV(-8.141986, 0.638031, -0.208557, 0.0, 0.0), _
      New TEST_XYZ_UV(-8.141986, 1.758306, -0.208557, 0.0, 0.0), _
      New TEST_XYZ_UV(10.593723, -1.831117, 1.202206, 0.0, 0.0), _
      New TEST_XYZ_UV(10.593723, 1.986904, 1.202206, 0.0, 0.0), _
      New TEST_XYZ_UV(10.593727, -1.831116, 7.449623, 0.0, 0.0), _
      New TEST_XYZ_UV(10.593727, 1.986904, 7.449622, 0.0, 0.0) _
    }


    normal_Lhand = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.821635, -0.326217, 0.467438), _
      New TEST_NORMAL(-0.821635, 0.326217, 0.467438), _
      New TEST_NORMAL(-0.603382, 0.0, 0.797453), _
      New TEST_NORMAL(-0.603382, 0.0, 0.797453), _
      New TEST_NORMAL(-0.564846, 0.339498, -0.752124), _
      New TEST_NORMAL(-0.564846, -0.339498, -0.752124), _
      New TEST_NORMAL(-0.551579, -0.598241, 0.581265), _
      New TEST_NORMAL(-0.407657, 0.716614, 0.565933), _
      New TEST_NORMAL(-0.291643, 0.0, 0.956527), _
      New TEST_NORMAL(-0.291642, 0.0, 0.956527), _
      New TEST_NORMAL(-0.267746, 0.464924, 0.843895), _
      New TEST_NORMAL(-0.263722, -0.464316, 0.845495), _
      New TEST_NORMAL(-0.21261, -0.000002, 0.977137), _
      New TEST_NORMAL(-0.212609, 0.000002, 0.977137), _
      New TEST_NORMAL(-0.206906, -0.648001, -0.732997), _
      New TEST_NORMAL(-0.185861, -0.000002, 0.982576), _
      New TEST_NORMAL(-0.18586, -0.000001, 0.982576), _
      New TEST_NORMAL(-0.170501, 0.254872, -0.951824), _
      New TEST_NORMAL(-0.169474, -0.254605, -0.952079), _
      New TEST_NORMAL(-0.14147, -0.502707, 0.852802), _
      New TEST_NORMAL(-0.141469, 0.502707, 0.852803), _
      New TEST_NORMAL(-0.129804, -0.838271, 0.529578), _
      New TEST_NORMAL(-0.12556, 0.835939, 0.534267), _
      New TEST_NORMAL(-0.104684, 0.734685, -0.670283), _
      New TEST_NORMAL(-0.080709, 0.71006, 0.6995), _
      New TEST_NORMAL(-0.063389, -0.765037, -0.64086), _
      New TEST_NORMAL(-0.060705, 0.766033, -0.639929), _
      New TEST_NORMAL(0.019336, -0.138547, 0.990167), _
      New TEST_NORMAL(0.239267, 0.726088, -0.64463), _
      New TEST_NORMAL(0.26263, 0.0, -0.964897), _
      New TEST_NORMAL(0.26263, 0.0, -0.964897), _
      New TEST_NORMAL(0.291644, 0.0, -0.956527), _
      New TEST_NORMAL(0.291644, 0.0, -0.956527), _
      New TEST_NORMAL(0.331388, -0.725774, 0.602855), _
      New TEST_NORMAL(0.466744, -0.138205, -0.873527), _
      New TEST_NORMAL(0.498948, -0.753738, -0.427703), _
      New TEST_NORMAL(0.534562, -0.515345, 0.669823), _
      New TEST_NORMAL(0.535588, 0.515538, 0.668854), _
      New TEST_NORMAL(0.587545, -0.577797, -0.566517), _
      New TEST_NORMAL(0.590874, 0.573806, -0.56711), _
      New TEST_NORMAL(0.662556, 0.0, -0.749012), _
      New TEST_NORMAL(0.662556, 0.0, -0.749012), _
      New TEST_NORMAL(0.669132, 0.267143, 0.693468), _
      New TEST_NORMAL(0.824475, 0.526548, 0.207335), _
      New TEST_NORMAL(0.824476, -0.526547, 0.207335), _
      New TEST_NORMAL(0.885822, 0.266841, -0.379626), _
      New TEST_NORMAL(0.977625, 0.0, 0.210353), _
      New TEST_NORMAL(0.977626, 0.000002, 0.210352) _
    }

    triangle3_Lhand = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(5, 4, 0, 9, 10, 1), _
      New TEST_TRIANGLE3(0, 1, 5, 1, 7, 9), _
      New TEST_TRIANGLE3(6, 5, 1, 12, 9, 7), _
      New TEST_TRIANGLE3(1, 2, 6, 7, 24, 12), _
      New TEST_TRIANGLE3(7, 6, 2, 3, 12, 24), _
      New TEST_TRIANGLE3(2, 3, 7, 24, 22, 3), _
      New TEST_TRIANGLE3(9, 8, 4, 8, 11, 10), _
      New TEST_TRIANGLE3(4, 5, 9, 10, 9, 8), _
      New TEST_TRIANGLE3(10, 9, 5, 13, 8, 9), _
      New TEST_TRIANGLE3(5, 6, 10, 9, 12, 13), _
      New TEST_TRIANGLE3(11, 10, 6, 2, 13, 12), _
      New TEST_TRIANGLE3(6, 7, 11, 12, 3, 2), _
      New TEST_TRIANGLE3(13, 12, 8, 6, 0, 11), _
      New TEST_TRIANGLE3(8, 9, 13, 11, 8, 6), _
      New TEST_TRIANGLE3(14, 13, 9, 27, 6, 8), _
      New TEST_TRIANGLE3(9, 10, 14, 8, 13, 27), _
      New TEST_TRIANGLE3(15, 14, 10, 21, 27, 13), _
      New TEST_TRIANGLE3(10, 11, 15, 13, 2, 21), _
      New TEST_TRIANGLE3(21, 17, 16, 32, 23, 4), _
      New TEST_TRIANGLE3(16, 20, 21, 4, 17, 32), _
      New TEST_TRIANGLE3(22, 18, 17, 29, 28, 23), _
      New TEST_TRIANGLE3(17, 21, 22, 23, 32, 29), _
      New TEST_TRIANGLE3(23, 19, 18, 41, 39, 28), _
      New TEST_TRIANGLE3(18, 22, 23, 28, 29, 41), _
      New TEST_TRIANGLE3(25, 21, 20, 31, 32, 17), _
      New TEST_TRIANGLE3(20, 24, 25, 17, 18, 31), _
      New TEST_TRIANGLE3(26, 22, 21, 30, 29, 32), _
      New TEST_TRIANGLE3(21, 25, 26, 32, 31, 30), _
      New TEST_TRIANGLE3(27, 23, 22, 40, 41, 29), _
      New TEST_TRIANGLE3(22, 26, 27, 29, 30, 40), _
      New TEST_TRIANGLE3(29, 25, 24, 14, 31, 18), _
      New TEST_TRIANGLE3(24, 28, 29, 18, 5, 14), _
      New TEST_TRIANGLE3(30, 26, 25, 34, 30, 31), _
      New TEST_TRIANGLE3(25, 29, 30, 31, 14, 34), _
      New TEST_TRIANGLE3(31, 27, 26, 38, 40, 30), _
      New TEST_TRIANGLE3(26, 30, 31, 30, 34, 38), _
      New TEST_TRIANGLE3(17, 1, 0, 23, 7, 1), _
      New TEST_TRIANGLE3(0, 16, 17, 1, 4, 23), _
      New TEST_TRIANGLE3(18, 2, 1, 28, 24, 7), _
      New TEST_TRIANGLE3(1, 17, 18, 7, 23, 28), _
      New TEST_TRIANGLE3(19, 3, 2, 39, 22, 24), _
      New TEST_TRIANGLE3(2, 18, 19, 24, 28, 39), _
      New TEST_TRIANGLE3(41, 37, 36, 47, 16, 20), _
      New TEST_TRIANGLE3(36, 40, 41, 20, 43, 47), _
      New TEST_TRIANGLE3(42, 38, 37, 46, 15, 16), _
      New TEST_TRIANGLE3(37, 41, 42, 16, 47, 46), _
      New TEST_TRIANGLE3(43, 39, 38, 44, 19, 15), _
      New TEST_TRIANGLE3(38, 42, 43, 15, 46, 44), _
      New TEST_TRIANGLE3(30, 14, 15, 34, 27, 21), _
      New TEST_TRIANGLE3(15, 31, 30, 21, 38, 34), _
      New TEST_TRIANGLE3(35, 33, 32, 35, 33, 42), _
      New TEST_TRIANGLE3(32, 34, 35, 42, 45, 35), _
      New TEST_TRIANGLE3(28, 12, 13, 5, 0, 6), _
      New TEST_TRIANGLE3(13, 29, 28, 6, 14, 5), _
      New TEST_TRIANGLE3(24, 8, 12, 18, 11, 0), _
      New TEST_TRIANGLE3(12, 28, 24, 0, 5, 18), _
      New TEST_TRIANGLE3(16, 0, 4, 4, 1, 10), _
      New TEST_TRIANGLE3(4, 20, 16, 10, 17, 4), _
      New TEST_TRIANGLE3(33, 13, 14, 33, 6, 27), _
      New TEST_TRIANGLE3(14, 32, 33, 27, 42, 33), _
      New TEST_TRIANGLE3(32, 14, 30, 42, 27, 34), _
      New TEST_TRIANGLE3(30, 34, 32, 34, 45, 42), _
      New TEST_TRIANGLE3(35, 29, 13, 35, 14, 6), _
      New TEST_TRIANGLE3(13, 33, 35, 6, 33, 35), _
      New TEST_TRIANGLE3(34, 30, 35, 45, 34, 35), _
      New TEST_TRIANGLE3(29, 35, 30, 14, 35, 34), _
      New TEST_TRIANGLE3(36, 3, 40, 20, 22, 43), _
      New TEST_TRIANGLE3(19, 40, 3, 39, 43, 22), _
      New TEST_TRIANGLE3(37, 7, 3, 16, 3, 22), _
      New TEST_TRIANGLE3(3, 36, 37, 22, 20, 16), _
      New TEST_TRIANGLE3(38, 11, 7, 15, 2, 3), _
      New TEST_TRIANGLE3(7, 37, 38, 3, 16, 15), _
      New TEST_TRIANGLE3(39, 15, 11, 19, 21, 2), _
      New TEST_TRIANGLE3(11, 38, 39, 2, 15, 19), _
      New TEST_TRIANGLE3(40, 19, 23, 43, 39, 41), _
      New TEST_TRIANGLE3(23, 41, 40, 41, 47, 43), _
      New TEST_TRIANGLE3(41, 23, 27, 47, 41, 40), _
      New TEST_TRIANGLE3(27, 42, 41, 40, 46, 47), _
      New TEST_TRIANGLE3(43, 31, 15, 44, 38, 21), _
      New TEST_TRIANGLE3(15, 39, 43, 21, 19, 44), _
      New TEST_TRIANGLE3(42, 27, 31, 46, 40, 38), _
      New TEST_TRIANGLE3(31, 43, 42, 38, 44, 46), _
      New TEST_TRIANGLE3(44, 4, 8, 37, 10, 11), _
      New TEST_TRIANGLE3(8, 45, 44, 11, 36, 37), _
      New TEST_TRIANGLE3(47, 24, 20, 25, 18, 17), _
      New TEST_TRIANGLE3(20, 46, 47, 17, 26, 25), _
      New TEST_TRIANGLE3(45, 8, 24, 36, 11, 18), _
      New TEST_TRIANGLE3(24, 47, 45, 18, 25, 36), _
      New TEST_TRIANGLE3(46, 20, 4, 26, 17, 10), _
      New TEST_TRIANGLE3(4, 44, 46, 10, 37, 26) _
    }

    matrix_Llower_arm = New Single() { _
      0.939692, -0.31244, 0.0, 41.75566, _
      0.0, 0.0, -0.999999, 4.915867, _
      0.34202, 0.858423, 0.0, 97.80647, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_Llower_arm = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-7.97703, -16.998699, 5.000002, 0.687941, 1.177419), _
      New TEST_XYZ_UV(-7.97703, -16.998699, 5.000002, 1.259541, 1.177419), _
      New TEST_XYZ_UV(-7.363418, -16.940021, 10.750242, 0.689115, 1.292424), _
      New TEST_XYZ_UV(-7.363418, -16.940021, 10.750242, 1.247268, 0.689115), _
      New TEST_XYZ_UV(-7.363418, -16.940021, 10.750242, 1.247268, 1.292424), _
      New TEST_XYZ_UV(-7.363411, -16.940022, -7.441553, 0.689115, 0.928588), _
      New TEST_XYZ_UV(-7.363411, -16.940022, -7.441553, 0.952732, 0.689115), _
      New TEST_XYZ_UV(-7.363411, -16.940022, -7.441553, 1.247268, 0.928588), _
      New TEST_XYZ_UV(-6.468254, -6.875829, 5.0, 0.890399, 1.177419), _
      New TEST_XYZ_UV(-5.255458, -6.875818, 9.827704, 0.890399, 1.273973), _
      New TEST_XYZ_UV(-5.255458, -6.875818, 9.827704, 1.205109, 0.890399), _
      New TEST_XYZ_UV(-5.255455, -6.875819, -2.953073, 0.890399, 1.018358), _
      New TEST_XYZ_UV(-5.255455, -6.875819, -2.953073, 0.994891, 0.890399), _
      New TEST_XYZ_UV(-4.999997, 13.473956, 5.0, 1.297394, 1.177419), _
      New TEST_XYZ_UV(-4.062499, 24.078129, 5.0, 1.01875, 1.177419), _
      New TEST_XYZ_UV(-4.062499, 24.078129, 5.0, 1.509478, 1.177419), _
      New TEST_XYZ_UV(-4.062498, 13.473962, 0.9375, 1.01875, 1.297394), _
      New TEST_XYZ_UV(-4.062498, 13.473962, 0.9375, 1.297394, 1.096169), _
      New TEST_XYZ_UV(-4.062498, 13.473961, 9.0625, 1.18125, 1.297394), _
      New TEST_XYZ_UV(-4.062498, 13.473961, 9.0625, 1.297394, 1.258669), _
      New TEST_XYZ_UV(-3.749997, 23.770827, 1.25, 1.025, 1.102419), _
      New TEST_XYZ_UV(-3.749997, 23.770827, 1.25, 1.025, 1.503332), _
      New TEST_XYZ_UV(-3.749997, 23.770827, 1.25, 1.503332, 1.102419), _
      New TEST_XYZ_UV(-3.749997, 23.770826, 8.75, 1.025, 1.252419), _
      New TEST_XYZ_UV(-3.749997, 23.770826, 8.75, 1.175, 1.503332), _
      New TEST_XYZ_UV(-3.749997, 23.770826, 8.75, 1.503332, 1.252419), _
      New TEST_XYZ_UV(-0.000001, -6.87582, -4.481199, 1.1, 0.890399), _
      New TEST_XYZ_UV(-0.000001, -17.791527, -10.107854, 1.1, 0.672085), _
      New TEST_XYZ_UV(-0.000001, -17.791527, -10.107854, 1.1, 0.875262), _
      New TEST_XYZ_UV(0.0, 24.999996, 5.0, 1.1, 1.177419), _
      New TEST_XYZ_UV(0.0, -17.791528, 12.365924, 1.1, 0.672085), _
      New TEST_XYZ_UV(0.0, -17.791528, 12.365924, 1.1, 1.324738), _
      New TEST_XYZ_UV(0.000002, 13.473963, 0.0, 1.1, 1.297394), _
      New TEST_XYZ_UV(0.000002, 13.473962, 10.0, 1.1, 1.297394), _
      New TEST_XYZ_UV(0.000002, -11.298856, 5.000004, 1.1, 1.177419), _
      New TEST_XYZ_UV(0.000003, -6.875822, 11.355825, 1.1, 0.890399), _
      New TEST_XYZ_UV(0.000003, 24.078129, 0.9375, 1.1, 1.096169), _
      New TEST_XYZ_UV(0.000003, 24.078129, 0.9375, 1.1, 1.509478), _
      New TEST_XYZ_UV(0.000004, 24.078129, 9.0625, 1.1, 1.258669), _
      New TEST_XYZ_UV(0.000004, 24.078129, 9.0625, 1.1, 1.509478), _
      New TEST_XYZ_UV(3.750002, 23.770832, 1.25, 0.696668, 1.102419), _
      New TEST_XYZ_UV(3.750002, 23.770832, 1.25, 1.175, 1.102419), _
      New TEST_XYZ_UV(3.750002, 23.770832, 1.25, 1.175, 1.503332), _
      New TEST_XYZ_UV(3.750002, 23.770831, 8.75, 0.696668, 1.252419), _
      New TEST_XYZ_UV(3.750002, 23.770831, 8.75, 1.025, 1.503332), _
      New TEST_XYZ_UV(3.750002, 23.770831, 8.75, 1.175, 1.252419), _
      New TEST_XYZ_UV(4.062498, 24.078123, 5.0, 0.690522, 1.177419), _
      New TEST_XYZ_UV(4.062498, 24.078123, 5.0, 1.18125, 1.177419), _
      New TEST_XYZ_UV(4.0625, 13.473956, 0.9375, 0.902606, 1.096169), _
      New TEST_XYZ_UV(4.0625, 13.473956, 0.9375, 1.18125, 1.297394), _
      New TEST_XYZ_UV(4.0625, 13.473955, 9.0625, 0.902606, 1.258669), _
      New TEST_XYZ_UV(4.0625, 13.473955, 9.0625, 1.01875, 1.297394), _
      New TEST_XYZ_UV(5.000002, 13.47396, 5.0, 0.902606, 1.177419), _
      New TEST_XYZ_UV(5.255456, -6.875823, -2.953073, 1.205109, 0.890399), _
      New TEST_XYZ_UV(5.255456, -6.875823, -2.953073, 1.309601, 1.018358), _
      New TEST_XYZ_UV(5.255457, -6.875823, 9.827704, 0.994891, 0.890399), _
      New TEST_XYZ_UV(5.255457, -6.875823, 9.827704, 1.309601, 1.273973), _
      New TEST_XYZ_UV(6.468257, -6.875823, 5.0, 1.309601, 1.177419), _
      New TEST_XYZ_UV(7.363411, -16.940019, -7.441552, 0.952732, 0.928588), _
      New TEST_XYZ_UV(7.363411, -16.940019, -7.441552, 1.247268, 0.689115), _
      New TEST_XYZ_UV(7.363411, -16.940019, -7.441552, 1.510885, 0.928588), _
      New TEST_XYZ_UV(7.363411, -16.94002, 10.750242, 0.952732, 0.689115), _
      New TEST_XYZ_UV(7.363411, -16.94002, 10.750242, 0.952732, 1.292424), _
      New TEST_XYZ_UV(7.363411, -16.94002, 10.750242, 1.510885, 1.292424), _
      New TEST_XYZ_UV(7.977029, -16.998705, 5.000002, 0.940459, 1.177419), _
      New TEST_XYZ_UV(7.977029, -16.998705, 5.000002, 1.512059, 1.177419) _
    }


    normal_Llower_arm = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.997571, -0.069181, -0.008127), _
      New TEST_NORMAL(-0.991312, -0.127338, -0.032939), _
      New TEST_NORMAL(-0.749932, -0.279178, 0.599717), _
      New TEST_NORMAL(-0.748497, -0.663073, 0.009294), _
      New TEST_NORMAL(-0.713393, -0.112867, 0.691615), _
      New TEST_NORMAL(-0.703277, -0.145114, -0.695948), _
      New TEST_NORMAL(-0.703054, -0.078333, -0.706809), _
      New TEST_NORMAL(-0.665518, 0.534656, 0.520797), _
      New TEST_NORMAL(-0.604442, -0.518943, -0.604441), _
      New TEST_NORMAL(-0.577126, 0.666452, -0.471983), _
      New TEST_NORMAL(-0.576451, -0.558182, 0.596773), _
      New TEST_NORMAL(-0.560405, 0.828164, 0.009533), _
      New TEST_NORMAL(-0.02876, -0.662828, 0.748219), _
      New TEST_NORMAL(-0.009772, -0.064198, -0.997889), _
      New TEST_NORMAL(-0.009724, -0.140444, 0.990041), _
      New TEST_NORMAL(-0.002668, -0.343697, 0.939077), _
      New TEST_NORMAL(-0.001588, 0.62883, 0.777542), _
      New TEST_NORMAL(0.0, -1.0, 0.0), _
      New TEST_NORMAL(0.0, 0.990898, 0.134617), _
      New TEST_NORMAL(0.006405, -0.08586, -0.996287), _
      New TEST_NORMAL(0.009295, -0.663073, -0.748497), _
      New TEST_NORMAL(0.014651, 0.854442, -0.519341), _
      New TEST_NORMAL(0.559352, 0.827728, -0.044635), _
      New TEST_NORMAL(0.58203, -0.567875, -0.58203), _
      New TEST_NORMAL(0.590472, 0.654809, -0.471771), _
      New TEST_NORMAL(0.609583, -0.529429, 0.590011), _
      New TEST_NORMAL(0.650757, 0.540347, 0.533423), _
      New TEST_NORMAL(0.705145, -0.060609, -0.706468), _
      New TEST_NORMAL(0.709454, -0.114524, -0.695384), _
      New TEST_NORMAL(0.720528, -0.124113, 0.682228), _
      New TEST_NORMAL(0.733523, -0.297349, 0.611169), _
      New TEST_NORMAL(0.748497, -0.663073, -0.009294), _
      New TEST_NORMAL(0.990498, -0.123033, -0.061445), _
      New TEST_NORMAL(0.997101, -0.076044, 0.002749) _
    }

    triangle3_Llower_arm = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(26, 53, 59, 15, 2, 7), _
      New TEST_TRIANGLE3(59, 27, 26, 7, 16, 15), _
      New TEST_TRIANGLE3(12, 26, 27, 30, 15, 16), _
      New TEST_TRIANGLE3(27, 6, 12, 16, 26, 30), _
      New TEST_TRIANGLE3(32, 49, 53, 14, 4, 2), _
      New TEST_TRIANGLE3(53, 26, 32, 2, 15, 14), _
      New TEST_TRIANGLE3(16, 32, 26, 29, 14, 15), _
      New TEST_TRIANGLE3(26, 12, 16, 15, 30, 29), _
      New TEST_TRIANGLE3(37, 42, 49, 12, 10, 4), _
      New TEST_TRIANGLE3(49, 32, 37, 4, 14, 12), _
      New TEST_TRIANGLE3(21, 37, 32, 25, 12, 14), _
      New TEST_TRIANGLE3(32, 16, 21, 14, 29, 25), _
      New TEST_TRIANGLE3(35, 30, 61, 19, 21, 9), _
      New TEST_TRIANGLE3(61, 55, 35, 9, 5, 19), _
      New TEST_TRIANGLE3(10, 3, 30, 28, 24, 21), _
      New TEST_TRIANGLE3(30, 35, 10, 21, 19, 28), _
      New TEST_TRIANGLE3(33, 35, 55, 13, 19, 5), _
      New TEST_TRIANGLE3(55, 51, 33, 5, 6, 13), _
      New TEST_TRIANGLE3(18, 10, 35, 27, 28, 19), _
      New TEST_TRIANGLE3(35, 33, 18, 19, 13, 27), _
      New TEST_TRIANGLE3(39, 33, 51, 20, 13, 6), _
      New TEST_TRIANGLE3(51, 44, 39, 6, 8, 20), _
      New TEST_TRIANGLE3(24, 18, 33, 23, 27, 13), _
      New TEST_TRIANGLE3(33, 39, 24, 13, 20, 23), _
      New TEST_TRIANGLE3(34, 28, 58, 18, 16, 7), _
      New TEST_TRIANGLE3(58, 64, 34, 7, 11, 18), _
      New TEST_TRIANGLE3(1, 7, 34, 22, 26, 18), _
      New TEST_TRIANGLE3(28, 34, 7, 16, 18, 26), _
      New TEST_TRIANGLE3(31, 34, 62, 21, 18, 9), _
      New TEST_TRIANGLE3(64, 62, 34, 11, 9, 18), _
      New TEST_TRIANGLE3(4, 1, 34, 24, 22, 18), _
      New TEST_TRIANGLE3(34, 31, 4, 18, 21, 24), _
      New TEST_TRIANGLE3(8, 11, 5, 32, 30, 26), _
      New TEST_TRIANGLE3(5, 0, 8, 26, 22, 32), _
      New TEST_TRIANGLE3(13, 17, 11, 33, 29, 30), _
      New TEST_TRIANGLE3(11, 8, 13, 30, 32, 33), _
      New TEST_TRIANGLE3(15, 22, 17, 31, 25, 29), _
      New TEST_TRIANGLE3(17, 13, 15, 29, 33, 31), _
      New TEST_TRIANGLE3(9, 8, 0, 28, 32, 22), _
      New TEST_TRIANGLE3(0, 2, 9, 22, 24, 28), _
      New TEST_TRIANGLE3(19, 13, 8, 27, 33, 32), _
      New TEST_TRIANGLE3(8, 9, 19, 32, 28, 27), _
      New TEST_TRIANGLE3(25, 15, 13, 23, 31, 33), _
      New TEST_TRIANGLE3(13, 19, 25, 33, 27, 23), _
      New TEST_TRIANGLE3(29, 36, 20, 17, 12, 25), _
      New TEST_TRIANGLE3(20, 14, 29, 25, 31, 17), _
      New TEST_TRIANGLE3(47, 41, 36, 3, 10, 12), _
      New TEST_TRIANGLE3(36, 29, 47, 12, 17, 3), _
      New TEST_TRIANGLE3(38, 29, 14, 20, 17, 31), _
      New TEST_TRIANGLE3(14, 23, 38, 31, 23, 20), _
      New TEST_TRIANGLE3(45, 47, 29, 8, 3, 17), _
      New TEST_TRIANGLE3(29, 38, 45, 17, 20, 8), _
      New TEST_TRIANGLE3(52, 48, 40, 0, 4, 10), _
      New TEST_TRIANGLE3(40, 46, 52, 10, 3, 0), _
      New TEST_TRIANGLE3(57, 54, 48, 1, 2, 4), _
      New TEST_TRIANGLE3(48, 52, 57, 4, 0, 1), _
      New TEST_TRIANGLE3(65, 60, 54, 11, 7, 2), _
      New TEST_TRIANGLE3(54, 57, 65, 2, 1, 11), _
      New TEST_TRIANGLE3(50, 52, 46, 6, 0, 3), _
      New TEST_TRIANGLE3(46, 43, 50, 3, 8, 6), _
      New TEST_TRIANGLE3(56, 57, 52, 5, 1, 0), _
      New TEST_TRIANGLE3(52, 50, 56, 0, 6, 5), _
      New TEST_TRIANGLE3(63, 65, 57, 9, 11, 1), _
      New TEST_TRIANGLE3(57, 56, 63, 1, 5, 9) _
    }

    matrix_Rlower_arm = New Single() { _
      0.939692, 0.31244, 0.0, -41.75563, _
      0.0, 0.0, -0.999999, 4.915868, _
      -0.34202, 0.858423, 0.0, 97.80647, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_Rlower_arm = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-7.977034, -16.998699, 5.000002, 0.940459, 1.177419), _
      New TEST_XYZ_UV(-7.977034, -16.998699, 5.000002, 1.512059, 1.177419), _
      New TEST_XYZ_UV(-7.363417, -16.940021, -7.441553, 0.952732, 0.928588), _
      New TEST_XYZ_UV(-7.363417, -16.940021, -7.441553, 1.247268, 0.689115), _
      New TEST_XYZ_UV(-7.363417, -16.940021, -7.441553, 1.510885, 0.928588), _
      New TEST_XYZ_UV(-7.363416, -16.940014, 10.750242, 0.952732, 0.689115), _
      New TEST_XYZ_UV(-7.363416, -16.940014, 10.750242, 0.952732, 1.292424), _
      New TEST_XYZ_UV(-7.363416, -16.940014, 10.750242, 1.510885, 1.292424), _
      New TEST_XYZ_UV(-6.468256, -6.875823, 5.0, 1.309601, 1.177419), _
      New TEST_XYZ_UV(-5.255462, -6.875818, 9.827704, 0.994891, 0.890399), _
      New TEST_XYZ_UV(-5.255462, -6.875818, 9.827704, 1.309601, 1.273973), _
      New TEST_XYZ_UV(-5.255459, -6.875824, -2.953073, 1.205109, 0.890399), _
      New TEST_XYZ_UV(-5.255459, -6.875824, -2.953073, 1.309601, 1.018358), _
      New TEST_XYZ_UV(-5.000003, 13.47395, 5.0, 0.902606, 1.177419), _
      New TEST_XYZ_UV(-4.062508, 24.078127, 5.0, 0.690522, 1.177419), _
      New TEST_XYZ_UV(-4.062508, 24.078127, 5.0, 1.18125, 1.177419), _
      New TEST_XYZ_UV(-4.062503, 13.473953, 9.062501, 0.902606, 1.258669), _
      New TEST_XYZ_UV(-4.062503, 13.473953, 9.062501, 1.01875, 1.297394), _
      New TEST_XYZ_UV(-4.062503, 13.473954, 0.937501, 0.902606, 1.096169), _
      New TEST_XYZ_UV(-4.062503, 13.473954, 0.937501, 1.18125, 1.297394), _
      New TEST_XYZ_UV(-3.750008, 23.770837, 1.25, 0.696668, 1.102419), _
      New TEST_XYZ_UV(-3.750008, 23.770837, 1.25, 1.175, 1.102419), _
      New TEST_XYZ_UV(-3.750008, 23.770837, 1.25, 1.175, 1.503332), _
      New TEST_XYZ_UV(-3.750005, 23.770838, 8.75, 0.696668, 1.252419), _
      New TEST_XYZ_UV(-3.750005, 23.770838, 8.75, 1.025, 1.503332), _
      New TEST_XYZ_UV(-3.750005, 23.770838, 8.75, 1.175, 1.252419), _
      New TEST_XYZ_UV(-0.000008, 24.078126, 9.0625, 1.1, 1.258669), _
      New TEST_XYZ_UV(-0.000008, 24.078126, 9.0625, 1.1, 1.509478), _
      New TEST_XYZ_UV(-0.000006, 25.000002, 5.0, 1.1, 1.177419), _
      New TEST_XYZ_UV(-0.000006, -6.875822, -4.481198, 1.1, 0.890399), _
      New TEST_XYZ_UV(-0.000006, 13.473961, 0.0, 1.1, 1.297394), _
      New TEST_XYZ_UV(-0.000005, -17.791522, 12.365924, 1.1, 0.672085), _
      New TEST_XYZ_UV(-0.000005, -17.791522, 12.365924, 1.1, 1.324738), _
      New TEST_XYZ_UV(-0.000005, 24.07812, 0.9375, 1.1, 1.096169), _
      New TEST_XYZ_UV(-0.000005, 24.07812, 0.9375, 1.1, 1.509478), _
      New TEST_XYZ_UV(-0.000005, -17.791519, -10.107855, 1.1, 0.672085), _
      New TEST_XYZ_UV(-0.000005, -17.791519, -10.107855, 1.1, 0.875262), _
      New TEST_XYZ_UV(-0.000003, 13.473952, 10.000001, 1.1, 1.297394), _
      New TEST_XYZ_UV(-0.000003, -6.875823, 11.355825, 1.1, 0.890399), _
      New TEST_XYZ_UV(-0.000002, -11.298856, 5.000005, 1.1, 1.177419), _
      New TEST_XYZ_UV(3.749995, 23.770835, 1.25, 1.025, 1.102419), _
      New TEST_XYZ_UV(3.749995, 23.770835, 1.25, 1.025, 1.503332), _
      New TEST_XYZ_UV(3.749995, 23.770835, 1.25, 1.503332, 1.102419), _
      New TEST_XYZ_UV(3.749997, 23.770835, 8.75, 1.025, 1.252419), _
      New TEST_XYZ_UV(3.749997, 23.770835, 8.75, 1.175, 1.503332), _
      New TEST_XYZ_UV(3.749997, 23.770835, 8.75, 1.503332, 1.252419), _
      New TEST_XYZ_UV(4.062496, 24.078128, 5.0, 1.01875, 1.177419), _
      New TEST_XYZ_UV(4.062496, 24.078128, 5.0, 1.509478, 1.177419), _
      New TEST_XYZ_UV(4.062497, 13.473953, 0.937501, 1.01875, 1.297394), _
      New TEST_XYZ_UV(4.062497, 13.473953, 0.937501, 1.297394, 1.096169), _
      New TEST_XYZ_UV(4.0625, 13.473953, 9.062501, 1.18125, 1.297394), _
      New TEST_XYZ_UV(4.0625, 13.473953, 9.062501, 1.297394, 1.258669), _
      New TEST_XYZ_UV(4.999996, 13.473956, 5.0, 1.297394, 1.177419), _
      New TEST_XYZ_UV(5.255451, -6.87582, -2.953074, 0.890399, 1.018358), _
      New TEST_XYZ_UV(5.255451, -6.87582, -2.953074, 0.994891, 0.890399), _
      New TEST_XYZ_UV(5.255454, -6.87582, 9.827704, 0.890399, 1.273973), _
      New TEST_XYZ_UV(5.255454, -6.87582, 9.827704, 1.205109, 0.890399), _
      New TEST_XYZ_UV(6.468251, -6.875821, 5.0, 0.890399, 1.177419), _
      New TEST_XYZ_UV(7.363411, -16.940021, -7.441554, 0.689115, 0.928588), _
      New TEST_XYZ_UV(7.363411, -16.940021, -7.441554, 0.952732, 0.689115), _
      New TEST_XYZ_UV(7.363411, -16.940021, -7.441554, 1.247268, 0.928588), _
      New TEST_XYZ_UV(7.363412, -16.940014, 10.750242, 0.689115, 1.292424), _
      New TEST_XYZ_UV(7.363412, -16.940014, 10.750242, 1.247268, 0.689115), _
      New TEST_XYZ_UV(7.363412, -16.940014, 10.750242, 1.247268, 1.292424), _
      New TEST_XYZ_UV(7.97703, -16.998698, 5.000002, 0.687941, 1.177419), _
      New TEST_XYZ_UV(7.97703, -16.998698, 5.000002, 1.259541, 1.177419) _
    }


    normal_Rlower_arm = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.997571, 0.069181, 0.008127), _
      New TEST_NORMAL(-0.991312, 0.127338, 0.032938), _
      New TEST_NORMAL(-0.749932, 0.279179, -0.599717), _
      New TEST_NORMAL(-0.748497, 0.663072, -0.009295), _
      New TEST_NORMAL(-0.713393, 0.112867, -0.691615), _
      New TEST_NORMAL(-0.703277, 0.145114, 0.695948), _
      New TEST_NORMAL(-0.703054, 0.078333, 0.706809), _
      New TEST_NORMAL(-0.665518, -0.534656, -0.520797), _
      New TEST_NORMAL(-0.604441, 0.518943, 0.604441), _
      New TEST_NORMAL(-0.577126, -0.666452, 0.471983), _
      New TEST_NORMAL(-0.576449, 0.558183, -0.596773), _
      New TEST_NORMAL(-0.560405, -0.828164, -0.009533), _
      New TEST_NORMAL(-0.028761, 0.662826, -0.748221), _
      New TEST_NORMAL(-0.009772, 0.064198, 0.997889), _
      New TEST_NORMAL(-0.009724, 0.140444, -0.990041), _
      New TEST_NORMAL(-0.002669, 0.343697, -0.939077), _
      New TEST_NORMAL(-0.001588, -0.628829, -0.777542), _
      New TEST_NORMAL(0.0, -0.990898, -0.134617), _
      New TEST_NORMAL(0.0, 1.0, 0.0), _
      New TEST_NORMAL(0.006405, 0.08586, 0.996287), _
      New TEST_NORMAL(0.009295, 0.663072, 0.748498), _
      New TEST_NORMAL(0.014652, -0.854442, 0.519341), _
      New TEST_NORMAL(0.559352, -0.827728, 0.044636), _
      New TEST_NORMAL(0.582029, 0.567877, 0.582029), _
      New TEST_NORMAL(0.590472, -0.654809, 0.471772), _
      New TEST_NORMAL(0.609583, 0.52943, -0.590011), _
      New TEST_NORMAL(0.650757, -0.540347, -0.533424), _
      New TEST_NORMAL(0.705145, 0.060609, 0.706468), _
      New TEST_NORMAL(0.709454, 0.114524, 0.695384), _
      New TEST_NORMAL(0.720528, 0.124114, -0.682228), _
      New TEST_NORMAL(0.733523, 0.297349, -0.611169), _
      New TEST_NORMAL(0.748497, 0.663073, 0.009295), _
      New TEST_NORMAL(0.990498, 0.123033, 0.061445), _
      New TEST_NORMAL(0.997101, 0.076044, -0.002749) _
    }

    triangle3_Rlower_arm = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(29, 11, 3, 15, 2, 7), _
      New TEST_TRIANGLE3(3, 35, 29, 7, 16, 15), _
      New TEST_TRIANGLE3(54, 29, 35, 30, 15, 16), _
      New TEST_TRIANGLE3(35, 59, 54, 16, 26, 30), _
      New TEST_TRIANGLE3(30, 19, 11, 14, 4, 2), _
      New TEST_TRIANGLE3(11, 29, 30, 2, 15, 14), _
      New TEST_TRIANGLE3(48, 30, 29, 29, 14, 15), _
      New TEST_TRIANGLE3(29, 54, 48, 15, 30, 29), _
      New TEST_TRIANGLE3(34, 22, 19, 12, 10, 4), _
      New TEST_TRIANGLE3(19, 30, 34, 4, 14, 12), _
      New TEST_TRIANGLE3(41, 34, 30, 25, 12, 14), _
      New TEST_TRIANGLE3(30, 48, 41, 14, 29, 25), _
      New TEST_TRIANGLE3(38, 31, 5, 19, 21, 9), _
      New TEST_TRIANGLE3(5, 9, 38, 9, 5, 19), _
      New TEST_TRIANGLE3(56, 62, 31, 28, 24, 21), _
      New TEST_TRIANGLE3(31, 38, 56, 21, 19, 28), _
      New TEST_TRIANGLE3(37, 38, 9, 13, 19, 5), _
      New TEST_TRIANGLE3(9, 17, 37, 5, 6, 13), _
      New TEST_TRIANGLE3(50, 56, 38, 27, 28, 19), _
      New TEST_TRIANGLE3(38, 37, 50, 19, 13, 27), _
      New TEST_TRIANGLE3(27, 37, 17, 20, 13, 6), _
      New TEST_TRIANGLE3(17, 24, 27, 6, 8, 20), _
      New TEST_TRIANGLE3(44, 50, 37, 23, 27, 13), _
      New TEST_TRIANGLE3(37, 27, 44, 13, 20, 23), _
      New TEST_TRIANGLE3(39, 36, 2, 17, 16, 7), _
      New TEST_TRIANGLE3(2, 0, 39, 7, 11, 17), _
      New TEST_TRIANGLE3(65, 60, 39, 22, 26, 17), _
      New TEST_TRIANGLE3(36, 39, 60, 16, 17, 26), _
      New TEST_TRIANGLE3(32, 39, 6, 21, 17, 9), _
      New TEST_TRIANGLE3(0, 6, 39, 11, 9, 17), _
      New TEST_TRIANGLE3(63, 65, 39, 24, 22, 17), _
      New TEST_TRIANGLE3(39, 32, 63, 17, 21, 24), _
      New TEST_TRIANGLE3(57, 53, 58, 32, 30, 26), _
      New TEST_TRIANGLE3(58, 64, 57, 26, 22, 32), _
      New TEST_TRIANGLE3(52, 49, 53, 33, 29, 30), _
      New TEST_TRIANGLE3(53, 57, 52, 30, 32, 33), _
      New TEST_TRIANGLE3(47, 42, 49, 31, 25, 29), _
      New TEST_TRIANGLE3(49, 52, 47, 29, 33, 31), _
      New TEST_TRIANGLE3(55, 57, 64, 28, 32, 22), _
      New TEST_TRIANGLE3(64, 61, 55, 22, 24, 28), _
      New TEST_TRIANGLE3(51, 52, 57, 27, 33, 32), _
      New TEST_TRIANGLE3(57, 55, 51, 32, 28, 27), _
      New TEST_TRIANGLE3(45, 47, 52, 23, 31, 33), _
      New TEST_TRIANGLE3(52, 51, 45, 33, 27, 23), _
      New TEST_TRIANGLE3(28, 33, 40, 18, 12, 25), _
      New TEST_TRIANGLE3(40, 46, 28, 25, 31, 18), _
      New TEST_TRIANGLE3(15, 21, 33, 3, 10, 12), _
      New TEST_TRIANGLE3(33, 28, 15, 12, 18, 3), _
      New TEST_TRIANGLE3(26, 28, 46, 20, 18, 31), _
      New TEST_TRIANGLE3(46, 43, 26, 31, 23, 20), _
      New TEST_TRIANGLE3(25, 15, 28, 8, 3, 18), _
      New TEST_TRIANGLE3(28, 26, 25, 18, 20, 8), _
      New TEST_TRIANGLE3(13, 18, 20, 0, 4, 10), _
      New TEST_TRIANGLE3(20, 14, 13, 10, 3, 0), _
      New TEST_TRIANGLE3(8, 12, 18, 1, 2, 4), _
      New TEST_TRIANGLE3(18, 13, 8, 4, 0, 1), _
      New TEST_TRIANGLE3(1, 4, 12, 11, 7, 2), _
      New TEST_TRIANGLE3(12, 8, 1, 2, 1, 11), _
      New TEST_TRIANGLE3(16, 13, 14, 6, 0, 3), _
      New TEST_TRIANGLE3(14, 23, 16, 3, 8, 6), _
      New TEST_TRIANGLE3(10, 8, 13, 5, 1, 0), _
      New TEST_TRIANGLE3(13, 16, 10, 0, 6, 5), _
      New TEST_TRIANGLE3(7, 1, 8, 9, 11, 1), _
      New TEST_TRIANGLE3(8, 10, 7, 1, 5, 9) _
    }

    matrix_rope_belt = New Single() { _
      0.93358, 0.0, -0.358367, 10.1313, _
      0.195181, 0.83867, 0.508464, -17.11292, _
      0.300552, -0.544639, 0.782966, 95.04119, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_rope_belt = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-22.118886, 5.454729, 21.057842, 2.463346, 3.849128), _
      New TEST_XYZ_UV(-22.118886, 5.454729, 21.057842, 2.998413, 1.536654), _
      New TEST_XYZ_UV(-21.691233, 1.034451, 17.818903, 2.672261, 1.091544), _
      New TEST_XYZ_UV(-21.691233, 1.034451, 17.818903, 2.672261, 3.806064), _
      New TEST_XYZ_UV(-21.691233, 1.034451, 17.818903, 2.908456, 3.806064), _
      New TEST_XYZ_UV(-21.517785, 4.365454, 22.623769, 1.426966, 3.788598), _
      New TEST_XYZ_UV(-21.517785, 4.365454, 22.623769, 3.156098, 1.426966), _
      New TEST_XYZ_UV(-21.090132, -0.054824, 19.38483, 0.981856, 3.745535), _
      New TEST_XYZ_UV(-21.090132, -0.054824, 19.38483, 2.829946, 0.981856), _
      New TEST_XYZ_UV(-21.090132, -0.054824, 19.38483, 2.829946, 3.745535), _
      New TEST_XYZ_UV(-20.195174, 5.697726, 20.488429, 2.438877, 3.655415), _
      New TEST_XYZ_UV(-19.874108, 2.379075, 18.056707, 2.773056, 3.623085), _
      New TEST_XYZ_UV(-19.723642, 15.746793, 27.297663, 1.426963, 3.607933), _
      New TEST_XYZ_UV(-19.723642, 15.746793, 27.297663, 3.626747, 2.573037), _
      New TEST_XYZ_UV(-19.594068, 4.608448, 22.054362, 1.451436, 3.594885), _
      New TEST_XYZ_UV(-19.273001, 1.289797, 19.62264, 1.117256, 3.562555), _
      New TEST_XYZ_UV(-19.122538, 14.657514, 28.863596, 2.46335, 3.547403), _
      New TEST_XYZ_UV(-19.122538, 14.657514, 28.863596, 3.784432, 2.46335), _
      New TEST_XYZ_UV(-17.913047, 15.503749, 26.433577, 1.451437, 3.425611), _
      New TEST_XYZ_UV(-17.311946, 14.41447, 27.999511, 2.438876, 3.365081), _
      New TEST_XYZ_UV(-17.238588, 20.167029, 29.418499, 0.159691, 3.357694), _
      New TEST_XYZ_UV(-17.238588, 20.167029, 29.418499, 0.981857, 3.357694), _
      New TEST_XYZ_UV(-17.238588, 20.167029, 29.418499, 3.840309, 3.018143), _
      New TEST_XYZ_UV(-17.117995, -0.286973, 15.144206, 2.402926, 3.345551), _
      New TEST_XYZ_UV(-17.117995, -0.286973, 15.144206, 3.04152, 3.345551), _
      New TEST_XYZ_UV(-16.637482, 19.077749, 30.984431, 0.002005, 3.297164), _
      New TEST_XYZ_UV(-16.637482, 19.077749, 30.984431, 2.908456, 3.297164), _
      New TEST_XYZ_UV(-16.637482, 19.077749, 30.984431, 3.997994, 2.908456), _
      New TEST_XYZ_UV(-16.51689, -1.376251, 16.710139, 0.848792, 3.285022), _
      New TEST_XYZ_UV(-16.51689, -1.376251, 16.710139, 2.560611, 3.285022), _
      New TEST_XYZ_UV(-16.452398, 1.390374, 16.055476, 2.872617, 3.278527), _
      New TEST_XYZ_UV(-16.047281, 18.822432, 28.025885, 1.117254, 3.237733), _
      New TEST_XYZ_UV(-15.85129, 0.301095, 17.621407, 1.017696, 3.217997), _
      New TEST_XYZ_UV(-15.446176, 17.733152, 29.591817, 2.773058, 3.177203), _
      New TEST_XYZ_UV(-12.165384, 19.811126, 27.2235, 1.017696, 2.846836), _
      New TEST_XYZ_UV(-12.050281, 21.488461, 28.346096, 0.267679, 2.835245), _
      New TEST_XYZ_UV(-12.050281, 21.488461, 28.346096, 0.848792, 2.835245), _
      New TEST_XYZ_UV(-11.564277, 18.721844, 28.789439, 2.872617, 2.786306), _
      New TEST_XYZ_UV(-11.449173, 20.399184, 29.912028, 0.109994, 2.774715), _
      New TEST_XYZ_UV(-11.449173, 20.399184, 29.912028, 3.04152, 2.774715), _
      New TEST_XYZ_UV(-7.701025, 1.000002, -7.456767, 0.127068, 1.088074), _
      New TEST_XYZ_UV(-7.701025, 1.000002, -7.456767, 2.911926, 2.397287), _
      New TEST_XYZ_UV(-7.701025, 1.000002, -7.456767, 3.872932, 2.397287), _
      New TEST_XYZ_UV(-7.701025, -0.999997, -7.456765, 0.127068, 0.88668), _
      New TEST_XYZ_UV(-7.701025, -0.999997, -7.456765, 0.127068, 2.397287), _
      New TEST_XYZ_UV(-7.701025, -0.999997, -7.456765, 3.11332, 2.397287), _
      New TEST_XYZ_UV(-5.833864, 1.000002, -8.173502, 2.911926, 2.209269), _
      New TEST_XYZ_UV(-5.833864, 1.000002, -8.173502, 3.945105, 1.088074), _
      New TEST_XYZ_UV(-5.833864, 1.000002, -8.173502, 3.945105, 2.209269), _
      New TEST_XYZ_UV(-5.833864, -0.999997, -8.173501, 0.054895, 2.209269), _
      New TEST_XYZ_UV(-5.833864, -0.999997, -8.173501, 3.113321, 2.209269), _
      New TEST_XYZ_UV(-5.833864, -0.999997, -8.173501, 3.945105, 0.886679), _
      New TEST_XYZ_UV(-1.000003, -0.999996, -8.698735, 0.002005, 0.886679), _
      New TEST_XYZ_UV(-1.000003, -0.999996, -8.698735, 0.002005, 1.722512), _
      New TEST_XYZ_UV(-1.000003, -0.999996, -8.698735, 3.113321, 1.722512), _
      New TEST_XYZ_UV(-1.000001, 1.000001, -8.69873, 0.002005, 1.088074), _
      New TEST_XYZ_UV(-1.000001, 1.000001, -8.69873, 2.911926, 1.722512), _
      New TEST_XYZ_UV(-1.000001, 1.000001, -8.69873, 3.997994, 1.722512), _
      New TEST_XYZ_UV(-1.000001, 0.999999, 10.000002, 1.884918, 1.088074), _
      New TEST_XYZ_UV(-1.000001, 0.999999, 10.000002, 2.115082, 1.722512), _
      New TEST_XYZ_UV(-1.0, -1.000001, 10.000003, 1.884918, 0.886679), _
      New TEST_XYZ_UV(-1.0, -1.000001, 10.000003, 1.884918, 1.722512), _
      New TEST_XYZ_UV(-0.999998, 1.000002, 10.000003, 1.884919, 1.088074), _
      New TEST_XYZ_UV(-0.999998, 1.000002, 10.000003, 2.115081, 1.722512), _
      New TEST_XYZ_UV(-0.999998, -0.999999, 10.000003, 1.884919, 0.886679), _
      New TEST_XYZ_UV(-0.999998, -0.999999, 10.000003, 1.884919, 1.722512), _
      New TEST_XYZ_UV(0.867162, 1.000002, 9.283267, 2.187255, 1.088074), _
      New TEST_XYZ_UV(0.867162, 1.000002, 9.283267, 2.187255, 1.534494), _
      New TEST_XYZ_UV(0.867163, -0.999999, 9.283268, 1.812745, 1.534494), _
      New TEST_XYZ_UV(0.867163, -0.999999, 9.283268, 2.187255, 0.886679), _
      New TEST_XYZ_UV(0.999999, 1.000002, -8.69873, 2.911926, 1.521117), _
      New TEST_XYZ_UV(0.999999, 1.000002, -8.69873, 3.997994, 1.088074), _
      New TEST_XYZ_UV(0.999999, 1.000002, -8.69873, 3.997994, 1.521117), _
      New TEST_XYZ_UV(0.999999, 0.999999, 10.000001, 2.115082, 1.088074), _
      New TEST_XYZ_UV(0.999999, 0.999999, 10.000001, 2.115082, 1.521117), _
      New TEST_XYZ_UV(0.999999, -0.999999, -8.698729, 0.002005, 1.521117), _
      New TEST_XYZ_UV(0.999999, -0.999999, -8.698729, 3.113321, 1.521117), _
      New TEST_XYZ_UV(0.999999, -0.999999, -8.698729, 3.997994, 0.886679), _
      New TEST_XYZ_UV(1.0, -1.000001, 10.000002, 1.884918, 1.521117), _
      New TEST_XYZ_UV(1.0, -1.000001, 10.000002, 2.115082, 0.886679), _
      New TEST_XYZ_UV(3.937837, -0.286964, 7.061617, 1.589031, 1.225285), _
      New TEST_XYZ_UV(3.937837, -0.286964, 7.061617, 3.04152, 1.225285), _
      New TEST_XYZ_UV(4.052933, 1.390375, 8.184209, 2.872616, 1.213695), _
      New TEST_XYZ_UV(4.538942, -1.376242, 8.627549, 0.848793, 1.164755), _
      New TEST_XYZ_UV(4.538942, -1.376242, 8.627549, 1.746716, 1.164755), _
      New TEST_XYZ_UV(4.654038, 0.3011, 9.750134, 1.017696, 1.153165), _
      New TEST_XYZ_UV(7.934843, 2.379066, 7.381826, 2.773058, 0.822797), _
      New TEST_XYZ_UV(8.339947, 19.811124, 19.35223, 1.017696, 0.782004), _
      New TEST_XYZ_UV(8.535949, 1.289787, 8.947758, 1.117254, 0.762267), _
      New TEST_XYZ_UV(8.941054, 18.721846, 20.918162, 2.872617, 0.721474), _
      New TEST_XYZ_UV(9.005546, 21.488468, 20.263497, 0.848792, 0.714979), _
      New TEST_XYZ_UV(9.005546, 21.488468, 20.263497, 1.081574, 0.714979), _
      New TEST_XYZ_UV(9.126153, 1.034471, 5.989212, 1.481042, 0.702835), _
      New TEST_XYZ_UV(9.126153, 1.034471, 5.989212, 2.518958, 1.091545), _
      New TEST_XYZ_UV(9.126153, 1.034471, 5.989212, 2.908455, 0.702835), _
      New TEST_XYZ_UV(9.606656, 20.399187, 21.829436, 0.923889, 0.654449), _
      New TEST_XYZ_UV(9.606656, 20.399187, 21.829436, 3.041521, 0.654449), _
      New TEST_XYZ_UV(9.727256, -0.054808, 7.555145, 0.981857, 0.642306), _
      New TEST_XYZ_UV(9.727256, -0.054808, 7.555145, 1.638728, 0.642306), _
      New TEST_XYZ_UV(9.727256, -0.054808, 7.555145, 2.361273, 0.981857), _
      New TEST_XYZ_UV(9.800611, 5.697749, 8.974133, 2.438875, 0.634919), _
      New TEST_XYZ_UV(10.401715, 4.608471, 10.540067, 1.451437, 0.574389), _
      New TEST_XYZ_UV(11.611205, 5.454709, 8.11005, 2.305395, 1.536651), _
      New TEST_XYZ_UV(11.611205, 5.454709, 8.11005, 2.463349, 0.452597), _
      New TEST_XYZ_UV(11.761667, 18.82242, 17.351003, 1.117256, 0.437445), _
      New TEST_XYZ_UV(12.08273, 15.503775, 14.919277, 1.451435, 0.405115), _
      New TEST_XYZ_UV(12.21231, 4.365429, 9.675982, 1.426964, 0.392067), _
      New TEST_XYZ_UV(12.21231, 4.365429, 9.675982, 2.14771, 1.426964), _
      New TEST_XYZ_UV(12.362774, 17.733145, 18.916937, 2.773057, 0.376916), _
      New TEST_XYZ_UV(12.683837, 14.414497, 16.485209, 2.438878, 0.344586), _
      New TEST_XYZ_UV(13.578795, 20.167044, 17.588806, 0.981856, 0.254465), _
      New TEST_XYZ_UV(13.578795, 20.167044, 17.588806, 1.350909, 0.254465), _
      New TEST_XYZ_UV(13.578795, 20.167044, 17.588806, 1.350909, 3.018144), _
      New TEST_XYZ_UV(14.006446, 15.746775, 14.349864, 1.426965, 0.211402), _
      New TEST_XYZ_UV(14.006446, 15.746775, 14.349864, 1.677062, 2.573035), _
      New TEST_XYZ_UV(14.179904, 19.077767, 19.154738, 1.193224, 0.193936), _
      New TEST_XYZ_UV(14.179904, 19.077767, 19.154738, 1.193224, 2.908457), _
      New TEST_XYZ_UV(14.179904, 19.077767, 19.154738, 2.908457, 0.193936), _
      New TEST_XYZ_UV(14.607554, 14.657497, 15.915796, 1.519377, 2.463347), _
      New TEST_XYZ_UV(14.607554, 14.657497, 15.915796, 2.463347, 0.150872) _
    }


    normal_rope_belt = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.904523, 0.2797, -0.32188), _
      New TEST_NORMAL(-0.863288, 0.456883, -0.214458), _
      New TEST_NORMAL(-0.815493, -0.13234, -0.563434), _
      New TEST_NORMAL(-0.745907, -0.57735, -0.332099), _
      New TEST_NORMAL(-0.745907, 0.57735, -0.332099), _
      New TEST_NORMAL(-0.707107, 0.707107, 0.0), _
      New TEST_NORMAL(-0.707107, -0.707107, 0.0), _
      New TEST_NORMAL(-0.660141, 0.707107, 0.253404), _
      New TEST_NORMAL(-0.660141, -0.707107, 0.253404), _
      New TEST_NORMAL(-0.598201, 0.801342, 0.002635), _
      New TEST_NORMAL(-0.57735, -0.577349, -0.577351), _
      New TEST_NORMAL(-0.57735, 0.577351, -0.57735), _
      New TEST_NORMAL(-0.49805, -0.456883, 0.737024), _
      New TEST_NORMAL(-0.456813, -0.279701, 0.844446), _
      New TEST_NORMAL(-0.446313, -0.801342, 0.398315), _
      New TEST_NORMAL(-0.445797, -0.243618, -0.861345), _
      New TEST_NORMAL(-0.300554, 0.544636, -0.782968), _
      New TEST_NORMAL(-0.300554, 0.544642, -0.782964), _
      New TEST_NORMAL(-0.300553, 0.544636, -0.782968), _
      New TEST_NORMAL(-0.300553, 0.544639, -0.782966), _
      New TEST_NORMAL(-0.300553, 0.544639, -0.782966), _
      New TEST_NORMAL(-0.300553, 0.544639, -0.782966), _
      New TEST_NORMAL(-0.300553, 0.544639, -0.782967), _
      New TEST_NORMAL(-0.300553, 0.544639, -0.782966), _
      New TEST_NORMAL(-0.300553, 0.544639, -0.782966), _
      New TEST_NORMAL(-0.245061, -0.243616, -0.938401), _
      New TEST_NORMAL(-0.229019, 0.132339, 0.964384), _
      New TEST_NORMAL(-0.161111, 0.979649, -0.11971), _
      New TEST_NORMAL(-0.039624, -0.979649, 0.196768), _
      New TEST_NORMAL(0.039624, 0.979649, -0.196769), _
      New TEST_NORMAL(0.161111, -0.979649, 0.119713), _
      New TEST_NORMAL(0.22902, -0.132339, -0.964384), _
      New TEST_NORMAL(0.245061, 0.243616, 0.938401), _
      New TEST_NORMAL(0.300549, -0.544639, 0.782968), _
      New TEST_NORMAL(0.30055, -0.544639, 0.782967), _
      New TEST_NORMAL(0.300552, -0.54464, 0.782966), _
      New TEST_NORMAL(0.300552, -0.54464, 0.782966), _
      New TEST_NORMAL(0.300553, -0.544639, 0.782966), _
      New TEST_NORMAL(0.300553, -0.544639, 0.782966), _
      New TEST_NORMAL(0.300553, -0.544639, 0.782966), _
      New TEST_NORMAL(0.300553, -0.544636, 0.782968), _
      New TEST_NORMAL(0.300555, -0.544636, 0.782968), _
      New TEST_NORMAL(0.332099, 0.57735, -0.745907), _
      New TEST_NORMAL(0.332099, -0.57735, -0.745907), _
      New TEST_NORMAL(0.445796, 0.243616, 0.861346), _
      New TEST_NORMAL(0.446311, 0.801343, -0.398316), _
      New TEST_NORMAL(0.456812, 0.279701, -0.844446), _
      New TEST_NORMAL(0.498048, 0.456884, -0.737025), _
      New TEST_NORMAL(0.577351, 0.577351, -0.57735), _
      New TEST_NORMAL(0.577351, -0.577351, -0.577349), _
      New TEST_NORMAL(0.5982, -0.801342, -0.002634), _
      New TEST_NORMAL(0.660141, -0.707107, -0.253404), _
      New TEST_NORMAL(0.660141, 0.707107, -0.253404), _
      New TEST_NORMAL(0.707107, -0.707107, 0.0), _
      New TEST_NORMAL(0.707107, 0.707107, 0.0), _
      New TEST_NORMAL(0.815493, 0.132341, 0.563433), _
      New TEST_NORMAL(0.863288, -0.456883, 0.214458), _
      New TEST_NORMAL(0.904523, -0.2797, 0.321878) _
    }

    triangle3_rope_belt = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(70, 56, 54, 48, 11, 10), _
      New TEST_TRIANGLE3(54, 76, 70, 10, 49, 48), _
      New TEST_TRIANGLE3(78, 75, 53, 53, 49, 10), _
      New TEST_TRIANGLE3(53, 61, 78, 10, 6, 53), _
      New TEST_TRIANGLE3(73, 71, 77, 54, 48, 49), _
      New TEST_TRIANGLE3(77, 79, 73, 49, 53, 54), _
      New TEST_TRIANGLE3(59, 57, 72, 5, 11, 48), _
      New TEST_TRIANGLE3(72, 74, 59, 48, 54, 5), _
      New TEST_TRIANGLE3(60, 52, 55, 6, 10, 11), _
      New TEST_TRIANGLE3(55, 58, 60, 11, 5, 6), _
      New TEST_TRIANGLE3(46, 41, 45, 42, 4, 3), _
      New TEST_TRIANGLE3(45, 50, 46, 3, 43, 42), _
      New TEST_TRIANGLE3(68, 49, 44, 51, 43, 3), _
      New TEST_TRIANGLE3(44, 65, 68, 3, 8, 51), _
      New TEST_TRIANGLE3(66, 47, 51, 52, 42, 43), _
      New TEST_TRIANGLE3(51, 69, 66, 43, 51, 52), _
      New TEST_TRIANGLE3(63, 42, 48, 7, 4, 42), _
      New TEST_TRIANGLE3(48, 67, 63, 42, 52, 7), _
      New TEST_TRIANGLE3(64, 43, 40, 8, 3, 4), _
      New TEST_TRIANGLE3(40, 62, 64, 4, 7, 8), _
      New TEST_TRIANGLE3(37, 33, 26, 39, 37, 26), _
      New TEST_TRIANGLE3(26, 39, 37, 26, 32, 39), _
      New TEST_TRIANGLE3(36, 21, 31, 27, 9, 21), _
      New TEST_TRIANGLE3(31, 34, 36, 21, 17, 27), _
      New TEST_TRIANGLE3(38, 25, 20, 32, 26, 9), _
      New TEST_TRIANGLE3(20, 35, 38, 9, 27, 32), _
      New TEST_TRIANGLE3(89, 37, 39, 38, 39, 32), _
      New TEST_TRIANGLE3(39, 96, 89, 32, 44, 38), _
      New TEST_TRIANGLE3(90, 36, 34, 29, 27, 17), _
      New TEST_TRIANGLE3(34, 87, 90, 17, 18, 29), _
      New TEST_TRIANGLE3(95, 38, 35, 44, 32, 27), _
      New TEST_TRIANGLE3(35, 91, 95, 27, 29, 44), _
      New TEST_TRIANGLE3(108, 89, 96, 37, 38, 44), _
      New TEST_TRIANGLE3(96, 117, 108, 44, 55, 37), _
      New TEST_TRIANGLE3(110, 90, 87, 45, 29, 18), _
      New TEST_TRIANGLE3(87, 104, 110, 18, 23, 45), _
      New TEST_TRIANGLE3(115, 95, 91, 55, 44, 29), _
      New TEST_TRIANGLE3(91, 111, 115, 29, 45, 55), _
      New TEST_TRIANGLE3(109, 108, 117, 37, 37, 55), _
      New TEST_TRIANGLE3(117, 119, 109, 55, 57, 37), _
      New TEST_TRIANGLE3(113, 110, 104, 47, 45, 23), _
      New TEST_TRIANGLE3(104, 105, 113, 23, 23, 47), _
      New TEST_TRIANGLE3(118, 116, 112, 57, 55, 45), _
      New TEST_TRIANGLE3(112, 114, 118, 45, 47, 57), _
      New TEST_TRIANGLE3(101, 109, 119, 37, 37, 57), _
      New TEST_TRIANGLE3(119, 106, 101, 57, 56, 37), _
      New TEST_TRIANGLE3(103, 113, 105, 46, 47, 23), _
      New TEST_TRIANGLE3(105, 100, 103, 23, 23, 46), _
      New TEST_TRIANGLE3(107, 118, 114, 56, 57, 47), _
      New TEST_TRIANGLE3(114, 102, 107, 47, 46, 56), _
      New TEST_TRIANGLE3(88, 101, 106, 35, 37, 56), _
      New TEST_TRIANGLE3(106, 97, 88, 56, 50, 35), _
      New TEST_TRIANGLE3(94, 103, 100, 31, 46, 23), _
      New TEST_TRIANGLE3(100, 86, 94, 23, 23, 31), _
      New TEST_TRIANGLE3(99, 107, 102, 50, 56, 46), _
      New TEST_TRIANGLE3(102, 93, 99, 46, 31, 50), _
      New TEST_TRIANGLE3(85, 88, 97, 40, 35, 50), _
      New TEST_TRIANGLE3(97, 83, 85, 50, 30, 40), _
      New TEST_TRIANGLE3(81, 94, 86, 25, 31, 23), _
      New TEST_TRIANGLE3(86, 82, 81, 23, 19, 25), _
      New TEST_TRIANGLE3(84, 98, 92, 30, 50, 31), _
      New TEST_TRIANGLE3(92, 80, 84, 31, 25, 30), _
      New TEST_TRIANGLE3(32, 85, 83, 41, 40, 30), _
      New TEST_TRIANGLE3(83, 28, 32, 30, 28, 41), _
      New TEST_TRIANGLE3(24, 81, 82, 15, 25, 19), _
      New TEST_TRIANGLE3(82, 30, 24, 19, 16, 15), _
      New TEST_TRIANGLE3(29, 84, 80, 28, 30, 25), _
      New TEST_TRIANGLE3(80, 23, 29, 25, 15, 28), _
      New TEST_TRIANGLE3(15, 32, 28, 34, 41, 28), _
      New TEST_TRIANGLE3(28, 7, 15, 28, 14, 34), _
      New TEST_TRIANGLE3(4, 24, 30, 2, 15, 16), _
      New TEST_TRIANGLE3(30, 11, 4, 16, 20, 2), _
      New TEST_TRIANGLE3(9, 29, 23, 14, 28, 15), _
      New TEST_TRIANGLE3(23, 3, 9, 15, 2, 14), _
      New TEST_TRIANGLE3(14, 15, 7, 33, 34, 14), _
      New TEST_TRIANGLE3(7, 5, 14, 14, 12, 33), _
      New TEST_TRIANGLE3(0, 4, 11, 0, 2, 20), _
      New TEST_TRIANGLE3(11, 10, 0, 20, 22, 0), _
      New TEST_TRIANGLE3(6, 8, 2, 12, 14, 2), _
      New TEST_TRIANGLE3(2, 1, 6, 2, 0, 12), _
      New TEST_TRIANGLE3(19, 14, 5, 36, 33, 12), _
      New TEST_TRIANGLE3(5, 16, 19, 12, 13, 36), _
      New TEST_TRIANGLE3(12, 0, 10, 1, 0, 22), _
      New TEST_TRIANGLE3(10, 18, 12, 22, 24, 1), _
      New TEST_TRIANGLE3(17, 6, 1, 13, 12, 0), _
      New TEST_TRIANGLE3(1, 13, 17, 0, 1, 13), _
      New TEST_TRIANGLE3(33, 19, 16, 37, 36, 13), _
      New TEST_TRIANGLE3(16, 26, 33, 13, 26, 37), _
      New TEST_TRIANGLE3(21, 12, 18, 9, 1, 24), _
      New TEST_TRIANGLE3(18, 31, 21, 24, 21, 9), _
      New TEST_TRIANGLE3(27, 17, 13, 26, 13, 1), _
      New TEST_TRIANGLE3(13, 22, 27, 1, 9, 26) _
    }

    matrix_Lupper_arm = New Single() { _
      0.983734, -0.139609, -0.044945, 30.8662453, _
      -0.044892, 0.003161, -0.998982, 5.000385, _
      0.166908, 0.823691, -0.003783, 137.520657, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_Lupper_arm = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-5.000004, 13.473963, 5.0, 1.378698, 1.1), _
      New TEST_XYZ_UV(-5.000002, -13.473957, 4.999999, 0.83974, 1.1), _
      New TEST_XYZ_UV(-4.062505, -13.473956, 9.0625, 0.83974, 1.18125), _
      New TEST_XYZ_UV(-4.062505, -13.473956, 9.0625, 1.18125, 0.83974), _
      New TEST_XYZ_UV(-4.062504, -24.078128, 4.999999, 0.627656, 1.1), _
      New TEST_XYZ_UV(-4.062504, -24.078128, 4.999999, 1.18125, 1.1), _
      New TEST_XYZ_UV(-4.062504, -13.473961, 0.937499, 0.83974, 1.01875), _
      New TEST_XYZ_UV(-4.062504, -13.473961, 0.937499, 1.01875, 0.83974), _
      New TEST_XYZ_UV(-4.062502, 13.473954, 9.062501, 1.18125, 1.378698), _
      New TEST_XYZ_UV(-4.062502, 13.473954, 9.062501, 1.378698, 1.18125), _
      New TEST_XYZ_UV(-4.062502, 13.473958, 0.9375, 1.01875, 1.378698), _
      New TEST_XYZ_UV(-4.062502, 13.473958, 0.9375, 1.378698, 1.01875), _
      New TEST_XYZ_UV(-4.062501, 24.07814, 5.0, 1.590781, 1.1), _
      New TEST_XYZ_UV(-3.750005, -23.770835, 8.75, 0.633802, 1.175), _
      New TEST_XYZ_UV(-3.750005, -23.770835, 8.75, 1.175, 0.633802), _
      New TEST_XYZ_UV(-3.750005, -23.770835, 8.75, 1.175, 1.175), _
      New TEST_XYZ_UV(-3.750003, 23.770843, 8.750001, 1.175, 1.584635), _
      New TEST_XYZ_UV(-3.750003, 23.770843, 8.750001, 1.584635, 1.175), _
      New TEST_XYZ_UV(-3.750003, 23.770846, 1.25, 1.025, 1.584635), _
      New TEST_XYZ_UV(-3.750003, 23.770846, 1.25, 1.584635, 1.025), _
      New TEST_XYZ_UV(-3.750003, -23.770832, 1.25, 0.633802, 1.025), _
      New TEST_XYZ_UV(-3.750003, -23.770832, 1.25, 1.025, 0.633802), _
      New TEST_XYZ_UV(-3.750003, -23.770832, 1.25, 1.175, 1.025), _
      New TEST_XYZ_UV(-0.000006, -24.07812, 0.9375, 1.1, 1.01875), _
      New TEST_XYZ_UV(-0.000006, -24.07812, 0.9375, 1.1, 0.627656), _
      New TEST_XYZ_UV(-0.000005, 24.078136, 9.062501, 1.1, 1.590781), _
      New TEST_XYZ_UV(-0.000004, 13.473951, 10.000001, 1.1, 1.378698), _
      New TEST_XYZ_UV(-0.000003, -25.000003, 5.000001, 1.1, 1.1), _
      New TEST_XYZ_UV(-0.000003, 24.078121, 0.9375, 1.1, 1.590781), _
      New TEST_XYZ_UV(-0.000003, -13.473959, 9.999998, 1.1, 0.83974), _
      New TEST_XYZ_UV(-0.000002, -13.473964, 0.0, 1.1, 0.83974), _
      New TEST_XYZ_UV(-0.000002, -24.078124, 9.0625, 1.1, 0.627656), _
      New TEST_XYZ_UV(-0.000002, -24.078124, 9.0625, 1.1, 1.18125), _
      New TEST_XYZ_UV(-0.000002, 13.473974, 0.000001, 1.1, 1.378698), _
      New TEST_XYZ_UV(3.749993, -23.770827, 1.25, 1.025, 1.025), _
      New TEST_XYZ_UV(3.749993, -23.770827, 1.25, 1.175, 0.633802), _
      New TEST_XYZ_UV(3.749993, -23.770827, 1.25, 1.566198, 1.025), _
      New TEST_XYZ_UV(3.749996, 23.770847, 8.75, 0.615365, 1.175), _
      New TEST_XYZ_UV(3.749996, 23.770847, 8.75, 1.025, 1.584635), _
      New TEST_XYZ_UV(3.749997, -23.770831, 8.75, 1.025, 0.633802), _
      New TEST_XYZ_UV(3.749997, -23.770831, 8.75, 1.025, 1.175), _
      New TEST_XYZ_UV(3.749997, -23.770831, 8.75, 1.566198, 1.175), _
      New TEST_XYZ_UV(3.749998, 23.770832, 1.25, 0.615365, 1.025), _
      New TEST_XYZ_UV(3.749998, 23.770832, 1.25, 1.175, 1.584635), _
      New TEST_XYZ_UV(4.062493, -13.473957, 0.9375, 1.18125, 0.83974), _
      New TEST_XYZ_UV(4.062493, -13.473957, 0.9375, 1.36026, 1.01875), _
      New TEST_XYZ_UV(4.062495, -24.078125, 5.0, 1.01875, 1.1), _
      New TEST_XYZ_UV(4.062495, -24.078125, 5.0, 1.572344, 1.1), _
      New TEST_XYZ_UV(4.062496, 13.473953, 0.9375, 0.821302, 1.01875), _
      New TEST_XYZ_UV(4.062496, 13.473953, 0.9375, 1.18125, 1.378698), _
      New TEST_XYZ_UV(4.062497, 24.078116, 5.0, 0.609219, 1.1), _
      New TEST_XYZ_UV(4.062499, 13.473948, 9.0625, 0.821302, 1.18125), _
      New TEST_XYZ_UV(4.062499, 13.473948, 9.0625, 1.01875, 1.378698), _
      New TEST_XYZ_UV(4.062501, -13.473963, 9.0625, 1.01875, 0.83974), _
      New TEST_XYZ_UV(4.062501, -13.473963, 9.0625, 1.36026, 1.18125), _
      New TEST_XYZ_UV(4.999993, -13.473956, 5.0, 1.36026, 1.1), _
      New TEST_XYZ_UV(4.999997, 13.473963, 5.0, 0.821302, 1.1) _
    }


    normal_Lupper_arm = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.999392, -0.034076, -0.007415), _
      New TEST_NORMAL(-0.999392, 0.034076, 0.007416), _
      New TEST_NORMAL(-0.99761, -0.067336, -0.015469), _
      New TEST_NORMAL(-0.748498, 0.663072, -0.009294), _
      New TEST_NORMAL(-0.711854, 0.03261, 0.70157), _
      New TEST_NORMAL(-0.706947, 0.021292, -0.706946), _
      New TEST_NORMAL(-0.706455, -0.042881, -0.706457), _
      New TEST_NORMAL(-0.706421, -0.044038, -0.706421), _
      New TEST_NORMAL(-0.70157, -0.03261, 0.711854), _
      New TEST_NORMAL(-0.692012, -0.070043, 0.71848), _
      New TEST_NORMAL(-0.609583, 0.529429, 0.590011), _
      New TEST_NORMAL(-0.58203, 0.567876, -0.582029), _
      New TEST_NORMAL(-0.015469, -0.067336, 0.99761), _
      New TEST_NORMAL(-0.015469, -0.067336, -0.99761), _
      New TEST_NORMAL(-0.009295, 0.663072, -0.748498), _
      New TEST_NORMAL(-0.007416, -0.034076, 0.999392), _
      New TEST_NORMAL(-0.007416, -0.034076, -0.999392), _
      New TEST_NORMAL(0.0, 1.0, 0.0), _
      New TEST_NORMAL(0.007415, 0.034076, 0.999392), _
      New TEST_NORMAL(0.007416, 0.034076, -0.999392), _
      New TEST_NORMAL(0.02876, 0.662826, 0.748221), _
      New TEST_NORMAL(0.57645, 0.558182, 0.596773), _
      New TEST_NORMAL(0.604441, 0.518943, -0.604441), _
      New TEST_NORMAL(0.70157, 0.03261, 0.711854), _
      New TEST_NORMAL(0.703817, -0.096351, -0.703817), _
      New TEST_NORMAL(0.706421, 0.044038, -0.706421), _
      New TEST_NORMAL(0.706946, -0.021292, -0.706947), _
      New TEST_NORMAL(0.711853, -0.03261, 0.701571), _
      New TEST_NORMAL(0.718481, -0.070043, 0.692011), _
      New TEST_NORMAL(0.748497, 0.663073, 0.009295), _
      New TEST_NORMAL(0.99761, -0.067336, 0.015469), _
      New TEST_NORMAL(0.999392, -0.034076, 0.007416), _
      New TEST_NORMAL(0.999392, 0.034076, -0.007415) _
    }

    triangle3_Lupper_arm = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(30, 44, 35, 18, 4, 10), _
      New TEST_TRIANGLE3(35, 24, 30, 10, 20, 18), _
      New TEST_TRIANGLE3(7, 30, 24, 23, 18, 20), _
      New TEST_TRIANGLE3(24, 21, 7, 20, 21, 23), _
      New TEST_TRIANGLE3(33, 49, 44, 15, 8, 4), _
      New TEST_TRIANGLE3(44, 30, 33, 4, 18, 15), _
      New TEST_TRIANGLE3(10, 33, 30, 27, 15, 18), _
      New TEST_TRIANGLE3(30, 7, 10, 18, 23, 27), _
      New TEST_TRIANGLE3(28, 43, 49, 12, 9, 8), _
      New TEST_TRIANGLE3(49, 33, 28, 8, 15, 12), _
      New TEST_TRIANGLE3(18, 28, 33, 28, 12, 15), _
      New TEST_TRIANGLE3(33, 10, 18, 15, 27, 28), _
      New TEST_TRIANGLE3(29, 31, 39, 19, 14, 11), _
      New TEST_TRIANGLE3(39, 53, 29, 11, 5, 19), _
      New TEST_TRIANGLE3(3, 14, 31, 25, 22, 14), _
      New TEST_TRIANGLE3(31, 29, 3, 14, 19, 25), _
      New TEST_TRIANGLE3(26, 29, 53, 16, 19, 5), _
      New TEST_TRIANGLE3(53, 52, 26, 5, 7, 16), _
      New TEST_TRIANGLE3(8, 3, 29, 26, 25, 19), _
      New TEST_TRIANGLE3(29, 26, 8, 19, 16, 26), _
      New TEST_TRIANGLE3(25, 26, 52, 13, 16, 7), _
      New TEST_TRIANGLE3(52, 38, 25, 7, 6, 13), _
      New TEST_TRIANGLE3(16, 8, 26, 24, 26, 16), _
      New TEST_TRIANGLE3(26, 25, 16, 16, 13, 24), _
      New TEST_TRIANGLE3(27, 23, 34, 17, 20, 10), _
      New TEST_TRIANGLE3(34, 46, 27, 10, 3, 17), _
      New TEST_TRIANGLE3(5, 22, 23, 29, 21, 20), _
      New TEST_TRIANGLE3(23, 27, 5, 20, 17, 29), _
      New TEST_TRIANGLE3(32, 27, 46, 14, 17, 3), _
      New TEST_TRIANGLE3(46, 40, 32, 3, 11, 14), _
      New TEST_TRIANGLE3(15, 5, 27, 22, 29, 17), _
      New TEST_TRIANGLE3(27, 32, 15, 17, 14, 22), _
      New TEST_TRIANGLE3(1, 6, 20, 32, 23, 21), _
      New TEST_TRIANGLE3(20, 4, 1, 21, 29, 32), _
      New TEST_TRIANGLE3(0, 11, 6, 31, 27, 23), _
      New TEST_TRIANGLE3(6, 1, 0, 23, 32, 31), _
      New TEST_TRIANGLE3(12, 19, 11, 30, 28, 27), _
      New TEST_TRIANGLE3(11, 0, 12, 27, 31, 30), _
      New TEST_TRIANGLE3(2, 1, 4, 25, 32, 29), _
      New TEST_TRIANGLE3(4, 13, 2, 29, 22, 25), _
      New TEST_TRIANGLE3(9, 0, 1, 26, 31, 32), _
      New TEST_TRIANGLE3(1, 2, 9, 32, 25, 26), _
      New TEST_TRIANGLE3(17, 12, 0, 24, 30, 31), _
      New TEST_TRIANGLE3(0, 9, 17, 31, 26, 24), _
      New TEST_TRIANGLE3(56, 48, 42, 0, 8, 9), _
      New TEST_TRIANGLE3(42, 50, 56, 9, 2, 0), _
      New TEST_TRIANGLE3(55, 45, 48, 1, 4, 8), _
      New TEST_TRIANGLE3(48, 56, 55, 8, 0, 1), _
      New TEST_TRIANGLE3(47, 36, 45, 3, 10, 4), _
      New TEST_TRIANGLE3(45, 55, 47, 4, 1, 3), _
      New TEST_TRIANGLE3(51, 56, 50, 7, 0, 2), _
      New TEST_TRIANGLE3(50, 37, 51, 2, 6, 7), _
      New TEST_TRIANGLE3(54, 55, 56, 5, 1, 0), _
      New TEST_TRIANGLE3(56, 51, 54, 0, 7, 5), _
      New TEST_TRIANGLE3(41, 47, 55, 11, 3, 1), _
      New TEST_TRIANGLE3(55, 54, 41, 1, 5, 11) _
    }

    matrix_Rupper_arm = New Single() { _
      0.983734, 0.139609, 0.044945, -30.86621, _
      0.044892, 0.003161, -0.998982, 5.000384, _
      -0.166902, 0.823692, -0.003783, 137.5207, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_Rupper_arm = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-5.000001, 13.473962, 5.0, 0.821302, 1.1), _
      New TEST_XYZ_UV(-4.999996, -13.473955, 5.0, 1.36026, 1.1), _
      New TEST_XYZ_UV(-4.062502, -13.473951, 9.0625, 1.01875, 0.83974), _
      New TEST_XYZ_UV(-4.062502, -13.473951, 9.0625, 1.36026, 1.18125), _
      New TEST_XYZ_UV(-4.0625, -13.473958, 0.9375, 1.18125, 0.83974), _
      New TEST_XYZ_UV(-4.0625, -13.473958, 0.9375, 1.36026, 1.01875), _
      New TEST_XYZ_UV(-4.062499, 13.473968, 9.062499, 0.821302, 1.18125), _
      New TEST_XYZ_UV(-4.062499, 13.473968, 9.062499, 1.01875, 1.378698), _
      New TEST_XYZ_UV(-4.062498, -24.078123, 5.0, 1.01875, 1.1), _
      New TEST_XYZ_UV(-4.062498, -24.078123, 5.0, 1.572344, 1.1), _
      New TEST_XYZ_UV(-4.062498, 24.078133, 5.0, 0.609219, 1.1), _
      New TEST_XYZ_UV(-4.062496, 13.473952, 0.937501, 0.821302, 1.01875), _
      New TEST_XYZ_UV(-4.062496, 13.473952, 0.937501, 1.18125, 1.378698), _
      New TEST_XYZ_UV(-3.75, 23.770847, 8.75, 0.615365, 1.175), _
      New TEST_XYZ_UV(-3.75, 23.770847, 8.75, 1.025, 1.584635), _
      New TEST_XYZ_UV(-3.75, -23.770828, 8.750001, 1.025, 0.633802), _
      New TEST_XYZ_UV(-3.75, -23.770828, 8.750001, 1.025, 1.175), _
      New TEST_XYZ_UV(-3.75, -23.770828, 8.750001, 1.566198, 1.175), _
      New TEST_XYZ_UV(-3.75, 23.770849, 1.25, 0.615365, 1.025), _
      New TEST_XYZ_UV(-3.75, 23.770849, 1.25, 1.175, 1.584635), _
      New TEST_XYZ_UV(-3.749999, -23.770826, 1.25, 1.025, 1.025), _
      New TEST_XYZ_UV(-3.749999, -23.770826, 1.25, 1.175, 0.633802), _
      New TEST_XYZ_UV(-3.749999, -23.770826, 1.25, 1.566198, 1.025), _
      New TEST_XYZ_UV(-0.000002, -13.473948, 9.999998, 1.1, 0.83974), _
      New TEST_XYZ_UV(-0.000001, 24.078137, 0.9375, 1.1, 1.590781), _
      New TEST_XYZ_UV(-0.000001, -24.999992, 5.0, 1.1, 1.1), _
      New TEST_XYZ_UV(-0.000001, 13.473973, 0.0, 1.1, 1.378698), _
      New TEST_XYZ_UV(0.000001, 24.078135, 9.0625, 1.1, 1.590781), _
      New TEST_XYZ_UV(0.000002, -24.078111, 9.0625, 1.1, 0.627656), _
      New TEST_XYZ_UV(0.000002, -24.078111, 9.0625, 1.1, 1.18125), _
      New TEST_XYZ_UV(0.000002, -24.078109, 0.9375, 1.1, 1.01875), _
      New TEST_XYZ_UV(0.000002, -24.078109, 0.9375, 1.1, 0.627656), _
      New TEST_XYZ_UV(0.000002, -13.473954, 0.0, 1.1, 0.83974), _
      New TEST_XYZ_UV(0.000003, 13.473952, 10.0, 1.1, 1.378698), _
      New TEST_XYZ_UV(3.75, 23.770844, 1.25, 1.025, 1.584635), _
      New TEST_XYZ_UV(3.75, 23.770844, 1.25, 1.584635, 1.025), _
      New TEST_XYZ_UV(3.750001, 23.770843, 8.75, 1.175, 1.584635), _
      New TEST_XYZ_UV(3.750001, 23.770843, 8.75, 1.584635, 1.175), _
      New TEST_XYZ_UV(3.750002, -23.770832, 8.749999, 0.633802, 1.175), _
      New TEST_XYZ_UV(3.750002, -23.770832, 8.749999, 1.175, 0.633802), _
      New TEST_XYZ_UV(3.750002, -23.770832, 8.749999, 1.175, 1.175), _
      New TEST_XYZ_UV(3.750002, -23.77083, 1.25, 0.633802, 1.025), _
      New TEST_XYZ_UV(3.750002, -23.77083, 1.25, 1.025, 0.633802), _
      New TEST_XYZ_UV(3.750002, -23.77083, 1.25, 1.175, 1.025), _
      New TEST_XYZ_UV(4.0625, -24.078117, 5.0, 0.627656, 1.1), _
      New TEST_XYZ_UV(4.0625, -24.078117, 5.0, 1.18125, 1.1), _
      New TEST_XYZ_UV(4.0625, 24.078139, 5.0, 1.590781, 1.1), _
      New TEST_XYZ_UV(4.062501, -13.473951, 0.937499, 0.83974, 1.01875), _
      New TEST_XYZ_UV(4.062501, -13.473951, 0.937499, 1.01875, 0.83974), _
      New TEST_XYZ_UV(4.062501, 13.473957, 0.9375, 1.01875, 1.378698), _
      New TEST_XYZ_UV(4.062501, 13.473957, 0.9375, 1.378698, 1.01875), _
      New TEST_XYZ_UV(4.062501, 13.473956, 9.062499, 1.18125, 1.378698), _
      New TEST_XYZ_UV(4.062501, 13.473956, 9.062499, 1.378698, 1.18125), _
      New TEST_XYZ_UV(4.062503, -13.473953, 9.062499, 0.83974, 1.18125), _
      New TEST_XYZ_UV(4.062503, -13.473953, 9.062499, 1.18125, 0.83974), _
      New TEST_XYZ_UV(5.000001, -13.473955, 5.0, 0.83974, 1.1), _
      New TEST_XYZ_UV(5.000002, 13.473963, 5.0, 1.378698, 1.1) _
    }


    normal_Rupper_arm = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.999392, -0.034076, -0.007416), _
      New TEST_NORMAL(-0.999392, 0.034076, 0.007415), _
      New TEST_NORMAL(-0.99761, 0.067337, 0.015469), _
      New TEST_NORMAL(-0.748497, -0.663073, 0.009295), _
      New TEST_NORMAL(-0.711854, -0.03261, -0.70157), _
      New TEST_NORMAL(-0.706947, -0.021292, 0.706946), _
      New TEST_NORMAL(-0.706456, 0.04288, 0.706456), _
      New TEST_NORMAL(-0.706421, 0.044038, 0.706421), _
      New TEST_NORMAL(-0.70157, 0.03261, -0.711854), _
      New TEST_NORMAL(-0.692012, 0.070043, -0.71848), _
      New TEST_NORMAL(-0.609583, -0.52943, -0.590011), _
      New TEST_NORMAL(-0.582029, -0.567877, 0.582029), _
      New TEST_NORMAL(-0.015469, 0.067336, -0.99761), _
      New TEST_NORMAL(-0.015469, 0.067336, 0.99761), _
      New TEST_NORMAL(-0.009295, -0.663072, 0.748498), _
      New TEST_NORMAL(-0.007416, 0.034076, -0.999392), _
      New TEST_NORMAL(-0.007415, 0.034075, 0.999392), _
      New TEST_NORMAL(0.0, -1.0, 0.0), _
      New TEST_NORMAL(0.007416, -0.034075, 0.999392), _
      New TEST_NORMAL(0.007416, -0.034076, -0.999392), _
      New TEST_NORMAL(0.028761, -0.662826, -0.748221), _
      New TEST_NORMAL(0.576449, -0.558184, -0.596772), _
      New TEST_NORMAL(0.604441, -0.518944, 0.604441), _
      New TEST_NORMAL(0.70157, -0.03261, -0.711854), _
      New TEST_NORMAL(0.703817, 0.096351, 0.703817), _
      New TEST_NORMAL(0.706421, -0.044038, 0.706421), _
      New TEST_NORMAL(0.706947, 0.021292, 0.706946), _
      New TEST_NORMAL(0.711854, 0.03261, -0.70157), _
      New TEST_NORMAL(0.71848, 0.070043, -0.692012), _
      New TEST_NORMAL(0.748497, -0.663073, -0.009295), _
      New TEST_NORMAL(0.99761, 0.067336, -0.015469), _
      New TEST_NORMAL(0.999392, -0.034076, 0.007416), _
      New TEST_NORMAL(0.999392, 0.034076, -0.007416) _
    }

    triangle3_Rupper_arm = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(32, 4, 21, 19, 4, 10), _
      New TEST_TRIANGLE3(21, 31, 32, 10, 20, 19), _
      New TEST_TRIANGLE3(48, 32, 31, 23, 19, 20), _
      New TEST_TRIANGLE3(31, 42, 48, 20, 21, 23), _
      New TEST_TRIANGLE3(26, 12, 4, 15, 8, 4), _
      New TEST_TRIANGLE3(4, 32, 26, 4, 19, 15), _
      New TEST_TRIANGLE3(49, 26, 32, 27, 15, 19), _
      New TEST_TRIANGLE3(32, 48, 49, 19, 23, 27), _
      New TEST_TRIANGLE3(24, 19, 12, 12, 9, 8), _
      New TEST_TRIANGLE3(12, 26, 24, 8, 15, 12), _
      New TEST_TRIANGLE3(34, 24, 26, 28, 12, 15), _
      New TEST_TRIANGLE3(26, 49, 34, 15, 27, 28), _
      New TEST_TRIANGLE3(23, 28, 15, 18, 14, 11), _
      New TEST_TRIANGLE3(15, 2, 23, 11, 5, 18), _
      New TEST_TRIANGLE3(54, 39, 28, 25, 22, 14), _
      New TEST_TRIANGLE3(28, 23, 54, 14, 18, 25), _
      New TEST_TRIANGLE3(33, 23, 2, 16, 18, 5), _
      New TEST_TRIANGLE3(2, 7, 33, 5, 7, 16), _
      New TEST_TRIANGLE3(51, 54, 23, 26, 25, 18), _
      New TEST_TRIANGLE3(23, 33, 51, 18, 16, 26), _
      New TEST_TRIANGLE3(27, 33, 7, 13, 16, 7), _
      New TEST_TRIANGLE3(7, 14, 27, 7, 6, 13), _
      New TEST_TRIANGLE3(36, 51, 33, 24, 26, 16), _
      New TEST_TRIANGLE3(33, 27, 36, 16, 13, 24), _
      New TEST_TRIANGLE3(25, 30, 20, 17, 20, 10), _
      New TEST_TRIANGLE3(20, 8, 25, 10, 3, 17), _
      New TEST_TRIANGLE3(45, 43, 30, 29, 21, 20), _
      New TEST_TRIANGLE3(30, 25, 45, 20, 17, 29), _
      New TEST_TRIANGLE3(29, 25, 8, 14, 17, 3), _
      New TEST_TRIANGLE3(8, 16, 29, 3, 11, 14), _
      New TEST_TRIANGLE3(40, 45, 25, 22, 29, 17), _
      New TEST_TRIANGLE3(25, 29, 40, 17, 14, 22), _
      New TEST_TRIANGLE3(55, 47, 41, 31, 23, 21), _
      New TEST_TRIANGLE3(41, 44, 55, 21, 29, 31), _
      New TEST_TRIANGLE3(56, 50, 47, 32, 27, 23), _
      New TEST_TRIANGLE3(47, 55, 56, 23, 31, 32), _
      New TEST_TRIANGLE3(46, 35, 50, 30, 28, 27), _
      New TEST_TRIANGLE3(50, 56, 46, 27, 32, 30), _
      New TEST_TRIANGLE3(53, 55, 44, 25, 31, 29), _
      New TEST_TRIANGLE3(44, 38, 53, 29, 22, 25), _
      New TEST_TRIANGLE3(52, 56, 55, 26, 32, 31), _
      New TEST_TRIANGLE3(55, 53, 52, 31, 25, 26), _
      New TEST_TRIANGLE3(37, 46, 56, 24, 30, 32), _
      New TEST_TRIANGLE3(56, 52, 37, 32, 26, 24), _
      New TEST_TRIANGLE3(0, 11, 18, 1, 8, 9), _
      New TEST_TRIANGLE3(18, 10, 0, 9, 2, 1), _
      New TEST_TRIANGLE3(1, 5, 11, 0, 4, 8), _
      New TEST_TRIANGLE3(11, 0, 1, 8, 1, 0), _
      New TEST_TRIANGLE3(9, 22, 5, 3, 10, 4), _
      New TEST_TRIANGLE3(5, 1, 9, 4, 0, 3), _
      New TEST_TRIANGLE3(6, 0, 10, 7, 1, 2), _
      New TEST_TRIANGLE3(10, 13, 6, 2, 6, 7), _
      New TEST_TRIANGLE3(3, 1, 0, 5, 0, 1), _
      New TEST_TRIANGLE3(0, 6, 3, 1, 7, 5), _
      New TEST_TRIANGLE3(17, 9, 1, 11, 3, 0), _
      New TEST_TRIANGLE3(1, 3, 17, 0, 5, 11) _
    }

    matrix_shawl = New Single() { _
      0.792079, 0.0, 0.0, 0.0, _
      0.0, 0.0, -1.198198, -18.06461, _
      0.0, 0.999999, 0.0, 163.7218, _
      0.0, 0.0, 0.0, 1.0 _
    }

    xyz_uv_shawl = New TEST_XYZ_UV() { _
      New TEST_XYZ_UV(-40.900613, -8.191438, -7.5, 0.780092, 0.946551), _
      New TEST_XYZ_UV(-40.900613, -8.191437, -15.0, 0.780092, 0.8), _
      New TEST_XYZ_UV(-40.900613, -8.191436, -22.500002, 0.780092, 0.653449), _
      New TEST_XYZ_UV(-38.522038, -15.838917, -7.500001, 0.262992, 0.946551), _
      New TEST_XYZ_UV(-38.522038, -15.838917, -7.500001, 0.929524, 0.946551), _
      New TEST_XYZ_UV(-38.522038, -15.838931, -15.000001, 0.262992, 0.8), _
      New TEST_XYZ_UV(-38.522038, -15.838931, -15.000001, 0.929524, 0.8), _
      New TEST_XYZ_UV(-38.522038, -15.83893, -22.5, 0.262992, 0.653449), _
      New TEST_XYZ_UV(-38.522038, -15.83893, -22.5, 0.929524, 0.653449), _
      New TEST_XYZ_UV(-38.009032, -8.799075, -0.937501, 0.270144, 0.808035), _
      New TEST_XYZ_UV(-38.009032, -8.799075, -0.937501, 0.791965, 1.074782), _
      New TEST_XYZ_UV(-38.00903, -8.799071, -29.0625, 0.791965, 0.525218), _
      New TEST_XYZ_UV(-38.00903, -8.799071, -29.0625, 1.329856, 0.808035), _
      New TEST_XYZ_UV(-37.558182, -15.888097, -1.25, 0.276429, 0.669515), _
      New TEST_XYZ_UV(-37.558182, -15.888097, -1.25, 0.276429, 1.068676), _
      New TEST_XYZ_UV(-37.558182, -15.888097, -1.25, 0.930485, 1.068676), _
      New TEST_XYZ_UV(-37.558175, -15.888093, -28.75, 0.276429, 0.531324), _
      New TEST_XYZ_UV(-37.558175, -15.888093, -28.75, 0.930485, 0.531324), _
      New TEST_XYZ_UV(-37.558175, -15.888093, -28.75, 1.323571, 0.669515), _
      New TEST_XYZ_UV(-36.691983, -0.691436, -7.788462, 0.633541, 0.940914), _
      New TEST_XYZ_UV(-36.691983, -0.691436, -7.788462, 1.311496, 0.940914), _
      New TEST_XYZ_UV(-36.691976, -0.691435, -15.000002, 0.633541, 0.8), _
      New TEST_XYZ_UV(-36.691976, -0.691435, -15.000002, 1.311496, 0.8), _
      New TEST_XYZ_UV(-36.691976, -0.691434, -22.211537, 0.633541, 0.659086), _
      New TEST_XYZ_UV(-36.691976, -0.691434, -22.211537, 1.311496, 0.659086), _
      New TEST_XYZ_UV(-34.086952, -0.691422, -1.478367, 0.324819, 0.966459), _
      New TEST_XYZ_UV(-34.086952, -0.691422, -1.478367, 0.633541, 1.064214), _
      New TEST_XYZ_UV(-34.086952, -0.691422, -1.478367, 1.275181, 1.064214), _
      New TEST_XYZ_UV(-34.086945, -0.691433, -28.521636, 0.633541, 0.535786), _
      New TEST_XYZ_UV(-34.086945, -0.691433, -28.521636, 1.275181, 0.535786), _
      New TEST_XYZ_UV(-34.086945, -0.691433, -28.521636, 1.275181, 0.966459), _
      New TEST_XYZ_UV(-28.601152, 6.808566, -8.561126, 1.198708, 0.925816), _
      New TEST_XYZ_UV(-28.601152, 6.808567, -14.999999, 1.198708, 0.8), _
      New TEST_XYZ_UV(-28.601152, 6.808568, -21.438872, 1.198708, 0.674184), _
      New TEST_XYZ_UV(-26.627648, 6.808566, -2.927112, 0.428804, 1.113009), _
      New TEST_XYZ_UV(-26.627648, 6.808566, -2.927112, 1.171197, 1.035905), _
      New TEST_XYZ_UV(-26.627644, 6.808569, -27.072885, 1.171196, 0.564095), _
      New TEST_XYZ_UV(-26.627644, 6.808569, -27.072885, 1.171196, 1.113009), _
      New TEST_XYZ_UV(-21.525739, 12.02622, -9.930021, 1.100075, 0.899068), _
      New TEST_XYZ_UV(-21.525736, 12.02622, -15.0, 1.100074, 0.8), _
      New TEST_XYZ_UV(-21.525736, 12.026221, -20.069977, 1.100075, 0.700932), _
      New TEST_XYZ_UV(-21.39741, 11.713722, -24.294958, 1.098286, 0.618376), _
      New TEST_XYZ_UV(-21.39741, 11.713722, -24.294958, 1.098286, 1.208856), _
      New TEST_XYZ_UV(-21.397403, 11.713719, -5.705039, 0.501715, 1.208856), _
      New TEST_XYZ_UV(-21.397403, 11.713719, -5.705039, 1.098286, 0.981624), _
      New TEST_XYZ_UV(-18.88741, -23.040336, -0.937502, 0.536704, 0.529759), _
      New TEST_XYZ_UV(-18.88741, -23.040336, -0.937502, 0.536704, 1.074782), _
      New TEST_XYZ_UV(-18.88741, -24.455191, -7.500002, 0.536704, 0.946551), _
      New TEST_XYZ_UV(-18.88741, -24.45519, -15.000001, 0.536704, 0.8), _
      New TEST_XYZ_UV(-18.887406, -24.455189, -22.5, 0.536704, 0.653449), _
      New TEST_XYZ_UV(-18.887406, -23.040332, -29.0625, 0.536704, 0.525218), _
      New TEST_XYZ_UV(-18.887406, -23.040332, -29.0625, 1.063296, 0.529759), _
      New TEST_XYZ_UV(-18.660957, -12.314609, -0.000001, 0.539861, 0.739341), _
      New TEST_XYZ_UV(-18.660957, -12.314605, -30.000002, 1.060139, 0.739341), _
      New TEST_XYZ_UV(-16.743067, -1.299068, -29.423078, 1.033403, 0.954585), _
      New TEST_XYZ_UV(-16.743063, -1.299073, -0.576924, 0.566597, 0.954585), _
      New TEST_XYZ_UV(-13.38974, 6.808569, -27.877747, 0.986657, 1.113009), _
      New TEST_XYZ_UV(-13.389738, 6.808566, -2.122253, 0.613344, 1.113009), _
      New TEST_XYZ_UV(-12.096407, 12.96372, -9.930022, 0.968627, 0.899068), _
      New TEST_XYZ_UV(-12.096407, 12.963721, -20.069977, 0.968627, 0.700932), _
      New TEST_XYZ_UV(-12.096406, 12.026219, -5.493789, 0.631373, 1.214963), _
      New TEST_XYZ_UV(-12.096406, 12.026219, -5.493789, 0.968627, 0.985752), _
      New TEST_XYZ_UV(-12.096406, 12.963721, -15.0, 0.968627, 0.8), _
      New TEST_XYZ_UV(-12.096404, 12.026222, -24.50621, 0.968627, 0.614248), _
      New TEST_XYZ_UV(-12.096404, 12.026222, -24.50621, 0.968627, 1.214962), _
      New TEST_XYZ_UV(-0.000001, 12.026222, -24.506212, 0.8, 0.614248), _
      New TEST_XYZ_UV(-0.000001, 12.026222, -24.506212, 0.8, 1.214962), _
      New TEST_XYZ_UV(-0.000001, 12.963721, -20.069977, 0.8, 0.700932), _
      New TEST_XYZ_UV(-0.000001, 6.808569, -27.877747, 0.8, 1.113009), _
      New TEST_XYZ_UV(-0.000001, 12.963721, -15.0, 0.8, 0.8), _
      New TEST_XYZ_UV(-0.000001, 12.96372, -9.930022, 0.8, 0.899068), _
      New TEST_XYZ_UV(-0.000001, -1.299068, -29.423078, 0.8, 0.954585), _
      New TEST_XYZ_UV(-0.000001, 6.808566, -2.122253, 0.8, 1.113009), _
      New TEST_XYZ_UV(-0.000001, 12.026219, -5.493789, 0.8, 0.985752), _
      New TEST_XYZ_UV(-0.000001, 12.026219, -5.493789, 0.8, 1.214962), _
      New TEST_XYZ_UV(-0.000001, -1.299073, -0.576924, 0.8, 0.954585), _
      New TEST_XYZ_UV(-0.000001, -14.091053, -0.000001, 0.8, 0.704629), _
      New TEST_XYZ_UV(-0.000001, -14.091064, -30.0, 0.8, 0.704629), _
      New TEST_XYZ_UV(-0.000001, -31.38424, -7.500004, 0.8, 0.946551), _
      New TEST_XYZ_UV(-0.000001, -28.800576, -0.937503, 0.8, 0.417204), _
      New TEST_XYZ_UV(-0.000001, -28.800576, -0.937503, 0.8, 1.074782), _
      New TEST_XYZ_UV(-0.000001, -31.384238, -22.5, 0.8, 0.653449), _
      New TEST_XYZ_UV(-0.000001, -28.800572, -29.062501, 0.8, 0.525218), _
      New TEST_XYZ_UV(-0.000001, -28.800572, -29.062501, 0.8, 0.417204), _
      New TEST_XYZ_UV(12.096398, 12.96372, -9.930021, 0.631373, 0.899068), _
      New TEST_XYZ_UV(12.096402, 12.026219, -5.493791, 0.631373, 0.985752), _
      New TEST_XYZ_UV(12.096402, 12.026219, -5.493791, 0.968627, 1.214962), _
      New TEST_XYZ_UV(12.096402, 12.963721, -15.0, 0.631373, 0.8), _
      New TEST_XYZ_UV(12.096402, 12.963721, -20.069977, 0.631373, 0.700932), _
      New TEST_XYZ_UV(12.096402, 12.026222, -24.50621, 0.631373, 0.614248), _
      New TEST_XYZ_UV(12.096402, 12.026222, -24.50621, 0.631373, 1.214962), _
      New TEST_XYZ_UV(13.389734, 6.808569, -27.877747, 0.613343, 1.113009), _
      New TEST_XYZ_UV(13.389738, 6.808566, -2.122253, 0.986657, 1.113009), _
      New TEST_XYZ_UV(16.743059, -1.299068, -29.423078, 0.566597, 0.954585), _
      New TEST_XYZ_UV(16.743065, -1.299073, -0.576924, 1.033403, 0.954585), _
      New TEST_XYZ_UV(18.66095, -12.314605, -30.000002, 0.539861, 0.739341), _
      New TEST_XYZ_UV(18.660952, -12.314609, -0.000001, 1.060139, 0.739341), _
      New TEST_XYZ_UV(18.887402, -23.040336, -0.937502, 1.063295, 0.529759), _
      New TEST_XYZ_UV(18.887402, -23.040336, -0.937502, 1.063295, 1.074782), _
      New TEST_XYZ_UV(18.887402, -24.455191, -7.500002, 1.063295, 0.946551), _
      New TEST_XYZ_UV(18.887402, -24.45519, -15.000001, 1.063295, 0.8), _
      New TEST_XYZ_UV(18.887406, -24.455189, -22.5, 1.063295, 0.653449), _
      New TEST_XYZ_UV(18.887406, -23.040332, -29.0625, 0.536705, 0.529759), _
      New TEST_XYZ_UV(18.887406, -23.040332, -29.0625, 1.063295, 0.525218), _
      New TEST_XYZ_UV(21.397395, 11.713719, -5.705039, 0.501714, 0.981624), _
      New TEST_XYZ_UV(21.397395, 11.713719, -5.705039, 1.098286, 1.208856), _
      New TEST_XYZ_UV(21.397405, 11.713722, -24.29496, 0.501714, 0.618376), _
      New TEST_XYZ_UV(21.397405, 11.713722, -24.29496, 0.501714, 1.208856), _
      New TEST_XYZ_UV(21.525731, 12.02622, -9.930021, 0.499925, 0.899068), _
      New TEST_XYZ_UV(21.525731, 12.02622, -14.999999, 0.499925, 0.8), _
      New TEST_XYZ_UV(21.525731, 12.026221, -20.069977, 0.499925, 0.700932), _
      New TEST_XYZ_UV(26.627641, 6.808566, -2.927112, 0.428803, 1.035905), _
      New TEST_XYZ_UV(26.627641, 6.808566, -2.927112, 1.171197, 1.113009), _
      New TEST_XYZ_UV(26.627641, 6.808569, -27.072885, 0.428804, 0.564095), _
      New TEST_XYZ_UV(26.627641, 6.808569, -27.072885, 0.428804, 1.113009), _
      New TEST_XYZ_UV(28.601142, 6.808566, -8.561127, 0.401292, 0.925816), _
      New TEST_XYZ_UV(28.601149, 6.808567, -15.000001, 0.401292, 0.8), _
      New TEST_XYZ_UV(28.601149, 6.808568, -21.438872, 0.401292, 0.674184), _
      New TEST_XYZ_UV(34.086937, -0.691422, -1.478365, 0.324819, 1.064214), _
      New TEST_XYZ_UV(34.086937, -0.691422, -1.478365, 0.966458, 1.064214), _
      New TEST_XYZ_UV(34.086937, -0.691422, -1.478365, 1.275181, 0.966458), _
      New TEST_XYZ_UV(34.086949, -0.691433, -28.521636, 0.324819, 0.535786), _
      New TEST_XYZ_UV(34.086949, -0.691433, -28.521636, 0.324819, 0.966458), _
      New TEST_XYZ_UV(34.086949, -0.691433, -28.521636, 0.966458, 0.535786), _
      New TEST_XYZ_UV(36.691975, -0.691436, -7.788463, 0.288504, 0.940914), _
      New TEST_XYZ_UV(36.691975, -0.691436, -7.788463, 0.966458, 0.940914), _
      New TEST_XYZ_UV(36.691975, -0.691435, -15.000002, 0.288504, 0.8), _
      New TEST_XYZ_UV(36.691975, -0.691435, -15.000002, 0.966458, 0.8), _
      New TEST_XYZ_UV(36.691975, -0.691434, -22.211541, 0.288504, 0.659086), _
      New TEST_XYZ_UV(36.691975, -0.691434, -22.211541, 0.966458, 0.659086), _
      New TEST_XYZ_UV(37.558167, -15.888097, -1.25, 0.669515, 1.068676), _
      New TEST_XYZ_UV(37.558167, -15.888097, -1.25, 1.323571, 0.669515), _
      New TEST_XYZ_UV(37.558167, -15.888097, -1.25, 1.323571, 1.068676), _
      New TEST_XYZ_UV(37.558167, -15.888093, -28.75, 0.276429, 0.669515), _
      New TEST_XYZ_UV(37.558167, -15.888093, -28.75, 0.669515, 0.531324), _
      New TEST_XYZ_UV(37.558167, -15.888093, -28.75, 1.323571, 0.531324), _
      New TEST_XYZ_UV(38.009022, -8.799075, -0.937501, 0.808035, 1.074782), _
      New TEST_XYZ_UV(38.009022, -8.799075, -0.937501, 1.329856, 0.808035), _
      New TEST_XYZ_UV(38.009034, -8.799071, -29.0625, 0.270144, 0.808035), _
      New TEST_XYZ_UV(38.009034, -8.799071, -29.0625, 0.808035, 0.525218), _
      New TEST_XYZ_UV(38.522031, -15.838917, -7.500001, 0.670475, 0.946551), _
      New TEST_XYZ_UV(38.522031, -15.838917, -7.500001, 1.337007, 0.946551), _
      New TEST_XYZ_UV(38.522031, -15.838931, -15.000001, 0.670475, 0.8), _
      New TEST_XYZ_UV(38.522031, -15.838931, -15.000001, 1.337007, 0.8), _
      New TEST_XYZ_UV(38.522031, -15.83893, -22.5, 0.670475, 0.653449), _
      New TEST_XYZ_UV(38.522031, -15.83893, -22.5, 1.337008, 0.653449), _
      New TEST_XYZ_UV(40.900606, -8.191438, -7.500001, 0.819908, 0.946551), _
      New TEST_XYZ_UV(40.900606, -8.191437, -15.000002, 0.819908, 0.8), _
      New TEST_XYZ_UV(40.900611, -8.191436, -22.499998, 0.819908, 0.653449) _
    }


    normal_shawl = New TEST_NORMAL() { _
      New TEST_NORMAL(-0.994502, 0.104719, 0.0), _
      New TEST_NORMAL(-0.97528, 0.10381, 0.195071), _
      New TEST_NORMAL(-0.975086, 0.132404, -0.177981), _
      New TEST_NORMAL(-0.785483, 0.618883, 0.0), _
      New TEST_NORMAL(-0.781334, 0.60203, -0.164551), _
      New TEST_NORMAL(-0.780291, 0.606221, 0.153761), _
      New TEST_NORMAL(-0.769265, -0.632385, 0.09122), _
      New TEST_NORMAL(-0.747538, -0.661334, -0.06185), _
      New TEST_NORMAL(-0.74557, -0.666427, 0.0), _
      New TEST_NORMAL(-0.637667, 0.770312, 0.0), _
      New TEST_NORMAL(-0.63751, 0.763457, 0.103514), _
      New TEST_NORMAL(-0.631096, 0.767198, -0.114569), _
      New TEST_NORMAL(-0.62512, 0.084335, 0.775959), _
      New TEST_NORMAL(-0.620669, -0.475984, 0.623065), _
      New TEST_NORMAL(-0.600101, 0.129464, -0.789378), _
      New TEST_NORMAL(-0.570642, -0.519869, -0.635691), _
      New TEST_NORMAL(-0.494896, 0.444176, -0.74685), _
      New TEST_NORMAL(-0.487634, 0.443125, 0.752232), _
      New TEST_NORMAL(-0.401841, -0.915709, 0.0), _
      New TEST_NORMAL(-0.385815, 0.61958, -0.683569), _
      New TEST_NORMAL(-0.383647, 0.609406, 0.693858), _
      New TEST_NORMAL(-0.368868, -0.921258, 0.123366), _
      New TEST_NORMAL(-0.365904, 0.929316, -0.049861), _
      New TEST_NORMAL(-0.364193, -0.92017, -0.143701), _
      New TEST_NORMAL(-0.359054, 0.933317, 0.0), _
      New TEST_NORMAL(-0.346, 0.937044, 0.047258), _
      New TEST_NORMAL(-0.296931, 0.839966, -0.45419), _
      New TEST_NORMAL(-0.253522, 0.852596, 0.456953), _
      New TEST_NORMAL(-0.232493, -0.635243, -0.736488), _
      New TEST_NORMAL(-0.229996, -0.62449, 0.746401), _
      New TEST_NORMAL(-0.049529, 0.998773, 0.0), _
      New TEST_NORMAL(-0.049106, 0.993418, 0.103486), _
      New TEST_NORMAL(-0.038478, 0.994751, -0.094819), _
      New TEST_NORMAL(-0.032809, 0.828422, 0.559142), _
      New TEST_NORMAL(-0.025027, -0.015802, -0.999562), _
      New TEST_NORMAL(-0.025027, -0.015802, 0.999562), _
      New TEST_NORMAL(-0.023749, 0.37854, -0.92528), _
      New TEST_NORMAL(-0.023749, 0.37854, 0.92528), _
      New TEST_NORMAL(-0.022635, 0.127821, -0.991539), _
      New TEST_NORMAL(-0.022635, 0.127821, 0.991539), _
      New TEST_NORMAL(-0.021102, 0.823816, -0.566465), _
      New TEST_NORMAL(-0.018509, -0.936564, -0.350008), _
      New TEST_NORMAL(-0.016719, -0.653957, -0.756347), _
      New TEST_NORMAL(-0.002013, -0.014006, -0.9999), _
      New TEST_NORMAL(-0.002013, -0.014006, 0.9999), _
      New TEST_NORMAL(0.0, 0.371861, 0.928288), _
      New TEST_NORMAL(0.0, 0.371861, -0.928288), _
      New TEST_NORMAL(0.0, 0.823815, 0.566859), _
      New TEST_NORMAL(0.0, 0.823815, -0.566859), _
      New TEST_NORMAL(0.0, 0.994583, -0.103944), _
      New TEST_NORMAL(0.0, 0.994583, 0.103944), _
      New TEST_NORMAL(0.0, 1.0, 0.0), _
      New TEST_NORMAL(0.00071, 0.117054, 0.993125), _
      New TEST_NORMAL(0.00071, 0.117054, -0.993125), _
      New TEST_NORMAL(0.013303, -0.653991, 0.756386), _
      New TEST_NORMAL(0.018509, -0.936564, 0.350007), _
      New TEST_NORMAL(0.018855, 0.824633, 0.565353), _
      New TEST_NORMAL(0.023546, 0.37508, 0.926693), _
      New TEST_NORMAL(0.023546, 0.37508, -0.926693), _
      New TEST_NORMAL(0.026915, 0.129527, 0.991211), _
      New TEST_NORMAL(0.026915, 0.129527, -0.991211), _
      New TEST_NORMAL(0.030546, 0.829253, -0.558039), _
      New TEST_NORMAL(0.031828, -0.012896, 0.99941), _
      New TEST_NORMAL(0.031828, -0.012896, -0.99941), _
      New TEST_NORMAL(0.038478, 0.994751, 0.09482), _
      New TEST_NORMAL(0.049106, 0.993418, -0.103485), _
      New TEST_NORMAL(0.049529, 0.998773, 0.0), _
      New TEST_NORMAL(0.236414, -0.62426, -0.744586), _
      New TEST_NORMAL(0.238975, -0.634967, 0.734648), _
      New TEST_NORMAL(0.25695, 0.855265, -0.449998), _
      New TEST_NORMAL(0.300127, 0.842617, 0.447124), _
      New TEST_NORMAL(0.345999, 0.937044, -0.047258), _
      New TEST_NORMAL(0.359054, 0.933317, 0.0), _
      New TEST_NORMAL(0.364193, -0.92017, 0.143701), _
      New TEST_NORMAL(0.365904, 0.929316, 0.049861), _
      New TEST_NORMAL(0.368868, -0.921258, -0.123366), _
      New TEST_NORMAL(0.381969, 0.602837, -0.700491), _
      New TEST_NORMAL(0.384187, 0.613094, 0.690302), _
      New TEST_NORMAL(0.401841, -0.91571, 0.0), _
      New TEST_NORMAL(0.484195, 0.440179, -0.756173), _
      New TEST_NORMAL(0.491489, 0.441235, 0.750834), _
      New TEST_NORMAL(0.56508, -0.51822, 0.641975), _
      New TEST_NORMAL(0.596231, 0.127977, 0.792547), _
      New TEST_NORMAL(0.615545, -0.474017, -0.629613), _
      New TEST_NORMAL(0.621304, 0.082635, -0.7792), _
      New TEST_NORMAL(0.631096, 0.767198, 0.114569), _
      New TEST_NORMAL(0.63751, 0.763457, -0.103514), _
      New TEST_NORMAL(0.637667, 0.770312, 0.0), _
      New TEST_NORMAL(0.74557, -0.666427, 0.0), _
      New TEST_NORMAL(0.747538, -0.661333, 0.061849), _
      New TEST_NORMAL(0.769264, -0.632385, -0.09122), _
      New TEST_NORMAL(0.780291, 0.606221, -0.153761), _
      New TEST_NORMAL(0.781334, 0.60203, 0.164551), _
      New TEST_NORMAL(0.785483, 0.618883, 0.0), _
      New TEST_NORMAL(0.975086, 0.132404, 0.177981), _
      New TEST_NORMAL(0.97528, 0.103811, -0.195071), _
      New TEST_NORMAL(0.994502, 0.104718, 0.0) _
    }

    triangle3_shawl = New TEST_TRIANGLE3() { _
      New TEST_TRIANGLE3(52, 13, 9, 35, 13, 12), _
      New TEST_TRIANGLE3(13, 52, 45, 13, 35, 29), _
      New TEST_TRIANGLE3(76, 45, 52, 44, 29, 35), _
      New TEST_TRIANGLE3(45, 76, 79, 29, 44, 54), _
      New TEST_TRIANGLE3(96, 79, 76, 62, 54, 44), _
      New TEST_TRIANGLE3(79, 96, 97, 54, 62, 68), _
      New TEST_TRIANGLE3(137, 97, 96, 82, 68, 62), _
      New TEST_TRIANGLE3(97, 137, 131, 68, 82, 81), _
      New TEST_TRIANGLE3(55, 9, 25, 39, 12, 17), _
      New TEST_TRIANGLE3(9, 55, 52, 12, 39, 35), _
      New TEST_TRIANGLE3(75, 52, 55, 52, 35, 39), _
      New TEST_TRIANGLE3(52, 75, 76, 35, 52, 44), _
      New TEST_TRIANGLE3(94, 76, 75, 59, 44, 52), _
      New TEST_TRIANGLE3(76, 94, 96, 44, 59, 62), _
      New TEST_TRIANGLE3(120, 96, 94, 80, 62, 59), _
      New TEST_TRIANGLE3(96, 120, 137, 62, 80, 82), _
      New TEST_TRIANGLE3(57, 25, 34, 37, 17, 20), _
      New TEST_TRIANGLE3(25, 57, 55, 17, 37, 39), _
      New TEST_TRIANGLE3(72, 55, 57, 45, 39, 37), _
      New TEST_TRIANGLE3(55, 72, 75, 39, 45, 52), _
      New TEST_TRIANGLE3(92, 75, 72, 57, 52, 45), _
      New TEST_TRIANGLE3(75, 92, 94, 52, 57, 59), _
      New TEST_TRIANGLE3(112, 94, 92, 77, 59, 57), _
      New TEST_TRIANGLE3(94, 112, 120, 59, 77, 80), _
      New TEST_TRIANGLE3(60, 34, 43, 33, 20, 27), _
      New TEST_TRIANGLE3(34, 60, 57, 20, 33, 37), _
      New TEST_TRIANGLE3(74, 57, 60, 47, 37, 33), _
      New TEST_TRIANGLE3(57, 74, 72, 37, 47, 45), _
      New TEST_TRIANGLE3(86, 72, 74, 56, 45, 47), _
      New TEST_TRIANGLE3(72, 86, 92, 45, 56, 57), _
      New TEST_TRIANGLE3(105, 92, 86, 70, 57, 56), _
      New TEST_TRIANGLE3(92, 105, 112, 57, 70, 77), _
      New TEST_TRIANGLE3(53, 18, 51, 34, 15, 28), _
      New TEST_TRIANGLE3(18, 53, 12, 15, 34, 14), _
      New TEST_TRIANGLE3(77, 51, 83, 43, 28, 42), _
      New TEST_TRIANGLE3(51, 77, 53, 28, 43, 34), _
      New TEST_TRIANGLE3(95, 83, 102, 63, 42, 67), _
      New TEST_TRIANGLE3(83, 95, 77, 42, 63, 43), _
      New TEST_TRIANGLE3(138, 102, 133, 84, 67, 83), _
      New TEST_TRIANGLE3(102, 138, 95, 67, 84, 63), _
      New TEST_TRIANGLE3(54, 12, 53, 38, 14, 34), _
      New TEST_TRIANGLE3(12, 54, 30, 14, 38, 16), _
      New TEST_TRIANGLE3(71, 53, 77, 53, 34, 43), _
      New TEST_TRIANGLE3(53, 71, 54, 34, 53, 38), _
      New TEST_TRIANGLE3(93, 77, 95, 60, 43, 63), _
      New TEST_TRIANGLE3(77, 93, 71, 43, 60, 53), _
      New TEST_TRIANGLE3(122, 95, 138, 79, 63, 84), _
      New TEST_TRIANGLE3(95, 122, 93, 63, 79, 60), _
      New TEST_TRIANGLE3(56, 30, 54, 36, 16, 38), _
      New TEST_TRIANGLE3(30, 56, 37, 16, 36, 19), _
      New TEST_TRIANGLE3(68, 54, 71, 46, 38, 53), _
      New TEST_TRIANGLE3(54, 68, 56, 38, 46, 36), _
      New TEST_TRIANGLE3(91, 71, 93, 58, 53, 60), _
      New TEST_TRIANGLE3(71, 91, 68, 53, 58, 46), _
      New TEST_TRIANGLE3(114, 93, 122, 76, 60, 79), _
      New TEST_TRIANGLE3(93, 114, 91, 60, 76, 58), _
      New TEST_TRIANGLE3(64, 37, 56, 40, 19, 36), _
      New TEST_TRIANGLE3(37, 64, 42, 19, 40, 26), _
      New TEST_TRIANGLE3(66, 56, 68, 48, 36, 46), _
      New TEST_TRIANGLE3(56, 66, 64, 36, 48, 40), _
      New TEST_TRIANGLE3(90, 68, 91, 61, 46, 58), _
      New TEST_TRIANGLE3(68, 90, 66, 46, 61, 48), _
      New TEST_TRIANGLE3(107, 91, 114, 69, 58, 76), _
      New TEST_TRIANGLE3(91, 107, 90, 58, 69, 61), _
      New TEST_TRIANGLE3(47, 14, 46, 21, 13, 29), _
      New TEST_TRIANGLE3(14, 47, 3, 13, 21, 6), _
      New TEST_TRIANGLE3(78, 46, 80, 55, 29, 54), _
      New TEST_TRIANGLE3(46, 78, 47, 29, 55, 21), _
      New TEST_TRIANGLE3(99, 80, 98, 73, 54, 68), _
      New TEST_TRIANGLE3(80, 99, 78, 54, 73, 55), _
      New TEST_TRIANGLE3(141, 98, 132, 89, 68, 81), _
      New TEST_TRIANGLE3(98, 141, 99, 68, 89, 73), _
      New TEST_TRIANGLE3(48, 3, 47, 18, 6, 21), _
      New TEST_TRIANGLE3(3, 48, 5, 6, 18, 8), _
      New TEST_TRIANGLE3(143, 99, 141, 88, 73, 89), _
      New TEST_TRIANGLE3(99, 143, 100, 73, 88, 78), _
      New TEST_TRIANGLE3(49, 5, 48, 23, 8, 18), _
      New TEST_TRIANGLE3(5, 49, 7, 8, 23, 7), _
      New TEST_TRIANGLE3(145, 100, 143, 90, 78, 88), _
      New TEST_TRIANGLE3(100, 145, 101, 78, 90, 75), _
      New TEST_TRIANGLE3(50, 7, 49, 28, 7, 23), _
      New TEST_TRIANGLE3(7, 50, 16, 7, 28, 15), _
      New TEST_TRIANGLE3(82, 49, 81, 42, 23, 41), _
      New TEST_TRIANGLE3(49, 82, 50, 23, 42, 28), _
      New TEST_TRIANGLE3(103, 81, 101, 67, 41, 75), _
      New TEST_TRIANGLE3(81, 103, 82, 41, 67, 42), _
      New TEST_TRIANGLE3(135, 101, 145, 83, 75, 90), _
      New TEST_TRIANGLE3(101, 135, 103, 75, 83, 67), _
      New TEST_TRIANGLE3(146, 130, 136, 94, 81, 82), _
      New TEST_TRIANGLE3(130, 146, 140, 81, 94, 89), _
      New TEST_TRIANGLE3(125, 136, 119, 92, 82, 80), _
      New TEST_TRIANGLE3(136, 125, 146, 82, 92, 94), _
      New TEST_TRIANGLE3(115, 118, 111, 85, 80, 77), _
      New TEST_TRIANGLE3(118, 115, 124, 80, 85, 92), _
      New TEST_TRIANGLE3(108, 111, 104, 74, 77, 70), _
      New TEST_TRIANGLE3(111, 108, 115, 77, 74, 85), _
      New TEST_TRIANGLE3(147, 140, 146, 96, 89, 94), _
      New TEST_TRIANGLE3(140, 147, 142, 89, 96, 88), _
      New TEST_TRIANGLE3(127, 146, 125, 93, 94, 92), _
      New TEST_TRIANGLE3(146, 127, 147, 94, 93, 96), _
      New TEST_TRIANGLE3(116, 124, 115, 87, 92, 85), _
      New TEST_TRIANGLE3(124, 116, 126, 92, 87, 93), _
      New TEST_TRIANGLE3(109, 115, 108, 72, 85, 74), _
      New TEST_TRIANGLE3(115, 109, 116, 85, 72, 87), _
      New TEST_TRIANGLE3(148, 142, 147, 95, 88, 96), _
      New TEST_TRIANGLE3(142, 148, 144, 88, 95, 90), _
      New TEST_TRIANGLE3(129, 147, 127, 91, 96, 93), _
      New TEST_TRIANGLE3(147, 129, 148, 96, 91, 95), _
      New TEST_TRIANGLE3(117, 126, 116, 86, 93, 87), _
      New TEST_TRIANGLE3(126, 117, 128, 93, 86, 91), _
      New TEST_TRIANGLE3(110, 116, 109, 71, 87, 72), _
      New TEST_TRIANGLE3(116, 110, 117, 87, 71, 86), _
      New TEST_TRIANGLE3(139, 144, 148, 84, 90, 95), _
      New TEST_TRIANGLE3(144, 139, 134, 90, 84, 83), _
      New TEST_TRIANGLE3(123, 148, 129, 79, 95, 91), _
      New TEST_TRIANGLE3(148, 123, 139, 95, 79, 84), _
      New TEST_TRIANGLE3(113, 128, 117, 76, 91, 86), _
      New TEST_TRIANGLE3(128, 113, 121, 91, 76, 79), _
      New TEST_TRIANGLE3(106, 117, 110, 69, 86, 71), _
      New TEST_TRIANGLE3(117, 106, 113, 86, 69, 76), _
      New TEST_TRIANGLE3(84, 104, 85, 64, 70, 56), _
      New TEST_TRIANGLE3(104, 84, 108, 70, 64, 74), _
      New TEST_TRIANGLE3(70, 85, 73, 50, 56, 47), _
      New TEST_TRIANGLE3(85, 70, 84, 56, 50, 64), _
      New TEST_TRIANGLE3(58, 73, 61, 31, 47, 33), _
      New TEST_TRIANGLE3(73, 58, 70, 47, 31, 50), _
      New TEST_TRIANGLE3(38, 61, 44, 25, 33, 27), _
      New TEST_TRIANGLE3(61, 38, 58, 33, 25, 31), _
      New TEST_TRIANGLE3(87, 108, 84, 66, 74, 64), _
      New TEST_TRIANGLE3(108, 87, 109, 74, 66, 72), _
      New TEST_TRIANGLE3(69, 84, 70, 51, 64, 50), _
      New TEST_TRIANGLE3(84, 69, 87, 64, 51, 66), _
      New TEST_TRIANGLE3(62, 70, 58, 30, 50, 31), _
      New TEST_TRIANGLE3(70, 62, 69, 50, 30, 51), _
      New TEST_TRIANGLE3(39, 58, 38, 24, 31, 25), _
      New TEST_TRIANGLE3(58, 39, 62, 31, 24, 30), _
      New TEST_TRIANGLE3(88, 109, 87, 65, 72, 66), _
      New TEST_TRIANGLE3(109, 88, 110, 72, 65, 71), _
      New TEST_TRIANGLE3(67, 87, 69, 49, 66, 51), _
      New TEST_TRIANGLE3(87, 67, 88, 66, 49, 65), _
      New TEST_TRIANGLE3(59, 69, 62, 32, 51, 30), _
      New TEST_TRIANGLE3(69, 59, 67, 51, 32, 49), _
      New TEST_TRIANGLE3(40, 62, 39, 22, 30, 24), _
      New TEST_TRIANGLE3(62, 40, 59, 30, 22, 32), _
      New TEST_TRIANGLE3(89, 110, 88, 61, 71, 65), _
      New TEST_TRIANGLE3(110, 89, 106, 71, 61, 69), _
      New TEST_TRIANGLE3(65, 88, 67, 48, 65, 49), _
      New TEST_TRIANGLE3(88, 65, 89, 65, 48, 61), _
      New TEST_TRIANGLE3(63, 67, 59, 40, 49, 32), _
      New TEST_TRIANGLE3(67, 63, 65, 49, 40, 48), _
      New TEST_TRIANGLE3(41, 59, 40, 26, 32, 22), _
      New TEST_TRIANGLE3(59, 41, 63, 32, 26, 40), _
      New TEST_TRIANGLE3(31, 44, 35, 10, 27, 20), _
      New TEST_TRIANGLE3(44, 31, 38, 27, 10, 25), _
      New TEST_TRIANGLE3(20, 35, 27, 5, 20, 17), _
      New TEST_TRIANGLE3(35, 20, 31, 20, 5, 10), _
      New TEST_TRIANGLE3(0, 26, 10, 1, 17, 12), _
      New TEST_TRIANGLE3(26, 0, 19, 17, 1, 5), _
      New TEST_TRIANGLE3(4, 10, 15, 6, 12, 13), _
      New TEST_TRIANGLE3(10, 4, 0, 12, 6, 1), _
      New TEST_TRIANGLE3(32, 38, 31, 9, 25, 10), _
      New TEST_TRIANGLE3(38, 32, 39, 25, 9, 24), _
      New TEST_TRIANGLE3(22, 31, 20, 3, 10, 5), _
      New TEST_TRIANGLE3(31, 22, 32, 10, 3, 9), _
      New TEST_TRIANGLE3(1, 19, 0, 0, 5, 1), _
      New TEST_TRIANGLE3(19, 1, 21, 5, 0, 3), _
      New TEST_TRIANGLE3(6, 0, 4, 8, 1, 6), _
      New TEST_TRIANGLE3(0, 6, 1, 1, 8, 0), _
      New TEST_TRIANGLE3(33, 39, 32, 11, 24, 9), _
      New TEST_TRIANGLE3(39, 33, 40, 24, 11, 22), _
      New TEST_TRIANGLE3(24, 32, 22, 4, 9, 3), _
      New TEST_TRIANGLE3(32, 24, 33, 9, 4, 11), _
      New TEST_TRIANGLE3(2, 21, 1, 2, 3, 0), _
      New TEST_TRIANGLE3(21, 2, 23, 3, 2, 4), _
      New TEST_TRIANGLE3(8, 1, 6, 7, 0, 8), _
      New TEST_TRIANGLE3(1, 8, 2, 0, 7, 2), _
      New TEST_TRIANGLE3(36, 40, 33, 19, 22, 11), _
      New TEST_TRIANGLE3(40, 36, 41, 22, 19, 26), _
      New TEST_TRIANGLE3(29, 33, 24, 16, 11, 4), _
      New TEST_TRIANGLE3(33, 29, 36, 11, 16, 19), _
      New TEST_TRIANGLE3(11, 23, 2, 14, 4, 2), _
      New TEST_TRIANGLE3(23, 11, 28, 4, 14, 16), _
      New TEST_TRIANGLE3(17, 2, 8, 15, 2, 7), _
      New TEST_TRIANGLE3(2, 17, 11, 2, 15, 14) _
    }

    data4 = New TEST_3D_DATA4() { _
      New TEST_3D_DATA4("body", _
        matrix_body, _
        306, 208, 392, _
        xyz_uv_body, _
        normal_body, _
        triangle3_body, _
        1, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChain.bmp"), _
      New TEST_3D_DATA4("head", _
        matrix_head, _
        34, 34, 48, _
        xyz_uv_head, _
        normal_head, _
        triangle3_head, _
        0, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        ""), _
      New TEST_3D_DATA4("hood", _
        matrix_hood, _
        200, 131, 244, _
        xyz_uv_hood, _
        normal_hood, _
        triangle3_hood, _
        1, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChain.bmp"), _
      New TEST_3D_DATA4("Rhand", _
        matrix_Rhand, _
        48, 48, 90, _
        xyz_uv_Rhand, _
        normal_Rhand, _
        triangle3_Rhand, _
        0, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        ""), _
      New TEST_3D_DATA4("Lhand", _
        matrix_Lhand, _
        48, 48, 90, _
        xyz_uv_Lhand, _
        normal_Lhand, _
        triangle3_Lhand, _
        0, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        ""), _
      New TEST_3D_DATA4("Llower_arm", _
        matrix_Llower_arm, _
        66, 34, 64, _
        xyz_uv_Llower_arm, _
        normal_Llower_arm, _
        triangle3_Llower_arm, _
        1, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChain.bmp"), _
      New TEST_3D_DATA4("Rlower_arm", _
        matrix_Rlower_arm, _
        66, 34, 64, _
        xyz_uv_Rlower_arm, _
        normal_Rlower_arm, _
        triangle3_Rlower_arm, _
        1, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChain.bmp"), _
      New TEST_3D_DATA4("rope_belt", _
        matrix_rope_belt, _
        120, 58, 92, _
        xyz_uv_rope_belt, _
        normal_rope_belt, _
        triangle3_rope_belt, _
        1, 252, _
        New TEST_RGB(0.584314, 0.584314, 0.584314), New TEST_RGB(0.584314, 0.584314, 0.584314), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChrome.bmp"), _
      New TEST_3D_DATA4("Lupper_arm", _
        matrix_Lupper_arm, _
        57, 33, 56, _
        xyz_uv_Lupper_arm, _
        normal_Lupper_arm, _
        triangle3_Lupper_arm, _
        1, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChain.bmp"), _
      New TEST_3D_DATA4("Rupper_arm", _
        matrix_Rupper_arm, _
        57, 33, 56, _
        xyz_uv_Rupper_arm, _
        normal_Rupper_arm, _
        triangle3_Rupper_arm, _
        1, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChain.bmp"), _
      New TEST_3D_DATA4("shawl", _
        matrix_shawl, _
        149, 97, 184, _
        xyz_uv_shawl, _
        normal_shawl, _
        triangle3_shawl, _
        1, 252, _
        New TEST_RGB(0.588235, 0.588235, 0.588235), New TEST_RGB(0.588235, 0.588235, 0.588235), _
        New TEST_RGB(0.898039, 0.898039, 0.898039), New TEST_RGB(0.0, 0.0, 0.0), _
        "D:\\Obj0\\BlueChain.bmp") _
      }
  End Sub

End Class

